// * Copyright (c) 2020 Storm

//#include "lvgl/lvgl.h"
#include "../lv_misc/lv_font.h"
//#include "../../../../../common/memory_map.h"

#if USE_MABOLT_12 != 0	/*Can be enabled in lv_conf.h*/

/***********************************************************************************
 * MontserratAlternates-Bold.ttf 12 px Font in U+0020 ( ) .. U+007f ()  range with all bpp
***********************************************************************************/

/*Store the image of the letters (glyph)*/
static const uint8_t mabolt_12_glyph_bitmap[] = 
{
#if USE_MABOLT_12 == 1
  /*Unicode: U+0020 ( ) , Width: 4 */
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 


  /*Unicode: U+0021 (!) , Width: 3 */
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x40,  //.%. 
  0x40,  //.%. 
  0x40,  //.%. 
  0x40,  //.%. 
  0x00,  //... 
  0x40,  //.%. 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 


  /*Unicode: U+0022 (") , Width: 4 */
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x60,  //.%%. 
  0x60,  //.%%. 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 


  /*Unicode: U+0023 (#) , Width: 7 */
  0x00,  //....... 
  0x00,  //....... 
  0x00,  //....... 
  0x2c,  //..%.%%. 
  0x7c,  //.%%%%%. 
  0x68,  //.%%.%.. 
  0x7c,  //.%%%%%. 
  0x78,  //.%%%%.. 
  0x58,  //.%.%%.. 
  0x00,  //....... 
  0x00,  //....... 
  0x00,  //....... 


  /*Unicode: U+0024 ($) , Width: 6 */
  0x00,  //...... 
  0x00,  //...... 
  0x30,  //..%%.. 
  0x78,  //.%%%%. 
  0x70,  //.%%%.. 
  0x78,  //.%%%%. 
  0x3c,  //..%%%% 
  0x5c,  //.%.%%% 
  0x78,  //.%%%%. 
  0x10,  //...%.. 
  0x00,  //...... 
  0x00,  //...... 


  /*Unicode: U+0025 (%) , Width: 6 */
  0x00,  //...... 
  0x00,  //...... 
  0x00,  //...... 
  0xcc,  //%%..%% 
  0xd8,  //%%.%%. 
  0x10,  //...%.. 
  0x2c,  //..%.%% 
  0x64,  //.%%..% 
  0xcc,  //%%..%% 
  0x00,  //...... 
  0x00,  //...... 
  0x00,  //...... 


  /*Unicode: U+0026 (&) , Width: 7 */
  0x00,  //....... 
  0x00,  //....... 
  0x00,  //....... 
  0x38,  //..%%%.. 
  0x28,  //..%.%.. 
  0x38,  //..%%%.. 
  0x7c,  //.%%%%%. 
  0x4c,  //.%..%%. 
  0x7c,  //.%%%%%. 
  0x00,  //....... 
  0x00,  //....... 
  0x00,  //....... 


  /*Unicode: U+0027 (') , Width: 3 */
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x40,  //.%. 
  0x40,  //.%. 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 


  /*Unicode: U+0028 (() , Width: 4 */
  0x00,  //.... 
  0x00,  //.... 
  0x20,  //..%. 
  0x60,  //.%%. 
  0x40,  //.%.. 
  0x40,  //.%.. 
  0x40,  //.%.. 
  0x40,  //.%.. 
  0x60,  //.%%. 
  0x20,  //..%. 
  0x00,  //.... 
  0x00,  //.... 


  /*Unicode: U+0029 ()) , Width: 4 */
  0x00,  //.... 
  0x00,  //.... 
  0x40,  //.%.. 
  0x60,  //.%%. 
  0x20,  //..%. 
  0x20,  //..%. 
  0x20,  //..%. 
  0x20,  //..%. 
  0x60,  //.%%. 
  0x40,  //.%.. 
  0x00,  //.... 
  0x00,  //.... 


  /*Unicode: U+002a (*) , Width: 4 */
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x60,  //.%%. 
  0x60,  //.%%. 
  0x60,  //.%%. 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 


  /*Unicode: U+002b (+) , Width: 4 */
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x20,  //..%. 
  0xf0,  //%%%% 
  0x20,  //..%. 
  0x20,  //..%. 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 


  /*Unicode: U+002c (,) , Width: 3 */
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x40,  //.%. 
  0x40,  //.%. 
  0x00,  //... 
  0x00,  //... 


  /*Unicode: U+002d (-) , Width: 3 */
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0xe0,  //%%% 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 


  /*Unicode: U+002e (.) , Width: 3 */
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x40,  //.%. 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 


  /*Unicode: U+002f (/) , Width: 6 */
  0x00,  //...... 
  0x00,  //...... 
  0x08,  //....%. 
  0x10,  //...%.. 
  0x10,  //...%.. 
  0x30,  //..%%.. 
  0x20,  //..%... 
  0x60,  //.%%... 
  0x40,  //.%.... 
  0xc0,  //%%.... 
  0x00,  //...... 
  0x00,  //...... 


  /*Unicode: U+0030 (0) , Width: 7 */
  0x00,  //....... 
  0x00,  //....... 
  0x00,  //....... 
  0x38,  //..%%%.. 
  0x6c,  //.%%.%%. 
  0x44,  //.%...%. 
  0x44,  //.%...%. 
  0x6c,  //.%%.%%. 
  0x38,  //..%%%.. 
  0x00,  //....... 
  0x00,  //....... 
  0x00,  //....... 


  /*Unicode: U+0031 (1) , Width: 4 */
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x60,  //.%%. 
  0x20,  //..%. 
  0x20,  //..%. 
  0x20,  //..%. 
  0x20,  //..%. 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 


  /*Unicode: U+0032 (2) , Width: 5 */
  0x00,  //..... 
  0x00,  //..... 
  0x00,  //..... 
  0x30,  //..%%. 
  0x48,  //.%..% 
  0x18,  //...%% 
  0x30,  //..%%. 
  0x20,  //..%.. 
  0x78,  //.%%%% 
  0x00,  //..... 
  0x00,  //..... 
  0x00,  //..... 


  /*Unicode: U+0033 (3) , Width: 6 */
  0x00,  //...... 
  0x00,  //...... 
  0x00,  //...... 
  0x00,  //...... 
  0x78,  //.%%%%. 
  0x30,  //..%%.. 
  0x30,  //..%%.. 
  0x18,  //...%%. 
  0x08,  //....%. 
  0x70,  //.%%%.. 
  0x00,  //...... 
  0x00,  //...... 


  /*Unicode: U+0034 (4) , Width: 5 */
  0x00,  //..... 
  0x00,  //..... 
  0x00,  //..... 
  0x00,  //..... 
  0x20,  //..%.. 
  0x60,  //.%%.. 
  0xd0,  //%%.%. 
  0xf8,  //%%%%% 
  0x10,  //...%. 
  0x10,  //...%. 
  0x00,  //..... 
  0x00,  //..... 


  /*Unicode: U+0035 (5) , Width: 6 */
  0x00,  //...... 
  0x00,  //...... 
  0x00,  //...... 
  0x00,  //...... 
  0x78,  //.%%%%. 
  0x40,  //.%.... 
  0x70,  //.%%%.. 
  0x18,  //...%%. 
  0x08,  //....%. 
  0x70,  //.%%%.. 
  0x00,  //...... 
  0x00,  //...... 


  /*Unicode: U+0036 (6) , Width: 6 */
  0x00,  //...... 
  0x00,  //...... 
  0x00,  //...... 
  0x30,  //..%%.. 
  0x40,  //.%.... 
  0x70,  //.%%%.. 
  0x58,  //.%.%%. 
  0x58,  //.%.%%. 
  0x30,  //..%%.. 
  0x00,  //...... 
  0x00,  //...... 
  0x00,  //...... 


  /*Unicode: U+0037 (7) , Width: 5 */
  0x00,  //..... 
  0x00,  //..... 
  0x00,  //..... 
  0x00,  //..... 
  0xf0,  //%%%%. 
  0x90,  //%..%. 
  0x30,  //..%%. 
  0x20,  //..%.. 
  0x60,  //.%%.. 
  0x40,  //.%... 
  0x00,  //..... 
  0x00,  //..... 


  /*Unicode: U+0038 (8) , Width: 6 */
  0x00,  //...... 
  0x00,  //...... 
  0x00,  //...... 
  0x78,  //.%%%%. 
  0x58,  //.%.%%. 
  0x78,  //.%%%%. 
  0x58,  //.%.%%. 
  0x58,  //.%.%%. 
  0x70,  //.%%%.. 
  0x00,  //...... 
  0x00,  //...... 
  0x00,  //...... 


  /*Unicode: U+0039 (9) , Width: 6 */
  0x00,  //...... 
  0x00,  //...... 
  0x00,  //...... 
  0x00,  //...... 
  0x70,  //.%%%.. 
  0x58,  //.%.%%. 
  0x48,  //.%..%. 
  0x78,  //.%%%%. 
  0x08,  //....%. 
  0x70,  //.%%%.. 
  0x00,  //...... 
  0x00,  //...... 


  /*Unicode: U+003a (:) , Width: 3 */
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x40,  //.%. 
  0x00,  //... 
  0x00,  //... 
  0x40,  //.%. 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 


  /*Unicode: U+003b (;) , Width: 3 */
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x40,  //.%. 
  0x00,  //... 
  0x00,  //... 
  0x40,  //.%. 
  0x40,  //.%. 
  0x00,  //... 
  0x00,  //... 


  /*Unicode: U+003c (<) , Width: 5 */
  0x00,  //..... 
  0x00,  //..... 
  0x00,  //..... 
  0x10,  //...%. 
  0x60,  //.%%.. 
  0xc0,  //%%... 
  0x70,  //.%%%. 
  0x10,  //...%. 
  0x00,  //..... 
  0x00,  //..... 
  0x00,  //..... 
  0x00,  //..... 


  /*Unicode: U+003d (=) , Width: 4 */
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0xf0,  //%%%% 
  0x00,  //.... 
  0xf0,  //%%%% 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 


  /*Unicode: U+003e (>) , Width: 5 */
  0x00,  //..... 
  0x00,  //..... 
  0x00,  //..... 
  0xc0,  //%%... 
  0x70,  //.%%%. 
  0x30,  //..%%. 
  0x60,  //.%%.. 
  0x80,  //%.... 
  0x00,  //..... 
  0x00,  //..... 
  0x00,  //..... 
  0x00,  //..... 


  /*Unicode: U+003f (?) , Width: 5 */
  0x00,  //..... 
  0x00,  //..... 
  0x00,  //..... 
  0x70,  //.%%%. 
  0x50,  //.%.%. 
  0x30,  //..%%. 
  0x20,  //..%.. 
  0x20,  //..%.. 
  0x20,  //..%.. 
  0x00,  //..... 
  0x00,  //..... 
  0x00,  //..... 


  /*Unicode: U+0040 (@) , Width: 9 */
  0x00, 0x00,  //......... 
  0x00, 0x00,  //......... 
  0x00, 0x00,  //......... 
  0x1c, 0x00,  //...%%%... 
  0x7e, 0x00,  //.%%%%%%.. 
  0x6f, 0x00,  //.%%.%%%%. 
  0x65, 0x00,  //.%%..%.%. 
  0x7d, 0x00,  //.%%%%%.%. 
  0x7e, 0x00,  //.%%%%%%.. 
  0x3c, 0x00,  //..%%%%... 
  0x00, 0x00,  //......... 
  0x00, 0x00,  //......... 


  /*Unicode: U+0041 (A) , Width: 7 */
  0x00,  //....... 
  0x00,  //....... 
  0x00,  //....... 
  0x38,  //..%%%.. 
  0x6c,  //.%%.%%. 
  0x44,  //.%...%. 
  0x7c,  //.%%%%%. 
  0x44,  //.%...%. 
  0x44,  //.%...%. 
  0x00,  //....... 
  0x00,  //....... 
  0x00,  //....... 


  /*Unicode: U+0042 (B) , Width: 7 */
  0x00,  //....... 
  0x00,  //....... 
  0x00,  //....... 
  0x78,  //.%%%%.. 
  0x58,  //.%.%%.. 
  0x78,  //.%%%%.. 
  0x4c,  //.%..%%. 
  0x4c,  //.%..%%. 
  0x78,  //.%%%%.. 
  0x00,  //....... 
  0x00,  //....... 
  0x00,  //....... 


  /*Unicode: U+0043 (C) , Width: 7 */
  0x00,  //....... 
  0x00,  //....... 
  0x00,  //....... 
  0x3c,  //..%%%%. 
  0x64,  //.%%..%. 
  0x40,  //.%..... 
  0x40,  //.%..... 
  0x64,  //.%%..%. 
  0x3c,  //..%%%%. 
  0x00,  //....... 
  0x00,  //....... 
  0x00,  //....... 


  /*Unicode: U+0044 (D) , Width: 7 */
  0x00,  //....... 
  0x00,  //....... 
  0x00,  //....... 
  0x78,  //.%%%%.. 
  0x4c,  //.%..%%. 
  0x44,  //.%...%. 
  0x44,  //.%...%. 
  0x4c,  //.%..%%. 
  0x78,  //.%%%%.. 
  0x00,  //....... 
  0x00,  //....... 
  0x00,  //....... 


  /*Unicode: U+0045 (E) , Width: 5 */
  0x00,  //..... 
  0x00,  //..... 
  0x00,  //..... 
  0x70,  //.%%%. 
  0x40,  //.%... 
  0x70,  //.%%%. 
  0x40,  //.%... 
  0x40,  //.%... 
  0x78,  //.%%%% 
  0x00,  //..... 
  0x00,  //..... 
  0x00,  //..... 


  /*Unicode: U+0046 (F) , Width: 6 */
  0x00,  //...... 
  0x00,  //...... 
  0x00,  //...... 
  0x38,  //..%%%. 
  0x60,  //.%%... 
  0x40,  //.%.... 
  0x70,  //.%%%.. 
  0x40,  //.%.... 
  0x40,  //.%.... 
  0x00,  //...... 
  0x00,  //...... 
  0x00,  //...... 


  /*Unicode: U+0047 (G) , Width: 8 */
  0x00,  //........ 
  0x00,  //........ 
  0x00,  //........ 
  0x3c,  //..%%%%.. 
  0x64,  //.%%..%.. 
  0x40,  //.%...... 
  0x42,  //.%....%. 
  0x66,  //.%%..%%. 
  0x3e,  //..%%%%%. 
  0x00,  //........ 
  0x00,  //........ 
  0x00,  //........ 


  /*Unicode: U+0048 (H) , Width: 7 */
  0x00,  //....... 
  0x00,  //....... 
  0x00,  //....... 
  0x44,  //.%...%. 
  0x44,  //.%...%. 
  0x7c,  //.%%%%%. 
  0x44,  //.%...%. 
  0x44,  //.%...%. 
  0x44,  //.%...%. 
  0x00,  //....... 
  0x00,  //....... 
  0x00,  //....... 


  /*Unicode: U+0049 (I) , Width: 4 */
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0xf0,  //%%%% 
  0x40,  //.%.. 
  0x40,  //.%.. 
  0x40,  //.%.. 
  0x40,  //.%.. 
  0xf0,  //%%%% 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 


  /*Unicode: U+004a (J) , Width: 5 */
  0x00,  //..... 
  0x00,  //..... 
  0x00,  //..... 
  0x70,  //.%%%. 
  0x10,  //...%. 
  0x10,  //...%. 
  0x10,  //...%. 
  0x10,  //...%. 
  0x10,  //...%. 
  0xe0,  //%%%.. 
  0x00,  //..... 
  0x00,  //..... 


  /*Unicode: U+004b (K) , Width: 7 */
  0x00,  //....... 
  0x00,  //....... 
  0x00,  //....... 
  0x4c,  //.%..%%. 
  0x58,  //.%.%%.. 
  0x70,  //.%%%... 
  0x70,  //.%%%... 
  0x58,  //.%.%%.. 
  0x4c,  //.%..%%. 
  0x00,  //....... 
  0x00,  //....... 
  0x00,  //....... 


  /*Unicode: U+004c (L) , Width: 5 */
  0x00,  //..... 
  0x00,  //..... 
  0x00,  //..... 
  0x40,  //.%... 
  0x40,  //.%... 
  0x40,  //.%... 
  0x40,  //.%... 
  0x40,  //.%... 
  0x78,  //.%%%% 
  0x00,  //..... 
  0x00,  //..... 
  0x00,  //..... 


  /*Unicode: U+004d (M) , Width: 9 */
  0x00, 0x00,  //......... 
  0x00, 0x00,  //......... 
  0x00, 0x00,  //......... 
  0x76, 0x00,  //.%%%.%%.. 
  0x5b, 0x00,  //.%.%%.%%. 
  0x49, 0x00,  //.%..%..%. 
  0x49, 0x00,  //.%..%..%. 
  0x49, 0x00,  //.%..%..%. 
  0x49, 0x00,  //.%..%..%. 
  0x00, 0x00,  //......... 
  0x00, 0x00,  //......... 
  0x00, 0x00,  //......... 


  /*Unicode: U+004e (N) , Width: 7 */
  0x00,  //....... 
  0x00,  //....... 
  0x00,  //....... 
  0x78,  //.%%%%.. 
  0x6c,  //.%%.%%. 
  0x44,  //.%...%. 
  0x44,  //.%...%. 
  0x44,  //.%...%. 
  0x44,  //.%...%. 
  0x00,  //....... 
  0x00,  //....... 
  0x00,  //....... 


  /*Unicode: U+004f (O) , Width: 8 */
  0x00,  //........ 
  0x00,  //........ 
  0x00,  //........ 
  0x3c,  //..%%%%.. 
  0x66,  //.%%..%%. 
  0x42,  //.%....%. 
  0x42,  //.%....%. 
  0x66,  //.%%..%%. 
  0x3c,  //..%%%%.. 
  0x00,  //........ 
  0x00,  //........ 
  0x00,  //........ 


  /*Unicode: U+0050 (P) , Width: 7 */
  0x00,  //....... 
  0x00,  //....... 
  0x00,  //....... 
  0x78,  //.%%%%.. 
  0x4c,  //.%..%%. 
  0x44,  //.%...%. 
  0x78,  //.%%%%.. 
  0x40,  //.%..... 
  0x40,  //.%..... 
  0x00,  //....... 
  0x00,  //....... 
  0x00,  //....... 


  /*Unicode: U+0051 (Q) , Width: 9 */
  0x00, 0x00,  //......... 
  0x00, 0x00,  //......... 
  0x00, 0x00,  //......... 
  0x3c, 0x00,  //..%%%%... 
  0x63, 0x00,  //.%%...%%. 
  0x41, 0x00,  //.%.....%. 
  0x41, 0x00,  //.%.....%. 
  0x7b, 0x00,  //.%%%%.%%. 
  0x3e, 0x00,  //..%%%%%.. 
  0x08, 0x00,  //....%.... 
  0x00, 0x00,  //......... 
  0x00, 0x00,  //......... 


  /*Unicode: U+0052 (R) , Width: 7 */
  0x00,  //....... 
  0x00,  //....... 
  0x00,  //....... 
  0x78,  //.%%%%.. 
  0x4c,  //.%..%%. 
  0x44,  //.%...%. 
  0x7c,  //.%%%%%. 
  0x58,  //.%.%%.. 
  0x4c,  //.%..%%. 
  0x00,  //....... 
  0x00,  //....... 
  0x00,  //....... 


  /*Unicode: U+0053 (S) , Width: 6 */
  0x00,  //...... 
  0x00,  //...... 
  0x00,  //...... 
  0x38,  //..%%%. 
  0x68,  //.%%.%. 
  0x70,  //.%%%.. 
  0x18,  //...%%. 
  0x48,  //.%..%. 
  0x38,  //..%%%. 
  0x00,  //...... 
  0x00,  //...... 
  0x00,  //...... 


  /*Unicode: U+0054 (T) , Width: 7 */
  0x00,  //....... 
  0x00,  //....... 
  0x00,  //....... 
  0x7c,  //.%%%%%. 
  0x74,  //.%%%.%. 
  0x10,  //...%... 
  0x10,  //...%... 
  0x10,  //...%... 
  0x10,  //...%... 
  0x00,  //....... 
  0x00,  //....... 
  0x00,  //....... 


  /*Unicode: U+0055 (U) , Width: 7 */
  0x00,  //....... 
  0x00,  //....... 
  0x00,  //....... 
  0x44,  //.%...%. 
  0x44,  //.%...%. 
  0x44,  //.%...%. 
  0x44,  //.%...%. 
  0x6c,  //.%%.%%. 
  0x3c,  //..%%%%. 
  0x00,  //....... 
  0x00,  //....... 
  0x00,  //....... 


  /*Unicode: U+0056 (V) , Width: 7 */
  0x00,  //....... 
  0x00,  //....... 
  0x00,  //....... 
  0xcc,  //%%..%%. 
  0x4c,  //.%..%%. 
  0x68,  //.%%.%.. 
  0x78,  //.%%%%.. 
  0x30,  //..%%... 
  0x30,  //..%%... 
  0x00,  //....... 
  0x00,  //....... 
  0x00,  //....... 


  /*Unicode: U+0057 (W) , Width: 9 */
  0x00, 0x00,  //......... 
  0x00, 0x00,  //......... 
  0x00, 0x00,  //......... 
  0x49, 0x00,  //.%..%..%. 
  0x49, 0x00,  //.%..%..%. 
  0x49, 0x00,  //.%..%..%. 
  0x49, 0x00,  //.%..%..%. 
  0x7f, 0x00,  //.%%%%%%%. 
  0x76, 0x00,  //.%%%.%%.. 
  0x00, 0x00,  //......... 
  0x00, 0x00,  //......... 
  0x00, 0x00,  //......... 


  /*Unicode: U+0058 (X) , Width: 7 */
  0x00,  //....... 
  0x00,  //....... 
  0x00,  //....... 
  0x4c,  //.%..%%. 
  0x78,  //.%%%%.. 
  0x30,  //..%%... 
  0x30,  //..%%... 
  0x78,  //.%%%%.. 
  0xcc,  //%%..%%. 
  0x00,  //....... 
  0x00,  //....... 
  0x00,  //....... 


  /*Unicode: U+0059 (Y) , Width: 7 */
  0x00,  //....... 
  0x00,  //....... 
  0x00,  //....... 
  0x44,  //.%...%. 
  0x44,  //.%...%. 
  0x44,  //.%...%. 
  0x4c,  //.%..%%. 
  0x7c,  //.%%%%%. 
  0x4c,  //.%..%%. 
  0x78,  //.%%%%.. 
  0x00,  //....... 
  0x00,  //....... 


  /*Unicode: U+005a (Z) , Width: 5 */
  0x00,  //..... 
  0x00,  //..... 
  0x00,  //..... 
  0xf8,  //%%%%% 
  0x30,  //..%%. 
  0xf8,  //%%%%% 
  0x60,  //.%%.. 
  0xc0,  //%%... 
  0xf8,  //%%%%% 
  0x00,  //..... 
  0x00,  //..... 
  0x00,  //..... 


  /*Unicode: U+005b ([) , Width: 4 */
  0x00,  //.... 
  0x00,  //.... 
  0x60,  //.%%. 
  0x40,  //.%.. 
  0x40,  //.%.. 
  0x40,  //.%.. 
  0x40,  //.%.. 
  0x40,  //.%.. 
  0x40,  //.%.. 
  0x60,  //.%%. 
  0x00,  //.... 
  0x00,  //.... 


  /*Unicode: U+005c (\) , Width: 5 */
  0x00,  //..... 
  0x00,  //..... 
  0xc0,  //%%... 
  0x40,  //.%... 
  0x60,  //.%%.. 
  0x20,  //..%.. 
  0x30,  //..%%. 
  0x10,  //...%. 
  0x18,  //...%% 
  0x00,  //..... 
  0x00,  //..... 
  0x00,  //..... 


  /*Unicode: U+005d (]) , Width: 4 */
  0x00,  //.... 
  0x00,  //.... 
  0x60,  //.%%. 
  0x20,  //..%. 
  0x20,  //..%. 
  0x20,  //..%. 
  0x20,  //..%. 
  0x20,  //..%. 
  0x20,  //..%. 
  0x60,  //.%%. 
  0x00,  //.... 
  0x00,  //.... 


  /*Unicode: U+005e (^) , Width: 4 */
  0x00,  //.... 
  0x60,  //.%%. 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 


  /*Unicode: U+005f (_) , Width: 6 */
  0x00,  //...... 
  0x00,  //...... 
  0x00,  //...... 
  0x00,  //...... 
  0x00,  //...... 
  0x00,  //...... 
  0x00,  //...... 
  0x00,  //...... 
  0x00,  //...... 
  0x7c,  //.%%%%% 
  0x00,  //...... 
  0x00,  //...... 


  /*Unicode: U+0060 (`) , Width: 3 */
  0x00,  //... 
  0x60,  //.%% 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 


  /*Unicode: U+0061 (a) , Width: 7 */
  0x00,  //....... 
  0x00,  //....... 
  0x00,  //....... 
  0x00,  //....... 
  0x3c,  //..%%%%. 
  0x6c,  //.%%.%%. 
  0x44,  //.%...%. 
  0x6c,  //.%%.%%. 
  0x3c,  //..%%%%. 
  0x00,  //....... 
  0x00,  //....... 
  0x00,  //....... 


  /*Unicode: U+0062 (b) , Width: 7 */
  0x00,  //....... 
  0x00,  //....... 
  0x40,  //.%..... 
  0x40,  //.%..... 
  0x78,  //.%%%%.. 
  0x6c,  //.%%.%%. 
  0x44,  //.%...%. 
  0x6c,  //.%%.%%. 
  0x78,  //.%%%%.. 
  0x00,  //....... 
  0x00,  //....... 
  0x00,  //....... 


  /*Unicode: U+0063 (c) , Width: 6 */
  0x00,  //...... 
  0x00,  //...... 
  0x00,  //...... 
  0x00,  //...... 
  0x38,  //..%%%. 
  0x68,  //.%%.%. 
  0x40,  //.%.... 
  0x68,  //.%%.%. 
  0x38,  //..%%%. 
  0x00,  //...... 
  0x00,  //...... 
  0x00,  //...... 


  /*Unicode: U+0064 (d) , Width: 7 */
  0x00,  //....... 
  0x00,  //....... 
  0x04,  //.....%. 
  0x04,  //.....%. 
  0x3c,  //..%%%%. 
  0x6c,  //.%%.%%. 
  0x44,  //.%...%. 
  0x6c,  //.%%.%%. 
  0x3c,  //..%%%%. 
  0x00,  //....... 
  0x00,  //....... 
  0x00,  //....... 


  /*Unicode: U+0065 (e) , Width: 6 */
  0x00,  //...... 
  0x00,  //...... 
  0x00,  //...... 
  0x00,  //...... 
  0x38,  //..%%%. 
  0x6c,  //.%%.%% 
  0x78,  //.%%%%. 
  0x68,  //.%%.%. 
  0x38,  //..%%%. 
  0x00,  //...... 
  0x00,  //...... 
  0x00,  //...... 


  /*Unicode: U+0066 (f) , Width: 4 */
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x70,  //.%%% 
  0x40,  //.%.. 
  0x60,  //.%%. 
  0x40,  //.%.. 
  0x40,  //.%.. 
  0x40,  //.%.. 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 


  /*Unicode: U+0067 (g) , Width: 6 */
  0x00,  //...... 
  0x00,  //...... 
  0x00,  //...... 
  0x00,  //...... 
  0x38,  //..%%%. 
  0x58,  //.%.%%. 
  0x48,  //.%..%. 
  0x58,  //.%.%%. 
  0x38,  //..%%%. 
  0x58,  //.%.%%. 
  0x30,  //..%%.. 
  0x00,  //...... 


  /*Unicode: U+0068 (h) , Width: 6 */
  0x00,  //...... 
  0x00,  //...... 
  0x40,  //.%.... 
  0x40,  //.%.... 
  0x70,  //.%%%.. 
  0x58,  //.%.%%. 
  0x48,  //.%..%. 
  0x48,  //.%..%. 
  0x48,  //.%..%. 
  0x00,  //...... 
  0x00,  //...... 
  0x00,  //...... 


  /*Unicode: U+0069 (i) , Width: 3 */
  0x00,  //... 
  0x00,  //... 
  0x40,  //.%. 
  0x00,  //... 
  0x40,  //.%. 
  0x40,  //.%. 
  0x40,  //.%. 
  0x40,  //.%. 
  0x40,  //.%. 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 


  /*Unicode: U+006a (j) , Width: 3 */
  0x00,  //... 
  0x00,  //... 
  0x40,  //.%. 
  0x00,  //... 
  0x40,  //.%. 
  0x40,  //.%. 
  0x40,  //.%. 
  0x40,  //.%. 
  0x40,  //.%. 
  0xc0,  //%%. 
  0xc0,  //%%. 
  0x00,  //... 


  /*Unicode: U+006b (k) , Width: 6 */
  0x00,  //...... 
  0x00,  //...... 
  0x40,  //.%.... 
  0x40,  //.%.... 
  0x58,  //.%.%%. 
  0x70,  //.%%%.. 
  0x70,  //.%%%.. 
  0x50,  //.%.%.. 
  0x58,  //.%.%%. 
  0x00,  //...... 
  0x00,  //...... 
  0x00,  //...... 


  /*Unicode: U+006c (l) , Width: 4 */
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x40,  //.%.. 
  0x40,  //.%.. 
  0x40,  //.%.. 
  0x40,  //.%.. 
  0x40,  //.%.. 
  0x60,  //.%%. 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 


  /*Unicode: U+006d (m) , Width: 9 */
  0x00, 0x00,  //......... 
  0x00, 0x00,  //......... 
  0x00, 0x00,  //......... 
  0x00, 0x00,  //......... 
  0x76, 0x00,  //.%%%.%%.. 
  0x5b, 0x00,  //.%.%%.%%. 
  0x49, 0x00,  //.%..%..%. 
  0x49, 0x00,  //.%..%..%. 
  0x49, 0x00,  //.%..%..%. 
  0x00, 0x00,  //......... 
  0x00, 0x00,  //......... 
  0x00, 0x00,  //......... 


  /*Unicode: U+006e (n) , Width: 6 */
  0x00,  //...... 
  0x00,  //...... 
  0x00,  //...... 
  0x00,  //...... 
  0x70,  //.%%%.. 
  0x58,  //.%.%%. 
  0x48,  //.%..%. 
  0x48,  //.%..%. 
  0x48,  //.%..%. 
  0x00,  //...... 
  0x00,  //...... 
  0x00,  //...... 


  /*Unicode: U+006f (o) , Width: 7 */
  0x00,  //....... 
  0x00,  //....... 
  0x00,  //....... 
  0x00,  //....... 
  0x38,  //..%%%.. 
  0x6c,  //.%%.%%. 
  0x44,  //.%...%. 
  0x6c,  //.%%.%%. 
  0x38,  //..%%%.. 
  0x00,  //....... 
  0x00,  //....... 
  0x00,  //....... 


  /*Unicode: U+0070 (p) , Width: 7 */
  0x00,  //....... 
  0x00,  //....... 
  0x00,  //....... 
  0x00,  //....... 
  0x78,  //.%%%%.. 
  0x6c,  //.%%.%%. 
  0x44,  //.%...%. 
  0x6c,  //.%%.%%. 
  0x78,  //.%%%%.. 
  0x40,  //.%..... 
  0x40,  //.%..... 
  0x00,  //....... 


  /*Unicode: U+0071 (q) , Width: 7 */
  0x00,  //....... 
  0x00,  //....... 
  0x00,  //....... 
  0x00,  //....... 
  0x3c,  //..%%%%. 
  0x6c,  //.%%.%%. 
  0x44,  //.%...%. 
  0x6c,  //.%%.%%. 
  0x3c,  //..%%%%. 
  0x04,  //.....%. 
  0x04,  //.....%. 
  0x00,  //....... 


  /*Unicode: U+0072 (r) , Width: 4 */
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x70,  //.%%% 
  0x60,  //.%%. 
  0x40,  //.%.. 
  0x40,  //.%.. 
  0x40,  //.%.. 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 


  /*Unicode: U+0073 (s) , Width: 5 */
  0x00,  //..... 
  0x00,  //..... 
  0x00,  //..... 
  0x00,  //..... 
  0x70,  //.%%%. 
  0x40,  //.%... 
  0x30,  //..%%. 
  0x10,  //...%. 
  0x70,  //.%%%. 
  0x00,  //..... 
  0x00,  //..... 
  0x00,  //..... 


  /*Unicode: U+0074 (t) , Width: 4 */
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x40,  //.%.. 
  0x60,  //.%%. 
  0x40,  //.%.. 
  0x40,  //.%.. 
  0x40,  //.%.. 
  0x60,  //.%%. 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 


  /*Unicode: U+0075 (u) , Width: 6 */
  0x00,  //...... 
  0x00,  //...... 
  0x00,  //...... 
  0x00,  //...... 
  0x48,  //.%..%. 
  0x48,  //.%..%. 
  0x48,  //.%..%. 
  0x58,  //.%.%%. 
  0x78,  //.%%%%. 
  0x00,  //...... 
  0x00,  //...... 
  0x00,  //...... 


  /*Unicode: U+0076 (v) , Width: 6 */
  0x00,  //...... 
  0x00,  //...... 
  0x00,  //...... 
  0x00,  //...... 
  0xc8,  //%%..%. 
  0x58,  //.%.%%. 
  0x70,  //.%%%.. 
  0x70,  //.%%%.. 
  0x30,  //..%%.. 
  0x00,  //...... 
  0x00,  //...... 
  0x00,  //...... 


  /*Unicode: U+0077 (w) , Width: 8 */
  0x00,  //........ 
  0x00,  //........ 
  0x00,  //........ 
  0x00,  //........ 
  0xdb,  //%%.%%.%% 
  0x5b,  //.%.%%.%% 
  0x7e,  //.%%%%%%. 
  0x7e,  //.%%%%%%. 
  0x26,  //..%..%%. 
  0x00,  //........ 
  0x00,  //........ 
  0x00,  //........ 


  /*Unicode: U+0078 (x) , Width: 6 */
  0x00,  //...... 
  0x00,  //...... 
  0x00,  //...... 
  0x00,  //...... 
  0x58,  //.%.%%. 
  0x70,  //.%%%.. 
  0x30,  //..%%.. 
  0x70,  //.%%%.. 
  0xd8,  //%%.%%. 
  0x00,  //...... 
  0x00,  //...... 
  0x00,  //...... 


  /*Unicode: U+0079 (y) , Width: 6 */
  0x00,  //...... 
  0x00,  //...... 
  0x00,  //...... 
  0x00,  //...... 
  0x48,  //.%..%. 
  0x48,  //.%..%. 
  0x48,  //.%..%. 
  0x78,  //.%%%%. 
  0x08,  //....%. 
  0x58,  //.%.%%. 
  0x70,  //.%%%.. 
  0x00,  //...... 


  /*Unicode: U+007a (z) , Width: 4 */
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0xf0,  //%%%% 
  0x30,  //..%% 
  0xf0,  //%%%% 
  0xc0,  //%%.. 
  0xf0,  //%%%% 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 


  /*Unicode: U+007b ({) , Width: 3 */
  0x00,  //... 
  0x00,  //... 
  0x60,  //.%% 
  0x40,  //.%. 
  0x40,  //.%. 
  0x40,  //.%. 
  0xc0,  //%%. 
  0x40,  //.%. 
  0x40,  //.%. 
  0x60,  //.%% 
  0x00,  //... 
  0x00,  //... 


  /*Unicode: U+007c (|) , Width: 3 */
  0x00,  //... 
  0x00,  //... 
  0x40,  //.%. 
  0x40,  //.%. 
  0x40,  //.%. 
  0x40,  //.%. 
  0x40,  //.%. 
  0x40,  //.%. 
  0x40,  //.%. 
  0x40,  //.%. 
  0x00,  //... 
  0x00,  //... 


  /*Unicode: U+007d (}) , Width: 3 */
  0x00,  //... 
  0x00,  //... 
  0xc0,  //%%. 
  0x40,  //.%. 
  0x40,  //.%. 
  0x40,  //.%. 
  0x60,  //.%% 
  0x40,  //.%. 
  0x40,  //.%. 
  0xc0,  //%%. 
  0x00,  //... 
  0x00,  //... 


  /*Unicode: U+007e (~) , Width: 5 */
  0x00,  //..... 
  0x00,  //..... 
  0x00,  //..... 
  0x00,  //..... 
  0x40,  //.%... 
  0xf0,  //%%%%. 
  0x00,  //..... 
  0x00,  //..... 
  0x00,  //..... 
  0x00,  //..... 
  0x00,  //..... 
  0x00,  //..... 


  /*Unicode: U+007f () , Width: 4 */
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 



#elif USE_MABOLT_12 == 2
  /*Unicode: U+0020 ( ) , Width: 4 */
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 


  /*Unicode: U+0021 (!) , Width: 3 */
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x70,  //+@. 
  0x30,  //.@. 
  0x30,  //.@. 
  0x30,  //.@. 
  0x00,  //... 
  0x30,  //.@. 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 


  /*Unicode: U+0022 (") , Width: 4 */
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x7c,  //+@@. 
  0x7c,  //+@@. 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 


  /*Unicode: U+0023 (#) , Width: 7 */
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x0d, 0xe0,  //..@+@%. 
  0x3f, 0xf0,  //.@@@@@. 
  0x2d, 0xc0,  //.%@+@.. 
  0x7f, 0xf0,  //+@@@@@. 
  0x3a, 0xc0,  //.@%%@.. 
  0x36, 0x80,  //.@+%%.. 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 


  /*Unicode: U+0024 ($) , Width: 6 */
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x0b, 0x40,  //..%@+. 
  0x3f, 0xd0,  //.@@@@+ 
  0x3b, 0x00,  //.@%@.. 
  0x3f, 0x80,  //.@@@%. 
  0x0b, 0xe0,  //..%@@% 
  0x27, 0xa0,  //.%+@%% 
  0x3f, 0xd0,  //.@@@@+ 
  0x07, 0x00,  //..+@.. 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 


  /*Unicode: U+0025 (%) , Width: 6 */
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0xb0, 0xe0,  //%@..@% 
  0xf6, 0xc0,  //@@+%@. 
  0x07, 0x00,  //..+@.. 
  0x0d, 0xe0,  //..@+@% 
  0x39, 0x70,  //.@%++@ 
  0xb0, 0xe0,  //%@..@% 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 


  /*Unicode: U+0026 (&) , Width: 7 */
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x0f, 0x80,  //..@@%.. 
  0x1d, 0xc0,  //.+@+@.. 
  0x0f, 0x80,  //..@@%.. 
  0x3b, 0xa0,  //.@%@%%. 
  0x35, 0xf0,  //.@++@@. 
  0x2f, 0xb0,  //.%@@%@. 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 


  /*Unicode: U+0027 (') , Width: 3 */
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x70,  //+@. 
  0x70,  //+@. 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 


  /*Unicode: U+0028 (() , Width: 4 */
  0x00,  //.... 
  0x00,  //.... 
  0x1c,  //.+@. 
  0x38,  //.@%. 
  0x34,  //.@+. 
  0x30,  //.@.. 
  0x30,  //.@.. 
  0x34,  //.@+. 
  0x38,  //.@%. 
  0x1c,  //.+@. 
  0x00,  //.... 
  0x00,  //.... 


  /*Unicode: U+0029 ()) , Width: 4 */
  0x00,  //.... 
  0x00,  //.... 
  0x70,  //+@.. 
  0x38,  //.@%. 
  0x1c,  //.+@. 
  0x1c,  //.+@. 
  0x1c,  //.+@. 
  0x1c,  //.+@. 
  0x38,  //.@%. 
  0x70,  //+@.. 
  0x00,  //.... 
  0x00,  //.... 


  /*Unicode: U+002a (*) , Width: 4 */
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x28,  //.%%. 
  0x3d,  //.@@+ 
  0x28,  //.%%. 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 


  /*Unicode: U+002b (+) , Width: 4 */
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x1c,  //.+@. 
  0xff,  //@@@@ 
  0x1c,  //.+@. 
  0x1c,  //.+@. 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 


  /*Unicode: U+002c (,) , Width: 3 */
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x30,  //.@. 
  0x20,  //.%. 
  0x00,  //... 
  0x00,  //... 


  /*Unicode: U+002d (-) , Width: 3 */
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0xfc,  //@@@ 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 


  /*Unicode: U+002e (.) , Width: 3 */
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x30,  //.@. 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 


  /*Unicode: U+002f (/) , Width: 6 */
  0x00, 0x00,  //...... 
  0x00, 0x40,  //....+. 
  0x01, 0xc0,  //...+@. 
  0x03, 0x40,  //...@+. 
  0x07, 0x00,  //..+@.. 
  0x0e, 0x00,  //..@%.. 
  0x0c, 0x00,  //..@... 
  0x28, 0x00,  //.%%... 
  0x30, 0x00,  //.@.... 
  0xa0, 0x00,  //%%.... 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 


  /*Unicode: U+0030 (0) , Width: 7 */
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x0f, 0x80,  //..@@%.. 
  0x38, 0xe0,  //.@%.@%. 
  0x30, 0x70,  //.@..+@. 
  0x30, 0x70,  //.@..+@. 
  0x38, 0xf0,  //.@%.@@. 
  0x0f, 0xc0,  //..@@@.. 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 


  /*Unicode: U+0031 (1) , Width: 4 */
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x7c,  //+@@. 
  0x1c,  //.+@. 
  0x1c,  //.+@. 
  0x1c,  //.+@. 
  0x1c,  //.+@. 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 


  /*Unicode: U+0032 (2) , Width: 5 */
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 
  0x1f, 0x40,  //.+@@+ 
  0x35, 0xc0,  //.@++@ 
  0x02, 0xc0,  //...%@ 
  0x0b, 0x00,  //..%@. 
  0x1d, 0x00,  //.+@+. 
  0x3f, 0xc0,  //.@@@@ 
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 


  /*Unicode: U+0033 (3) , Width: 6 */
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x3f, 0xc0,  //.@@@@. 
  0x0b, 0x40,  //..%@+. 
  0x0f, 0x00,  //..@@.. 
  0x06, 0xc0,  //..+%@. 
  0x11, 0xc0,  //.+.+@. 
  0x3f, 0x40,  //.@@@+. 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 


  /*Unicode: U+0034 (4) , Width: 5 */
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 
  0x05, 0x00,  //..++. 
  0x0d, 0x00,  //..@+. 
  0x38, 0x00,  //.@%.. 
  0xb7, 0x00,  //%@+@. 
  0xff, 0xc0,  //@@@@@ 
  0x07, 0x40,  //..+@+ 
  0x07, 0x00,  //..+@. 
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 


  /*Unicode: U+0035 (5) , Width: 6 */
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x7f, 0x80,  //+@@@%. 
  0x70, 0x00,  //+@.... 
  0x7f, 0x40,  //+@@@+. 
  0x12, 0xc0,  //.+.%@. 
  0x11, 0xc0,  //.+.+@. 
  0x7f, 0x40,  //+@@@+. 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 


  /*Unicode: U+0036 (6) , Width: 6 */
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x1f, 0x40,  //.+@@+. 
  0x35, 0x00,  //.@++.. 
  0x3f, 0x40,  //.@@@+. 
  0x36, 0xc0,  //.@+%@. 
  0x36, 0xc0,  //.@+%@. 
  0x1f, 0x40,  //.+@@+. 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 


  /*Unicode: U+0037 (7) , Width: 5 */
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 
  0xff, 0x40,  //@@@@+ 
  0xd7, 0x40,  //@++@+ 
  0x0f, 0x00,  //..@@. 
  0x0d, 0x00,  //..@+. 
  0x2c, 0x00,  //.%@.. 
  0x34, 0x00,  //.@+.. 
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 


  /*Unicode: U+0038 (8) , Width: 6 */
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x2f, 0x80,  //.%@@%. 
  0x36, 0xc0,  //.@+%@. 
  0x3f, 0x80,  //.@@@%. 
  0x36, 0xc0,  //.@+%@. 
  0x36, 0xc0,  //.@+%@. 
  0x2f, 0x40,  //.%@@+. 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 


  /*Unicode: U+0039 (9) , Width: 6 */
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x2f, 0x00,  //.%@@.. 
  0x36, 0xc0,  //.@+%@. 
  0x31, 0xc0,  //.@.+@. 
  0x2f, 0xc0,  //.%@@@. 
  0x01, 0xc0,  //...+@. 
  0x3f, 0x40,  //.@@@+. 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 


  /*Unicode: U+003a (:) , Width: 3 */
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x30,  //.@. 
  0x00,  //... 
  0x00,  //... 
  0x30,  //.@. 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 


  /*Unicode: U+003b (;) , Width: 3 */
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x30,  //.@. 
  0x00,  //... 
  0x00,  //... 
  0x30,  //.@. 
  0x20,  //.%. 
  0x00,  //... 
  0x00,  //... 


  /*Unicode: U+003c (<) , Width: 5 */
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 
  0x07, 0x40,  //..+@+ 
  0x7d, 0x00,  //+@@+. 
  0xf0, 0x00,  //@@... 
  0x2e, 0x00,  //.%@%. 
  0x02, 0x40,  //...%+ 
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 


  /*Unicode: U+003d (=) , Width: 4 */
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0xff,  //@@@@ 
  0x00,  //.... 
  0xff,  //@@@@ 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 


  /*Unicode: U+003e (>) , Width: 5 */
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 
  0xe0, 0x00,  //@%... 
  0x2e, 0x00,  //.%@%. 
  0x0b, 0x40,  //..%@+ 
  0x7d, 0x00,  //+@@+. 
  0xd0, 0x00,  //@+... 
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 


  /*Unicode: U+003f (?) , Width: 5 */
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 
  0x2e, 0x00,  //.%@%. 
  0x77, 0x00,  //+@+@. 
  0x0b, 0x00,  //..%@. 
  0x0c, 0x00,  //..@.. 
  0x08, 0x00,  //..%.. 
  0x0c, 0x00,  //..@.. 
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 


  /*Unicode: U+0040 (@) , Width: 9 */
  0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00,  //......... 
  0x07, 0xf4, 0x00,  //..+@@@+.. 
  0x2f, 0xfd, 0x00,  //.%@@@@@+. 
  0x3d, 0xbb, 0x00,  //.@@+%@%@. 
  0x3c, 0x77, 0x00,  //.@@.+@+@. 
  0x3e, 0xb7, 0x00,  //.@@%%@+@. 
  0x3f, 0xad, 0x00,  //.@@@%%@+. 
  0x0b, 0xe0, 0x00,  //..%@@%... 
  0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00,  //......... 


  /*Unicode: U+0041 (A) , Width: 7 */
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x1f, 0xc0,  //.+@@@.. 
  0x38, 0xb0,  //.@%.%@. 
  0x30, 0x70,  //.@..+@. 
  0x7f, 0xf0,  //+@@@@@. 
  0x70, 0x70,  //+@..+@. 
  0x70, 0x70,  //+@..+@. 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 


  /*Unicode: U+0042 (B) , Width: 7 */
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x7f, 0x80,  //+@@@%.. 
  0x72, 0xc0,  //+@.%@.. 
  0x7f, 0xc0,  //+@@@@.. 
  0x70, 0xb0,  //+@..%@. 
  0x70, 0xb0,  //+@..%@. 
  0x7f, 0xd0,  //+@@@@+. 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 


  /*Unicode: U+0043 (C) , Width: 7 */
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x0b, 0xe0,  //..%@@%. 
  0x3d, 0x60,  //.@@++%. 
  0x30, 0x00,  //.@..... 
  0x30, 0x00,  //.@..... 
  0x3c, 0x60,  //.@@.+%. 
  0x0b, 0xe0,  //..%@@%. 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 


  /*Unicode: U+0044 (D) , Width: 7 */
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x7f, 0x80,  //+@@@%.. 
  0x71, 0xe0,  //+@.+@%. 
  0x70, 0x70,  //+@..+@. 
  0x70, 0x70,  //+@..+@. 
  0x71, 0xe0,  //+@.+@%. 
  0x7f, 0x80,  //+@@@%.. 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 


  /*Unicode: U+0045 (E) , Width: 5 */
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 
  0x2f, 0x40,  //.%@@+ 
  0x34, 0x00,  //.@+.. 
  0x3f, 0x40,  //.@@@+ 
  0x34, 0x00,  //.@+.. 
  0x34, 0x40,  //.@+.+ 
  0x2f, 0x80,  //.%@@% 
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 


  /*Unicode: U+0046 (F) , Width: 6 */
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x1f, 0xc0,  //.+@@@. 
  0x38, 0x40,  //.@%.+. 
  0x70, 0x00,  //+@.... 
  0x7f, 0x00,  //+@@@.. 
  0x70, 0x00,  //+@.... 
  0x70, 0x00,  //+@.... 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 


  /*Unicode: U+0047 (G) , Width: 8 */
  0x00, 0x00,  //........ 
  0x00, 0x00,  //........ 
  0x00, 0x00,  //........ 
  0x0b, 0xf4,  //..%@@@+. 
  0x3d, 0x20,  //.@@+.%.. 
  0x30, 0x00,  //.@...... 
  0x30, 0x1c,  //.@...+@. 
  0x3d, 0x2c,  //.@@+.%@. 
  0x0b, 0xfc,  //..%@@@@. 
  0x00, 0x00,  //........ 
  0x00, 0x00,  //........ 
  0x00, 0x00,  //........ 


  /*Unicode: U+0048 (H) , Width: 7 */
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x70, 0x70,  //+@..+@. 
  0x70, 0x70,  //+@..+@. 
  0x7f, 0xf0,  //+@@@@@. 
  0x70, 0x70,  //+@..+@. 
  0x70, 0x70,  //+@..+@. 
  0x70, 0x70,  //+@..+@. 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 


  /*Unicode: U+0049 (I) , Width: 4 */
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0xff,  //@@@@ 
  0x70,  //+@.. 
  0x70,  //+@.. 
  0x70,  //+@.. 
  0x70,  //+@.. 
  0xff,  //@@@@ 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 


  /*Unicode: U+004a (J) , Width: 5 */
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 
  0x7f, 0x00,  //+@@@. 
  0x07, 0x00,  //..+@. 
  0x07, 0x00,  //..+@. 
  0x07, 0x00,  //..+@. 
  0x07, 0x00,  //..+@. 
  0x47, 0x00,  //+.+@. 
  0xfd, 0x00,  //@@@+. 
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 


  /*Unicode: U+004b (K) , Width: 7 */
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x70, 0xe0,  //+@..@%. 
  0x73, 0xc0,  //+@.@@.. 
  0x7f, 0x00,  //+@@@... 
  0x7f, 0x40,  //+@@@+.. 
  0x72, 0xc0,  //+@.%@.. 
  0x70, 0xf0,  //+@..@@. 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 


  /*Unicode: U+004c (L) , Width: 5 */
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 
  0x70, 0x00,  //+@... 
  0x70, 0x00,  //+@... 
  0x70, 0x00,  //+@... 
  0x70, 0x00,  //+@... 
  0x75, 0x00,  //+@++. 
  0x7f, 0xc0,  //+@@@@ 
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 


  /*Unicode: U+004d (M) , Width: 9 */
  0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00,  //......... 
  0x7f, 0x7d, 0x00,  //+@@@+@@+. 
  0x76, 0xdb, 0x00,  //+@+%@+%@. 
  0x71, 0xc7, 0x00,  //+@.+@.+@. 
  0x71, 0xc7, 0x00,  //+@.+@.+@. 
  0x71, 0xc7, 0x00,  //+@.+@.+@. 
  0x71, 0xc7, 0x00,  //+@.+@.+@. 
  0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00,  //......... 


  /*Unicode: U+004e (N) , Width: 7 */
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x7f, 0xc0,  //+@@@@.. 
  0x78, 0xb0,  //+@%.%@. 
  0x70, 0x70,  //+@..+@. 
  0x70, 0x70,  //+@..+@. 
  0x70, 0x70,  //+@..+@. 
  0x70, 0x70,  //+@..+@. 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 


  /*Unicode: U+004f (O) , Width: 8 */
  0x00, 0x00,  //........ 
  0x00, 0x00,  //........ 
  0x00, 0x00,  //........ 
  0x0b, 0xe0,  //..%@@%.. 
  0x3c, 0x78,  //.@@.+@%. 
  0x30, 0x1c,  //.@...+@. 
  0x30, 0x1c,  //.@...+@. 
  0x3c, 0x78,  //.@@.+@%. 
  0x0b, 0xe0,  //..%@@%.. 
  0x00, 0x00,  //........ 
  0x00, 0x00,  //........ 
  0x00, 0x00,  //........ 


  /*Unicode: U+0050 (P) , Width: 7 */
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x7f, 0xd0,  //+@@@@+. 
  0x70, 0xb0,  //+@..%@. 
  0x70, 0x70,  //+@..+@. 
  0x7f, 0xd0,  //+@@@@+. 
  0x70, 0x00,  //+@..... 
  0x70, 0x00,  //+@..... 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 


  /*Unicode: U+0051 (Q) , Width: 9 */
  0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00,  //......... 
  0x0b, 0xf4, 0x00,  //..%@@@+.. 
  0x2d, 0x1e, 0x00,  //.%@+.+@%. 
  0x30, 0x07, 0x00,  //.@....+@. 
  0x30, 0x07, 0x00,  //.@....+@. 
  0x3e, 0xde, 0x00,  //.@@%@+@%. 
  0x0b, 0xf8, 0x00,  //..%@@@%.. 
  0x01, 0xc0, 0x00,  //...+@.... 
  0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00,  //......... 


  /*Unicode: U+0052 (R) , Width: 7 */
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x7f, 0xd0,  //+@@@@+. 
  0x70, 0xb0,  //+@..%@. 
  0x70, 0x70,  //+@..+@. 
  0x7f, 0xe0,  //+@@@@%. 
  0x72, 0xd0,  //+@.%@+. 
  0x70, 0xb0,  //+@..%@. 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 


  /*Unicode: U+0053 (S) , Width: 6 */
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x1f, 0x80,  //.+@@%. 
  0x38, 0x80,  //.@%.%. 
  0x3e, 0x00,  //.@@%.. 
  0x06, 0xd0,  //..+%@+ 
  0x24, 0xd0,  //.%+.@+ 
  0x1f, 0x80,  //.+@@%. 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 


  /*Unicode: U+0054 (T) , Width: 7 */
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x2f, 0xe0,  //.%@@@%. 
  0x2b, 0x60,  //.%%@+%. 
  0x07, 0x00,  //..+@... 
  0x07, 0x00,  //..+@... 
  0x07, 0x00,  //..+@... 
  0x07, 0x00,  //..+@... 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 


  /*Unicode: U+0055 (U) , Width: 7 */
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x70, 0x70,  //+@..+@. 
  0x70, 0x70,  //+@..+@. 
  0x70, 0x70,  //+@..+@. 
  0x70, 0x70,  //+@..+@. 
  0x38, 0xf0,  //.@%.@@. 
  0x1f, 0xf0,  //.+@@@@. 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 


  /*Unicode: U+0056 (V) , Width: 7 */
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0xe0, 0xb0,  //@%..%@. 
  0x70, 0xe0,  //+@..@%. 
  0x39, 0xc0,  //.@%+@.. 
  0x2f, 0x80,  //.%@@%.. 
  0x0f, 0x40,  //..@@+.. 
  0x0b, 0x00,  //..%@... 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 


  /*Unicode: U+0057 (W) , Width: 9 */
  0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00,  //......... 
  0x71, 0xc7, 0x00,  //+@.+@.+@. 
  0x71, 0xc7, 0x00,  //+@.+@.+@. 
  0x71, 0xc7, 0x00,  //+@.+@.+@. 
  0x71, 0xc7, 0x00,  //+@.+@.+@. 
  0x3a, 0xeb, 0x00,  //.@%%@%%@. 
  0x2f, 0x7d, 0x00,  //.%@@+@@+. 
  0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00,  //......... 


  /*Unicode: U+0058 (X) , Width: 7 */
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x74, 0xe0,  //+@+.@%. 
  0x2e, 0xc0,  //.%@%@.. 
  0x0f, 0x40,  //..@@+.. 
  0x0f, 0x40,  //..@@+.. 
  0x3e, 0xc0,  //.@@%@.. 
  0xb0, 0xf0,  //%@..@@. 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 


  /*Unicode: U+0059 (Y) , Width: 7 */
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x70, 0x70,  //+@..+@. 
  0x70, 0x70,  //+@..+@. 
  0x70, 0x70,  //+@..+@. 
  0x34, 0xb0,  //.@+.%@. 
  0x2f, 0xf0,  //.%@@@@. 
  0x24, 0xb0,  //.%+.%@. 
  0x2f, 0xc0,  //.%@@@.. 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 


  /*Unicode: U+005a (Z) , Width: 5 */
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 
  0xff, 0xc0,  //@@@@@ 
  0x0b, 0x40,  //..%@+ 
  0xff, 0x80,  //@@@@% 
  0x38, 0x00,  //.@%.. 
  0xb4, 0x00,  //%@+.. 
  0xff, 0xc0,  //@@@@@ 
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 


  /*Unicode: U+005b ([) , Width: 4 */
  0x00,  //.... 
  0x00,  //.... 
  0x7c,  //+@@. 
  0x70,  //+@.. 
  0x70,  //+@.. 
  0x70,  //+@.. 
  0x70,  //+@.. 
  0x70,  //+@.. 
  0x70,  //+@.. 
  0x7c,  //+@@. 
  0x00,  //.... 
  0x00,  //.... 


  /*Unicode: U+005c (\) , Width: 5 */
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 
  0xb0, 0x00,  //%@... 
  0x34, 0x00,  //.@+.. 
  0x2c, 0x00,  //.%@.. 
  0x0c, 0x00,  //..@.. 
  0x0a, 0x00,  //..%%. 
  0x03, 0x00,  //...@. 
  0x02, 0x80,  //...%% 
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 


  /*Unicode: U+005d (]) , Width: 4 */
  0x00,  //.... 
  0x00,  //.... 
  0x7c,  //+@@. 
  0x1c,  //.+@. 
  0x1c,  //.+@. 
  0x1c,  //.+@. 
  0x1c,  //.+@. 
  0x1c,  //.+@. 
  0x1c,  //.+@. 
  0x7c,  //+@@. 
  0x00,  //.... 
  0x00,  //.... 


  /*Unicode: U+005e (^) , Width: 4 */
  0x00,  //.... 
  0x3d,  //.@@+ 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 


  /*Unicode: U+005f (_) , Width: 6 */
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x7f, 0xf0,  //+@@@@@ 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 


  /*Unicode: U+0060 (`) , Width: 3 */
  0x10,  //.+. 
  0x38,  //.@% 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 


  /*Unicode: U+0061 (a) , Width: 7 */
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x1f, 0xf0,  //.+@@@@. 
  0x38, 0xb0,  //.@%.%@. 
  0x30, 0x70,  //.@..+@. 
  0x38, 0xb0,  //.@%.%@. 
  0x1f, 0xf0,  //.+@@@@. 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 


  /*Unicode: U+0062 (b) , Width: 7 */
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x70, 0x00,  //+@..... 
  0x70, 0x00,  //+@..... 
  0x7b, 0xc0,  //+@%@@.. 
  0x78, 0xb0,  //+@%.%@. 
  0x70, 0x70,  //+@..+@. 
  0x78, 0xb0,  //+@%.%@. 
  0x7b, 0xc0,  //+@%@@.. 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 


  /*Unicode: U+0063 (c) , Width: 6 */
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x1f, 0x80,  //.+@@%. 
  0x38, 0x80,  //.@%.%. 
  0x30, 0x00,  //.@.... 
  0x38, 0x80,  //.@%.%. 
  0x1f, 0x80,  //.+@@%. 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 


  /*Unicode: U+0064 (d) , Width: 7 */
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x00, 0x70,  //....+@. 
  0x00, 0x70,  //....+@. 
  0x1f, 0xb0,  //.+@@%@. 
  0x38, 0xb0,  //.@%.%@. 
  0x30, 0x70,  //.@..+@. 
  0x38, 0xb0,  //.@%.%@. 
  0x1f, 0xb0,  //.+@@%@. 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 


  /*Unicode: U+0065 (e) , Width: 6 */
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x1f, 0x80,  //.+@@%. 
  0x39, 0xe0,  //.@%+@% 
  0x3b, 0x80,  //.@%@%. 
  0x3d, 0x80,  //.@@+%. 
  0x1f, 0x80,  //.+@@%. 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 


  /*Unicode: U+0066 (f) , Width: 4 */
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x2e,  //.%@% 
  0x34,  //.@+. 
  0x7d,  //+@@+ 
  0x70,  //+@.. 
  0x70,  //+@.. 
  0x70,  //+@.. 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 


  /*Unicode: U+0067 (g) , Width: 6 */
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x1f, 0xc0,  //.+@@@. 
  0x36, 0xc0,  //.@+%@. 
  0x31, 0xc0,  //.@.+@. 
  0x36, 0xc0,  //.@+%@. 
  0x1f, 0xc0,  //.+@@@. 
  0x36, 0xc0,  //.@+%@. 
  0x1f, 0x40,  //.+@@+. 
  0x00, 0x00,  //...... 


  /*Unicode: U+0068 (h) , Width: 6 */
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x70, 0x00,  //+@.... 
  0x70, 0x00,  //+@.... 
  0x7b, 0x40,  //+@%@+. 
  0x76, 0xc0,  //+@+%@. 
  0x71, 0xc0,  //+@.+@. 
  0x71, 0xc0,  //+@.+@. 
  0x71, 0xc0,  //+@.+@. 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 


  /*Unicode: U+0069 (i) , Width: 3 */
  0x00,  //... 
  0x00,  //... 
  0x30,  //.@. 
  0x00,  //... 
  0x70,  //+@. 
  0x70,  //+@. 
  0x70,  //+@. 
  0x70,  //+@. 
  0x70,  //+@. 
  0x00,  //... 
  0x00,  //... 
  0x00,  //... 


  /*Unicode: U+006a (j) , Width: 3 */
  0x00,  //... 
  0x00,  //... 
  0x30,  //.@. 
  0x00,  //... 
  0x70,  //+@. 
  0x70,  //+@. 
  0x70,  //+@. 
  0x70,  //+@. 
  0x70,  //+@. 
  0xb0,  //%@. 
  0xe0,  //@%. 
  0x00,  //... 


  /*Unicode: U+006b (k) , Width: 6 */
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x70, 0x00,  //+@.... 
  0x70, 0x00,  //+@.... 
  0x73, 0xc0,  //+@.@@. 
  0x7f, 0x00,  //+@@@.. 
  0x7f, 0x00,  //+@@@.. 
  0x77, 0x40,  //+@+@+. 
  0x72, 0xc0,  //+@.%@. 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 


  /*Unicode: U+006c (l) , Width: 4 */
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x70,  //+@.. 
  0x70,  //+@.. 
  0x70,  //+@.. 
  0x70,  //+@.. 
  0x34,  //.@+. 
  0x2d,  //.%@+ 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 


  /*Unicode: U+006d (m) , Width: 9 */
  0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00,  //......... 
  0x7f, 0x7d, 0x00,  //+@@@+@@+. 
  0x76, 0xdb, 0x00,  //+@+%@+%@. 
  0x71, 0xc7, 0x00,  //+@.+@.+@. 
  0x71, 0xc7, 0x00,  //+@.+@.+@. 
  0x71, 0xc7, 0x00,  //+@.+@.+@. 
  0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00,  //......... 


  /*Unicode: U+006e (n) , Width: 6 */
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x7b, 0x40,  //+@%@+. 
  0x76, 0xc0,  //+@+%@. 
  0x71, 0xc0,  //+@.+@. 
  0x71, 0xc0,  //+@.+@. 
  0x71, 0xc0,  //+@.+@. 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 


  /*Unicode: U+006f (o) , Width: 7 */
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x1f, 0xc0,  //.+@@@.. 
  0x38, 0xb0,  //.@%.%@. 
  0x30, 0x70,  //.@..+@. 
  0x38, 0xb0,  //.@%.%@. 
  0x1f, 0xc0,  //.+@@@.. 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 


  /*Unicode: U+0070 (p) , Width: 7 */
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x7b, 0xc0,  //+@%@@.. 
  0x78, 0xb0,  //+@%.%@. 
  0x70, 0x70,  //+@..+@. 
  0x78, 0xb0,  //+@%.%@. 
  0x7b, 0xc0,  //+@%@@.. 
  0x70, 0x00,  //+@..... 
  0x70, 0x00,  //+@..... 
  0x00, 0x00,  //....... 


  /*Unicode: U+0071 (q) , Width: 7 */
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x00, 0x00,  //....... 
  0x1f, 0xb0,  //.+@@%@. 
  0x38, 0xb0,  //.@%.%@. 
  0x30, 0x70,  //.@..+@. 
  0x38, 0xb0,  //.@%.%@. 
  0x1f, 0xf0,  //.+@@@@. 
  0x00, 0x70,  //....+@. 
  0x00, 0x70,  //....+@. 
  0x00, 0x00,  //....... 


  /*Unicode: U+0072 (r) , Width: 4 */
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x7a,  //+@%% 
  0x78,  //+@%. 
  0x70,  //+@.. 
  0x70,  //+@.. 
  0x70,  //+@.. 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 


  /*Unicode: U+0073 (s) , Width: 5 */
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 
  0x2f, 0x00,  //.%@@. 
  0x35, 0x00,  //.@++. 
  0x1f, 0x00,  //.+@@. 
  0x13, 0x40,  //.+.@+ 
  0x2f, 0x00,  //.%@@. 
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 


  /*Unicode: U+0074 (t) , Width: 4 */
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x70,  //+@.. 
  0x7d,  //+@@+ 
  0x70,  //+@.. 
  0x70,  //+@.. 
  0x34,  //.@+. 
  0x2d,  //.%@+ 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 


  /*Unicode: U+0075 (u) , Width: 6 */
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x71, 0xc0,  //+@.+@. 
  0x71, 0xc0,  //+@.+@. 
  0x71, 0xc0,  //+@.+@. 
  0x36, 0xc0,  //.@+%@. 
  0x2f, 0xc0,  //.%@@@. 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 


  /*Unicode: U+0076 (v) , Width: 6 */
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0xe1, 0xc0,  //@%.+@. 
  0x72, 0x80,  //+@.%%. 
  0x3b, 0x40,  //.@%@+. 
  0x2f, 0x00,  //.%@@.. 
  0x1e, 0x00,  //.+@%.. 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 


  /*Unicode: U+0077 (w) , Width: 8 */
  0x00, 0x00,  //........ 
  0x00, 0x00,  //........ 
  0x00, 0x00,  //........ 
  0x00, 0x00,  //........ 
  0xa2, 0xcb,  //%%.%@.%@ 
  0x73, 0xce,  //+@.@@.@% 
  0x3b, 0xec,  //.@%@@%@. 
  0x2e, 0xbc,  //.%@%%@@. 
  0x1d, 0x38,  //.+@+.@%. 
  0x00, 0x00,  //........ 
  0x00, 0x00,  //........ 
  0x00, 0x00,  //........ 


  /*Unicode: U+0078 (x) , Width: 6 */
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x73, 0x80,  //+@.@%. 
  0x3f, 0x00,  //.@@@.. 
  0x1e, 0x00,  //.+@%.. 
  0x3f, 0x00,  //.@@@.. 
  0xb3, 0xc0,  //%@.@@. 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 


  /*Unicode: U+0079 (y) , Width: 6 */
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x00, 0x00,  //...... 
  0x71, 0xc0,  //+@.+@. 
  0x71, 0xc0,  //+@.+@. 
  0x35, 0xc0,  //.@++@. 
  0x3f, 0xc0,  //.@@@@. 
  0x11, 0xc0,  //.+.+@. 
  0x76, 0xc0,  //+@+%@. 
  0x2f, 0x00,  //.%@@.. 
  0x00, 0x00,  //...... 


  /*Unicode: U+007a (z) , Width: 4 */
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0xff,  //@@@@ 
  0x1e,  //.+@% 
  0xfe,  //@@@% 
  0xf5,  //@@++ 
  0xff,  //@@@@ 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 


  /*Unicode: U+007b ({) , Width: 3 */
  0x00,  //... 
  0x00,  //... 
  0x38,  //.@% 
  0x30,  //.@. 
  0x70,  //+@. 
  0x70,  //+@. 
  0xf0,  //@@. 
  0x70,  //+@. 
  0x70,  //+@. 
  0x38,  //.@% 
  0x00,  //... 
  0x00,  //... 


  /*Unicode: U+007c (|) , Width: 3 */
  0x00,  //... 
  0x00,  //... 
  0x70,  //+@. 
  0x70,  //+@. 
  0x70,  //+@. 
  0x70,  //+@. 
  0x70,  //+@. 
  0x70,  //+@. 
  0x70,  //+@. 
  0x70,  //+@. 
  0x00,  //... 
  0x00,  //... 


  /*Unicode: U+007d (}) , Width: 3 */
  0x00,  //... 
  0x00,  //... 
  0xe0,  //@%. 
  0x70,  //+@. 
  0x70,  //+@. 
  0x70,  //+@. 
  0x38,  //.@% 
  0x70,  //+@. 
  0x70,  //+@. 
  0xf0,  //@@. 
  0x00,  //... 
  0x00,  //... 


  /*Unicode: U+007e (~) , Width: 5 */
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 
  0x75, 0x40,  //+@+++ 
  0xab, 0x40,  //%%%@+ 
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 
  0x00, 0x00,  //..... 


  /*Unicode: U+007f () , Width: 4 */
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 
  0x00,  //.... 



#elif USE_MABOLT_12 == 4
  /*Unicode: U+0020 ( ) , Width: 4 */
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 


  /*Unicode: U+0021 (!) , Width: 3 */
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 
  0x4f, 0x10,  //+@. 
  0x3f, 0x00,  //.@. 
  0x2f, 0x00,  //.@. 
  0x1e, 0x00,  //.@. 
  0x01, 0x00,  //... 
  0x2e, 0x00,  //.@. 
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 


  /*Unicode: U+0022 (") , Width: 4 */
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x4f, 0xf1,  //+@@. 
  0x4f, 0xf1,  //+@@. 
  0x02, 0x20,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 


  /*Unicode: U+0023 (#) , Width: 7 */
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0xf5, 0xd8, 0x00,  //..@+@%. 
  0x2f, 0xff, 0xff, 0x30,  //.@@@@@. 
  0x08, 0xe6, 0xf3, 0x00,  //.%@+@.. 
  0x7f, 0xff, 0xfe, 0x00,  //+@@@@@. 
  0x1d, 0xaa, 0xc2, 0x00,  //.@%%@.. 
  0x0e, 0x7b, 0x90, 0x00,  //.@+%%.. 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 


  /*Unicode: U+0024 ($) , Width: 6 */
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x01, 0x9f, 0x60,  //..%@+. 
  0x0e, 0xff, 0xf7,  //.@@@@+ 
  0x3f, 0xbf, 0x30,  //.@%@.. 
  0x0e, 0xff, 0x90,  //.@@@%. 
  0x00, 0x8f, 0xf8,  //..%@@% 
  0x1a, 0x7f, 0xaa,  //.%+@%% 
  0x3d, 0xff, 0xf5,  //.@@@@+ 
  0x00, 0x6f, 0x30,  //..+@.. 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 


  /*Unicode: U+0025 (%) , Width: 6 */
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0xbe, 0x30, 0xd8,  //%@..@% 
  0xef, 0x5a, 0xc0,  //@@+%@. 
  0x01, 0x5f, 0x20,  //..+@.. 
  0x02, 0xf7, 0xc8,  //..@+@% 
  0x0c, 0x97, 0x7f,  //.@%++@ 
  0x9d, 0x02, 0xe9,  //%@..@% 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 


  /*Unicode: U+0026 (&) , Width: 7 */
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x02, 0xcf, 0xb0, 0x00,  //..@@%.. 
  0x07, 0xf5, 0xf2, 0x00,  //.+@+@.. 
  0x02, 0xff, 0x80, 0x00,  //..@@%.. 
  0x0d, 0xae, 0xab, 0x00,  //.@%@%%. 
  0x3f, 0x57, 0xfc, 0x00,  //.@++@@. 
  0x09, 0xee, 0x9e, 0x30,  //.%@@%@. 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 


  /*Unicode: U+0027 (') , Width: 3 */
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 
  0x4f, 0x10,  //+@. 
  0x4f, 0x10,  //+@. 
  0x02, 0x00,  //... 
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 


  /*Unicode: U+0028 (() , Width: 4 */
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x05, 0xf1,  //.+@. 
  0x0c, 0xa0,  //.@%. 
  0x1f, 0x40,  //.@+. 
  0x3f, 0x20,  //.@.. 
  0x3f, 0x20,  //.@.. 
  0x1f, 0x40,  //.@+. 
  0x0c, 0x90,  //.@%. 
  0x05, 0xf1,  //.+@. 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 


  /*Unicode: U+0029 ()) , Width: 4 */
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x4f, 0x30,  //+@.. 
  0x0c, 0x90,  //.@%. 
  0x07, 0xe0,  //.+@. 
  0x04, 0xf0,  //.+@. 
  0x04, 0xf0,  //.+@. 
  0x07, 0xe0,  //.+@. 
  0x0c, 0x90,  //.@%. 
  0x4f, 0x30,  //+@.. 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 


  /*Unicode: U+002a (*) , Width: 4 */
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x2a, 0xb3,  //.%%. 
  0x3f, 0xf5,  //.@@+ 
  0x2b, 0xb3,  //.%%. 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 


  /*Unicode: U+002b (+) , Width: 4 */
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x04, 0xf1,  //.+@. 
  0xff, 0xff,  //@@@@ 
  0x26, 0xf3,  //.+@. 
  0x04, 0xf1,  //.+@. 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 


  /*Unicode: U+002c (,) , Width: 3 */
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 
  0x01, 0x00,  //... 
  0x3f, 0x00,  //.@. 
  0x2b, 0x00,  //.%. 
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 


  /*Unicode: U+002d (-) , Width: 3 */
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 
  0xff, 0xf0,  //@@@ 
  0x22, 0x20,  //... 
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 


  /*Unicode: U+002e (.) , Width: 3 */
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 
  0x01, 0x00,  //... 
  0x2e, 0x00,  //.@. 
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 


  /*Unicode: U+002f (/) , Width: 6 */
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x71,  //....+. 
  0x00, 0x06, 0xd0,  //...+@. 
  0x00, 0x0d, 0x60,  //...@+. 
  0x00, 0x4e, 0x00,  //..+@.. 
  0x00, 0xc8, 0x00,  //..@%.. 
  0x03, 0xf1, 0x00,  //..@... 
  0x0a, 0x90, 0x00,  //.%%... 
  0x1f, 0x20, 0x00,  //.@.... 
  0x8b, 0x00, 0x00,  //%%.... 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 


  /*Unicode: U+0030 (0) , Width: 7 */
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x03, 0xdf, 0xb1, 0x00,  //..@@%.. 
  0x0e, 0xa3, 0xcb, 0x00,  //.@%.@%. 
  0x3f, 0x20, 0x5f, 0x00,  //.@..+@. 
  0x3f, 0x20, 0x5f, 0x00,  //.@..+@. 
  0x0e, 0xa3, 0xcc, 0x00,  //.@%.@@. 
  0x03, 0xdf, 0xc2, 0x00,  //..@@@.. 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 


  /*Unicode: U+0031 (1) , Width: 4 */
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x7f, 0xf1,  //+@@. 
  0x16, 0xf1,  //.+@. 
  0x04, 0xf1,  //.+@. 
  0x04, 0xf1,  //.+@. 
  0x04, 0xf1,  //.+@. 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 


  /*Unicode: U+0032 (2) , Width: 5 */
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 
  0x05, 0xde, 0x60,  //.+@@+ 
  0x0d, 0x76, 0xf0,  //.@++@ 
  0x00, 0x0a, 0xc0,  //...%@ 
  0x00, 0x8f, 0x30,  //..%@. 
  0x07, 0xf6, 0x20,  //.+@+. 
  0x0f, 0xff, 0xf0,  //.@@@@ 
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 


  /*Unicode: U+0033 (3) , Width: 6 */
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x0f, 0xff, 0xf0,  //.@@@@. 
  0x02, 0x8f, 0x60,  //..%@+. 
  0x02, 0xfd, 0x20,  //..@@.. 
  0x02, 0x6b, 0xe0,  //..+%@. 
  0x06, 0x06, 0xf0,  //.+.+@. 
  0x2e, 0xff, 0x70,  //.@@@+. 
  0x00, 0x21, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 


  /*Unicode: U+0034 (4) , Width: 5 */
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x56, 0x00,  //..++. 
  0x03, 0xf5, 0x00,  //..@+. 
  0x0d, 0xb0, 0x00,  //.@%.. 
  0x9f, 0x6f, 0x10,  //%@+@. 
  0xff, 0xff, 0xf0,  //@@@@@ 
  0x33, 0x6f, 0x40,  //..+@+ 
  0x00, 0x4f, 0x10,  //..+@. 
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 


  /*Unicode: U+0035 (5) , Width: 6 */
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x4f, 0xff, 0xb0,  //+@@@%. 
  0x4f, 0x32, 0x10,  //+@.... 
  0x4f, 0xfd, 0x40,  //+@@@+. 
  0x06, 0x39, 0xf0,  //.+.%@. 
  0x17, 0x07, 0xf0,  //.+.+@. 
  0x4e, 0xff, 0x60,  //+@@@+. 
  0x00, 0x20, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 


  /*Unicode: U+0036 (6) , Width: 6 */
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x05, 0xef, 0x70,  //.+@@+. 
  0x0f, 0x74, 0x30,  //.@++.. 
  0x3f, 0xde, 0x60,  //.@@@+. 
  0x3f, 0x68, 0xf0,  //.@+%@. 
  0x0f, 0x68, 0xf0,  //.@+%@. 
  0x06, 0xee, 0x60,  //.+@@+. 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 


  /*Unicode: U+0037 (7) , Width: 5 */
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 
  0xff, 0xff, 0x70,  //@@@@+ 
  0xf6, 0x7f, 0x40,  //@++@+ 
  0x00, 0xcc, 0x00,  //..@@. 
  0x03, 0xf4, 0x00,  //..@+. 
  0x0b, 0xc0, 0x00,  //.%@.. 
  0x3f, 0x40, 0x00,  //.@+.. 
  0x12, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 


  /*Unicode: U+0038 (8) , Width: 6 */
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x0a, 0xfe, 0x80,  //.%@@%. 
  0x3f, 0x68, 0xf0,  //.@+%@. 
  0x0c, 0xff, 0xa0,  //.@@@%. 
  0x2f, 0x68, 0xf0,  //.@+%@. 
  0x2f, 0x68, 0xf0,  //.@+%@. 
  0x08, 0xfe, 0x50,  //.%@@+. 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 


  /*Unicode: U+0039 (9) , Width: 6 */
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x08, 0xed, 0x30,  //.%@@.. 
  0x2f, 0x69, 0xd0,  //.@+%@. 
  0x3f, 0x36, 0xf0,  //.@.+@. 
  0x0b, 0xff, 0xf0,  //.%@@@. 
  0x02, 0x27, 0xd0,  //...+@. 
  0x0c, 0xff, 0x40,  //.@@@+. 
  0x00, 0x20, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 


  /*Unicode: U+003a (:) , Width: 3 */
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 
  0x2e, 0x00,  //.@. 
  0x01, 0x00,  //... 
  0x01, 0x00,  //... 
  0x2e, 0x00,  //.@. 
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 


  /*Unicode: U+003b (;) , Width: 3 */
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 
  0x2e, 0x00,  //.@. 
  0x01, 0x00,  //... 
  0x01, 0x00,  //... 
  0x3f, 0x00,  //.@. 
  0x2b, 0x00,  //.%. 
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 


  /*Unicode: U+003c (<) , Width: 5 */
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x10,  //..... 
  0x00, 0x6d, 0x70,  //..+@+ 
  0x7e, 0xe7, 0x00,  //+@@+. 
  0xfe, 0x30, 0x00,  //@@... 
  0x3b, 0xfb, 0x20,  //.%@%. 
  0x00, 0x2a, 0x70,  //...%+ 
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 


  /*Unicode: U+003d (=) , Width: 4 */
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0xff, 0xff,  //@@@@ 
  0x22, 0x22,  //.... 
  0xff, 0xff,  //@@@@ 
  0x22, 0x22,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 


  /*Unicode: U+003e (>) , Width: 5 */
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 
  0x10, 0x00, 0x00,  //..... 
  0xf9, 0x20, 0x00,  //@%... 
  0x3b, 0xfb, 0x20,  //.%@%. 
  0x00, 0x9f, 0x70,  //..%@+ 
  0x7e, 0xe7, 0x10,  //+@@+. 
  0xd6, 0x00, 0x00,  //@+... 
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 


  /*Unicode: U+003f (?) , Width: 5 */
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 
  0x0b, 0xfa, 0x00,  //.%@%. 
  0x6e, 0x4f, 0x30,  //+@+@. 
  0x00, 0x8e, 0x00,  //..%@. 
  0x03, 0xf2, 0x00,  //..@.. 
  0x01, 0x80, 0x00,  //..%.. 
  0x02, 0xe0, 0x00,  //..@.. 
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 


  /*Unicode: U+0040 (@) , Width: 9 */
  0x00, 0x00, 0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //......... 
  0x00, 0x6d, 0xfd, 0x50, 0x00,  //..+@@@+.. 
  0x08, 0xff, 0xdf, 0xf5, 0x00,  //.%@@@@@+. 
  0x1f, 0xf7, 0x9f, 0x9e, 0x00,  //.@@+%@%@. 
  0x3f, 0xf1, 0x4f, 0x5f, 0x00,  //.@@.+@+@. 
  0x2f, 0xf8, 0xaf, 0x7e, 0x00,  //.@@%%@+@. 
  0x0c, 0xff, 0xba, 0xd5, 0x00,  //.@@@%%@+. 
  0x01, 0xbf, 0xf9, 0x00, 0x00,  //..%@@%... 
  0x00, 0x01, 0x10, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //......... 


  /*Unicode: U+0041 (A) , Width: 7 */
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x05, 0xdf, 0xd3, 0x00,  //.+@@@.. 
  0x1f, 0x83, 0xad, 0x00,  //.@%.%@. 
  0x3f, 0x10, 0x4f, 0x00,  //.@..+@. 
  0x4f, 0xff, 0xff, 0x10,  //+@@@@@. 
  0x4f, 0x32, 0x6f, 0x10,  //+@..+@. 
  0x4f, 0x10, 0x4f, 0x10,  //+@..+@. 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 


  /*Unicode: U+0042 (B) , Width: 7 */
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x4f, 0xff, 0x90, 0x00,  //+@@@%.. 
  0x4f, 0x38, 0xf0, 0x00,  //+@.%@.. 
  0x4f, 0xff, 0xf2, 0x00,  //+@@@@.. 
  0x4f, 0x33, 0x9e, 0x00,  //+@..%@. 
  0x4f, 0x32, 0x9f, 0x00,  //+@..%@. 
  0x4f, 0xff, 0xe6, 0x00,  //+@@@@+. 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 


  /*Unicode: U+0043 (C) , Width: 7 */
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x01, 0xaf, 0xfa, 0x10,  //..%@@%. 
  0x0c, 0xc4, 0x4b, 0x20,  //.@@++%. 
  0x3f, 0x20, 0x00, 0x00,  //.@..... 
  0x3f, 0x20, 0x00, 0x00,  //.@..... 
  0x0d, 0xc3, 0x4b, 0x20,  //.@@.+%. 
  0x01, 0xaf, 0xfa, 0x10,  //..%@@%. 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 


  /*Unicode: U+0044 (D) , Width: 7 */
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x4f, 0xfe, 0xa1, 0x00,  //+@@@%.. 
  0x4f, 0x34, 0xdb, 0x00,  //+@.+@%. 
  0x4f, 0x10, 0x5f, 0x00,  //+@..+@. 
  0x4f, 0x10, 0x5f, 0x00,  //+@..+@. 
  0x4f, 0x34, 0xdb, 0x00,  //+@.+@%. 
  0x4f, 0xfe, 0xa1, 0x00,  //+@@@%.. 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 


  /*Unicode: U+0045 (E) , Width: 5 */
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 
  0x0a, 0xfe, 0x60,  //.%@@+ 
  0x3f, 0x63, 0x20,  //.@+.. 
  0x0d, 0xff, 0x40,  //.@@@+ 
  0x2f, 0x62, 0x00,  //.@+.. 
  0x3f, 0x63, 0x60,  //.@+.+ 
  0x08, 0xff, 0xa0,  //.%@@% 
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 


  /*Unicode: U+0046 (F) , Width: 6 */
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x06, 0xef, 0xc0,  //.+@@@. 
  0x2f, 0x83, 0x50,  //.@%.+. 
  0x4f, 0x10, 0x00,  //+@.... 
  0x4f, 0xff, 0x20,  //+@@@.. 
  0x4f, 0x32, 0x00,  //+@.... 
  0x4f, 0x10, 0x00,  //+@.... 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 


  /*Unicode: U+0047 (G) , Width: 8 */
  0x00, 0x00, 0x00, 0x00,  //........ 
  0x00, 0x00, 0x00, 0x00,  //........ 
  0x00, 0x00, 0x00, 0x00,  //........ 
  0x01, 0x9e, 0xfc, 0x40,  //..%@@@+. 
  0x0c, 0xd4, 0x38, 0x20,  //.@@+.%.. 
  0x3f, 0x20, 0x00, 0x00,  //.@...... 
  0x3f, 0x20, 0x04, 0xf1,  //.@...+@. 
  0x0d, 0xc4, 0x3a, 0xf1,  //.@@+.%@. 
  0x01, 0xaf, 0xec, 0xf1,  //..%@@@@. 
  0x00, 0x00, 0x00, 0x00,  //........ 
  0x00, 0x00, 0x00, 0x00,  //........ 
  0x00, 0x00, 0x00, 0x00,  //........ 


  /*Unicode: U+0048 (H) , Width: 7 */
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x4f, 0x10, 0x4f, 0x10,  //+@..+@. 
  0x4f, 0x10, 0x4f, 0x10,  //+@..+@. 
  0x4f, 0xff, 0xff, 0x10,  //+@@@@@. 
  0x4f, 0x32, 0x6f, 0x10,  //+@..+@. 
  0x4f, 0x10, 0x4f, 0x10,  //+@..+@. 
  0x4f, 0x10, 0x4f, 0x10,  //+@..+@. 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 


  /*Unicode: U+0049 (I) , Width: 4 */
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0xff, 0xff,  //@@@@ 
  0x6f, 0x32,  //+@.. 
  0x4f, 0x10,  //+@.. 
  0x4f, 0x10,  //+@.. 
  0x6f, 0x32,  //+@.. 
  0xff, 0xff,  //@@@@ 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 


  /*Unicode: U+004a (J) , Width: 5 */
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 
  0x4f, 0xff, 0x10,  //+@@@. 
  0x02, 0x6f, 0x10,  //..+@. 
  0x00, 0x4f, 0x10,  //..+@. 
  0x00, 0x4f, 0x10,  //..+@. 
  0x00, 0x4f, 0x10,  //..+@. 
  0x61, 0x6f, 0x00,  //+.+@. 
  0xcf, 0xf7, 0x00,  //@@@+. 
  0x01, 0x10, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 


  /*Unicode: U+004b (K) , Width: 7 */
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x4f, 0x11, 0xeb, 0x00,  //+@..@%. 
  0x4f, 0x3d, 0xc0, 0x00,  //+@.@@.. 
  0x4f, 0xee, 0x00, 0x00,  //+@@@... 
  0x4f, 0xef, 0x50, 0x00,  //+@@@+.. 
  0x4f, 0x29, 0xf2, 0x00,  //+@.%@.. 
  0x4f, 0x10, 0xcc, 0x00,  //+@..@@. 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 


  /*Unicode: U+004c (L) , Width: 5 */
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 
  0x4f, 0x10, 0x00,  //+@... 
  0x4f, 0x10, 0x00,  //+@... 
  0x4f, 0x10, 0x00,  //+@... 
  0x4f, 0x10, 0x00,  //+@... 
  0x4f, 0x54, 0x30,  //+@++. 
  0x4f, 0xff, 0xc0,  //+@@@@ 
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 


  /*Unicode: U+004d (M) , Width: 9 */
  0x00, 0x00, 0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //......... 
  0x4f, 0xde, 0x5d, 0xe6, 0x00,  //+@@@+@@+. 
  0x4f, 0x79, 0xf7, 0x9f, 0x00,  //+@+%@+%@. 
  0x4f, 0x14, 0xf1, 0x4f, 0x10,  //+@.+@.+@. 
  0x4f, 0x14, 0xf1, 0x4f, 0x10,  //+@.+@.+@. 
  0x4f, 0x14, 0xf1, 0x4f, 0x10,  //+@.+@.+@. 
  0x4f, 0x14, 0xf1, 0x4f, 0x10,  //+@.+@.+@. 
  0x00, 0x00, 0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //......... 


  /*Unicode: U+004e (N) , Width: 7 */
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x4f, 0xcf, 0xd3, 0x00,  //+@@@@.. 
  0x4f, 0x93, 0xbe, 0x00,  //+@%.%@. 
  0x4f, 0x20, 0x4f, 0x10,  //+@..+@. 
  0x4f, 0x10, 0x4f, 0x10,  //+@..+@. 
  0x4f, 0x10, 0x4f, 0x10,  //+@..+@. 
  0x4f, 0x10, 0x4f, 0x10,  //+@..+@. 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 


  /*Unicode: U+004f (O) , Width: 8 */
  0x00, 0x00, 0x00, 0x00,  //........ 
  0x00, 0x00, 0x00, 0x00,  //........ 
  0x00, 0x00, 0x00, 0x00,  //........ 
  0x01, 0xaf, 0xe9, 0x00,  //..%@@%.. 
  0x0d, 0xc3, 0x4e, 0xa0,  //.@@.+@%. 
  0x3f, 0x20, 0x05, 0xf0,  //.@...+@. 
  0x3f, 0x20, 0x05, 0xf0,  //.@...+@. 
  0x0d, 0xc3, 0x4e, 0xa0,  //.@@.+@%. 
  0x01, 0xaf, 0xe9, 0x00,  //..%@@%.. 
  0x00, 0x00, 0x00, 0x00,  //........ 
  0x00, 0x00, 0x00, 0x00,  //........ 
  0x00, 0x00, 0x00, 0x00,  //........ 


  /*Unicode: U+0050 (P) , Width: 7 */
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x4f, 0xff, 0xd5, 0x00,  //+@@@@+. 
  0x4f, 0x33, 0x9f, 0x00,  //+@..%@. 
  0x4f, 0x10, 0x7f, 0x00,  //+@..+@. 
  0x4f, 0xff, 0xf7, 0x00,  //+@@@@+. 
  0x4f, 0x32, 0x00, 0x00,  //+@..... 
  0x4f, 0x10, 0x00, 0x00,  //+@..... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 


  /*Unicode: U+0051 (Q) , Width: 9 */
  0x00, 0x00, 0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //......... 
  0x00, 0x8e, 0xfd, 0x70, 0x00,  //..%@@@+.. 
  0x0b, 0xe5, 0x36, 0xf8, 0x00,  //.%@+.+@%. 
  0x2f, 0x30, 0x00, 0x6f, 0x00,  //.@....+@. 
  0x3f, 0x30, 0x00, 0x6f, 0x00,  //.@....+@. 
  0x0c, 0xd8, 0xf6, 0xe9, 0x00,  //.@@%@+@%. 
  0x01, 0x9f, 0xfe, 0x80, 0x00,  //..%@@@%.. 
  0x00, 0x04, 0xf1, 0x00, 0x00,  //...+@.... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //......... 


  /*Unicode: U+0052 (R) , Width: 7 */
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x4f, 0xff, 0xd6, 0x00,  //+@@@@+. 
  0x4f, 0x32, 0x9f, 0x00,  //+@..%@. 
  0x4f, 0x10, 0x7f, 0x00,  //+@..+@. 
  0x4f, 0xff, 0xf8, 0x00,  //+@@@@%. 
  0x4f, 0x38, 0xf5, 0x00,  //+@.%@+. 
  0x4f, 0x10, 0x9f, 0x20,  //+@..%@. 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 


  /*Unicode: U+0053 (S) , Width: 6 */
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x06, 0xef, 0xb1,  //.+@@%. 
  0x0f, 0x83, 0x80,  //.@%.%. 
  0x0c, 0xe8, 0x30,  //.@@%.. 
  0x00, 0x5a, 0xf4,  //..+%@+ 
  0x0b, 0x63, 0xd7,  //.%+.@+ 
  0x07, 0xef, 0xb1,  //.+@@%. 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 


  /*Unicode: U+0054 (T) , Width: 7 */
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x19, 0xef, 0xd8, 0x00,  //.%@@@%. 
  0x2b, 0x8f, 0x7b, 0x00,  //.%%@+%. 
  0x00, 0x4f, 0x10, 0x00,  //..+@... 
  0x00, 0x4f, 0x10, 0x00,  //..+@... 
  0x00, 0x4f, 0x10, 0x00,  //..+@... 
  0x00, 0x4f, 0x10, 0x00,  //..+@... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 


  /*Unicode: U+0055 (U) , Width: 7 */
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x4f, 0x10, 0x4f, 0x10,  //+@..+@. 
  0x4f, 0x10, 0x4f, 0x10,  //+@..+@. 
  0x4f, 0x10, 0x4f, 0x10,  //+@..+@. 
  0x4f, 0x10, 0x4f, 0x10,  //+@..+@. 
  0x1f, 0x83, 0xcf, 0x10,  //.@%.@@. 
  0x05, 0xef, 0xcf, 0x10,  //.+@@@@. 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 


  /*Unicode: U+0056 (V) , Width: 7 */
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0xdb, 0x00, 0x8f, 0x00,  //@%..%@. 
  0x6f, 0x20, 0xe9, 0x00,  //+@..@%. 
  0x0e, 0x85, 0xf2, 0x00,  //.@%+@.. 
  0x08, 0xec, 0xb0, 0x00,  //.%@@%.. 
  0x02, 0xff, 0x50, 0x00,  //..@@+.. 
  0x00, 0xbe, 0x00, 0x00,  //..%@... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 


  /*Unicode: U+0057 (W) , Width: 9 */
  0x00, 0x00, 0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //......... 
  0x4f, 0x14, 0xf1, 0x4f, 0x10,  //+@.+@.+@. 
  0x4f, 0x14, 0xf1, 0x4f, 0x10,  //+@.+@.+@. 
  0x4f, 0x14, 0xf1, 0x4f, 0x10,  //+@.+@.+@. 
  0x4f, 0x14, 0xf1, 0x4f, 0x10,  //+@.+@.+@. 
  0x2f, 0x8a, 0xf8, 0xaf, 0x00,  //.@%%@%%@. 
  0x08, 0xfd, 0x6e, 0xe5, 0x00,  //.%@@+@@+. 
  0x00, 0x00, 0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //......... 


  /*Unicode: U+0058 (X) , Width: 7 */
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x6f, 0x41, 0xea, 0x00,  //+@+.@%. 
  0x0b, 0xdb, 0xe1, 0x00,  //.%@%@.. 
  0x02, 0xff, 0x50, 0x00,  //..@@+.. 
  0x03, 0xff, 0x70, 0x00,  //..@@+.. 
  0x0d, 0xc9, 0xf2, 0x00,  //.@@%@.. 
  0x8f, 0x20, 0xdc, 0x00,  //%@..@@. 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 


  /*Unicode: U+0059 (Y) , Width: 7 */
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x4f, 0x10, 0x4f, 0x10,  //+@..+@. 
  0x4f, 0x10, 0x4f, 0x10,  //+@..+@. 
  0x4f, 0x10, 0x4f, 0x10,  //+@..+@. 
  0x1f, 0x71, 0xaf, 0x10,  //.@+.%@. 
  0x08, 0xff, 0xef, 0x00,  //.%@@@@. 
  0x18, 0x43, 0x8d, 0x00,  //.%+.%@. 
  0x0a, 0xff, 0xe3, 0x00,  //.%@@@.. 
  0x00, 0x12, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 


  /*Unicode: U+005a (Z) , Width: 5 */
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 
  0xff, 0xff, 0xf0,  //@@@@@ 
  0x22, 0x8f, 0x50,  //..%@+ 
  0xcf, 0xff, 0x80,  //@@@@% 
  0x3f, 0xa2, 0x10,  //.@%.. 
  0xaf, 0x42, 0x20,  //%@+.. 
  0xff, 0xff, 0xf0,  //@@@@@ 
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 


  /*Unicode: U+005b ([) , Width: 4 */
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x4f, 0xf3,  //+@@. 
  0x4f, 0x30,  //+@.. 
  0x4f, 0x10,  //+@.. 
  0x4f, 0x10,  //+@.. 
  0x4f, 0x10,  //+@.. 
  0x4f, 0x10,  //+@.. 
  0x4f, 0x10,  //+@.. 
  0x4f, 0xf3,  //+@@. 
  0x02, 0x20,  //.... 
  0x00, 0x00,  //.... 


  /*Unicode: U+005c (\) , Width: 5 */
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 
  0x8d, 0x00, 0x00,  //%@... 
  0x1f, 0x40, 0x00,  //.@+.. 
  0x09, 0xc0, 0x00,  //.%@.. 
  0x01, 0xf3, 0x00,  //..@.. 
  0x00, 0xab, 0x00,  //..%%. 
  0x00, 0x2f, 0x20,  //...@. 
  0x00, 0x0b, 0xa0,  //...%% 
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 


  /*Unicode: U+005d (]) , Width: 4 */
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x6f, 0xf1,  //+@@. 
  0x16, 0xf1,  //.+@. 
  0x04, 0xf1,  //.+@. 
  0x04, 0xf1,  //.+@. 
  0x04, 0xf1,  //.+@. 
  0x04, 0xf1,  //.+@. 
  0x04, 0xf1,  //.+@. 
  0x6f, 0xf1,  //+@@. 
  0x12, 0x20,  //.... 
  0x00, 0x00,  //.... 


  /*Unicode: U+005e (^) , Width: 4 */
  0x00, 0x00,  //.... 
  0x2d, 0xd7,  //.@@+ 
  0x11, 0x02,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 


  /*Unicode: U+005f (_) , Width: 6 */
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x6f, 0xff, 0xfd,  //+@@@@@ 
  0x12, 0x22, 0x22,  //...... 
  0x00, 0x00, 0x00,  //...... 


  /*Unicode: U+0060 (`) , Width: 3 */
  0x17, 0x00,  //.+. 
  0x1c, 0xa0,  //.@% 
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 


  /*Unicode: U+0061 (a) , Width: 7 */
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x04, 0xdf, 0xcf, 0x10,  //.+@@@@. 
  0x1f, 0x93, 0xbf, 0x10,  //.@%.%@. 
  0x3f, 0x20, 0x4f, 0x10,  //.@..+@. 
  0x1f, 0x93, 0xbf, 0x10,  //.@%.%@. 
  0x04, 0xdf, 0xcf, 0x10,  //.+@@@@. 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 


  /*Unicode: U+0062 (b) , Width: 7 */
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x4f, 0x10, 0x00, 0x00,  //+@..... 
  0x4f, 0x10, 0x00, 0x00,  //+@..... 
  0x4f, 0xbf, 0xd3, 0x00,  //+@%@@.. 
  0x4f, 0x93, 0xbd, 0x00,  //+@%.%@. 
  0x4f, 0x20, 0x4f, 0x00,  //+@..+@. 
  0x4f, 0x93, 0xbd, 0x00,  //+@%.%@. 
  0x4f, 0xaf, 0xc2, 0x00,  //+@%@@.. 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 


  /*Unicode: U+0063 (c) , Width: 6 */
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x04, 0xdf, 0xb1,  //.+@@%. 
  0x1f, 0x93, 0x80,  //.@%.%. 
  0x3f, 0x20, 0x00,  //.@.... 
  0x1f, 0x93, 0x91,  //.@%.%. 
  0x04, 0xdf, 0xa1,  //.+@@%. 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 


  /*Unicode: U+0064 (d) , Width: 7 */
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x4f, 0x10,  //....+@. 
  0x00, 0x00, 0x4f, 0x10,  //....+@. 
  0x05, 0xef, 0xbf, 0x10,  //.+@@%@. 
  0x1f, 0x93, 0xbf, 0x10,  //.@%.%@. 
  0x3f, 0x20, 0x4f, 0x10,  //.@..+@. 
  0x1f, 0x93, 0xbf, 0x10,  //.@%.%@. 
  0x04, 0xdf, 0xbf, 0x10,  //.+@@%@. 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 


  /*Unicode: U+0065 (e) , Width: 6 */
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x04, 0xdf, 0xb1,  //.+@@%. 
  0x1f, 0x84, 0xea,  //.@%+@% 
  0x3f, 0xae, 0xa3,  //.@%@%. 
  0x1f, 0xd4, 0x92,  //.@@+%. 
  0x04, 0xdf, 0xb1,  //.+@@%. 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 


  /*Unicode: U+0066 (f) , Width: 4 */
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x0a, 0xfa,  //.%@% 
  0x3f, 0x52,  //.@+. 
  0x4f, 0xf4,  //+@@+ 
  0x4f, 0x30,  //+@.. 
  0x4f, 0x10,  //+@.. 
  0x4f, 0x10,  //+@.. 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 


  /*Unicode: U+0067 (g) , Width: 6 */
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x07, 0xfc, 0xf1,  //.+@@@. 
  0x1f, 0x79, 0xf1,  //.@+%@. 
  0x3f, 0x14, 0xf1,  //.@.+@. 
  0x1f, 0x79, 0xf1,  //.@+%@. 
  0x07, 0xfd, 0xf0,  //.+@@@. 
  0x0c, 0x68, 0xd0,  //.@+%@. 
  0x06, 0xee, 0x40,  //.+@@+. 
  0x00, 0x00, 0x00,  //...... 


  /*Unicode: U+0068 (h) , Width: 6 */
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x4f, 0x10, 0x00,  //+@.... 
  0x4f, 0x10, 0x00,  //+@.... 
  0x4f, 0xbf, 0x70,  //+@%@+. 
  0x4f, 0x78, 0xf0,  //+@+%@. 
  0x4f, 0x14, 0xf1,  //+@.+@. 
  0x4f, 0x14, 0xf1,  //+@.+@. 
  0x4f, 0x14, 0xf1,  //+@.+@. 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 


  /*Unicode: U+0069 (i) , Width: 3 */
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 
  0x2e, 0x00,  //.@. 
  0x01, 0x00,  //... 
  0x4f, 0x10,  //+@. 
  0x4f, 0x10,  //+@. 
  0x4f, 0x10,  //+@. 
  0x4f, 0x10,  //+@. 
  0x4f, 0x10,  //+@. 
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 


  /*Unicode: U+006a (j) , Width: 3 */
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 
  0x2e, 0x00,  //.@. 
  0x01, 0x00,  //... 
  0x4f, 0x10,  //+@. 
  0x4f, 0x10,  //+@. 
  0x4f, 0x10,  //+@. 
  0x4f, 0x10,  //+@. 
  0x4f, 0x10,  //+@. 
  0x8f, 0x00,  //%@. 
  0xf8, 0x00,  //@%. 
  0x00, 0x00,  //... 


  /*Unicode: U+006b (k) , Width: 6 */
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x4f, 0x10, 0x00,  //+@.... 
  0x4f, 0x10, 0x00,  //+@.... 
  0x4f, 0x2c, 0xc0,  //+@.@@. 
  0x4f, 0xcd, 0x10,  //+@@@.. 
  0x4f, 0xfc, 0x00,  //+@@@.. 
  0x4f, 0x7f, 0x60,  //+@+@+. 
  0x4f, 0x18, 0xf1,  //+@.%@. 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 


  /*Unicode: U+006c (l) , Width: 4 */
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x4f, 0x10,  //+@.. 
  0x4f, 0x10,  //+@.. 
  0x4f, 0x10,  //+@.. 
  0x4f, 0x10,  //+@.. 
  0x3f, 0x52,  //.@+. 
  0x0b, 0xf6,  //.%@+ 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 


  /*Unicode: U+006d (m) , Width: 9 */
  0x00, 0x00, 0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //......... 
  0x4f, 0xcf, 0x6c, 0xf7, 0x00,  //+@@@+@@+. 
  0x4f, 0x78, 0xf7, 0x8f, 0x00,  //+@+%@+%@. 
  0x4f, 0x14, 0xf1, 0x4f, 0x10,  //+@.+@.+@. 
  0x4f, 0x14, 0xf1, 0x4f, 0x10,  //+@.+@.+@. 
  0x4f, 0x14, 0xf1, 0x4f, 0x10,  //+@.+@.+@. 
  0x00, 0x00, 0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //......... 


  /*Unicode: U+006e (n) , Width: 6 */
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x4f, 0xbf, 0x70,  //+@%@+. 
  0x4f, 0x78, 0xf0,  //+@+%@. 
  0x4f, 0x14, 0xf1,  //+@.+@. 
  0x4f, 0x14, 0xf1,  //+@.+@. 
  0x4f, 0x14, 0xf1,  //+@.+@. 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 


  /*Unicode: U+006f (o) , Width: 7 */
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x04, 0xdf, 0xc2, 0x00,  //.+@@@.. 
  0x1f, 0x93, 0xbd, 0x00,  //.@%.%@. 
  0x3f, 0x20, 0x4f, 0x00,  //.@..+@. 
  0x1f, 0x93, 0xbd, 0x00,  //.@%.%@. 
  0x04, 0xdf, 0xc2, 0x00,  //.+@@@.. 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 


  /*Unicode: U+0070 (p) , Width: 7 */
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x4f, 0xbf, 0xd2, 0x00,  //+@%@@.. 
  0x4f, 0x93, 0xbd, 0x00,  //+@%.%@. 
  0x4f, 0x20, 0x4f, 0x00,  //+@..+@. 
  0x4f, 0x93, 0xbd, 0x00,  //+@%.%@. 
  0x4f, 0xaf, 0xc2, 0x00,  //+@%@@.. 
  0x4f, 0x10, 0x00, 0x00,  //+@..... 
  0x4f, 0x10, 0x00, 0x00,  //+@..... 
  0x00, 0x00, 0x00, 0x00,  //....... 


  /*Unicode: U+0071 (q) , Width: 7 */
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00,  //....... 
  0x04, 0xdf, 0xbf, 0x10,  //.+@@%@. 
  0x1f, 0x93, 0xbf, 0x10,  //.@%.%@. 
  0x3f, 0x20, 0x4f, 0x10,  //.@..+@. 
  0x1f, 0x93, 0xbf, 0x10,  //.@%.%@. 
  0x04, 0xdf, 0xcf, 0x10,  //.+@@@@. 
  0x00, 0x00, 0x4f, 0x10,  //....+@. 
  0x00, 0x00, 0x4f, 0x10,  //....+@. 
  0x00, 0x00, 0x00, 0x00,  //....... 


  /*Unicode: U+0072 (r) , Width: 4 */
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x4f, 0xb8,  //+@%% 
  0x4f, 0x91,  //+@%. 
  0x4f, 0x20,  //+@.. 
  0x4f, 0x10,  //+@.. 
  0x4f, 0x10,  //+@.. 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 


  /*Unicode: U+0073 (s) , Width: 5 */
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 
  0x08, 0xfd, 0x20,  //.%@@. 
  0x0f, 0x65, 0x00,  //.@++. 
  0x05, 0xdc, 0x20,  //.+@@. 
  0x07, 0x3c, 0x70,  //.+.@+ 
  0x1a, 0xfd, 0x20,  //.%@@. 
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 


  /*Unicode: U+0074 (t) , Width: 4 */
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x4f, 0x10,  //+@.. 
  0x4f, 0xf4,  //+@@+ 
  0x4f, 0x30,  //+@.. 
  0x4f, 0x10,  //+@.. 
  0x3f, 0x52,  //.@+. 
  0x0b, 0xf6,  //.%@+ 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 


  /*Unicode: U+0075 (u) , Width: 6 */
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x4f, 0x14, 0xf1,  //+@.+@. 
  0x4f, 0x14, 0xf1,  //+@.+@. 
  0x4f, 0x14, 0xf1,  //+@.+@. 
  0x3f, 0x58, 0xf1,  //.@+%@. 
  0x0a, 0xfc, 0xf1,  //.%@@@. 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 


  /*Unicode: U+0076 (v) , Width: 6 */
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0xca, 0x05, 0xf1,  //@%.+@. 
  0x6f, 0x0b, 0xa0,  //+@.%%. 
  0x0f, 0x8f, 0x40,  //.@%@+. 
  0x0a, 0xfe, 0x00,  //.%@@.. 
  0x04, 0xf8, 0x00,  //.+@%.. 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 


  /*Unicode: U+0077 (w) , Width: 8 */
  0x00, 0x00, 0x00, 0x00,  //........ 
  0x00, 0x00, 0x00, 0x00,  //........ 
  0x00, 0x00, 0x00, 0x00,  //........ 
  0x00, 0x00, 0x00, 0x00,  //........ 
  0xba, 0x0b, 0xd0, 0x8d,  //%%.%@.%@ 
  0x6f, 0x1f, 0xf2, 0xd8,  //+@.@@.@% 
  0x1f, 0xaf, 0xda, 0xf2,  //.@%@@%@. 
  0x0b, 0xfa, 0x8f, 0xd0,  //.%@%%@@. 
  0x06, 0xf5, 0x3f, 0x80,  //.+@+.@%. 
  0x00, 0x00, 0x00, 0x00,  //........ 
  0x00, 0x00, 0x00, 0x00,  //........ 
  0x00, 0x00, 0x00, 0x00,  //........ 


  /*Unicode: U+0078 (x) , Width: 6 */
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x7f, 0x2c, 0xb0,  //+@.@%. 
  0x0c, 0xef, 0x10,  //.@@@.. 
  0x05, 0xf9, 0x00,  //.+@%.. 
  0x0d, 0xef, 0x20,  //.@@@.. 
  0x8e, 0x1c, 0xc0,  //%@.@@. 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 


  /*Unicode: U+0079 (y) , Width: 6 */
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00,  //...... 
  0x4f, 0x14, 0xf1,  //+@.+@. 
  0x4f, 0x14, 0xf1,  //+@.+@. 
  0x3f, 0x46, 0xf1,  //.@++@. 
  0x0d, 0xff, 0xf1,  //.@@@@. 
  0x04, 0x24, 0xf0,  //.+.+@. 
  0x4f, 0x4a, 0xd0,  //+@+%@. 
  0x08, 0xfd, 0x30,  //.%@@.. 
  0x00, 0x00, 0x00,  //...... 


  /*Unicode: U+007a (z) , Width: 4 */
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0xff, 0xff,  //@@@@ 
  0x26, 0xf9,  //.+@% 
  0xef, 0xfa,  //@@@% 
  0xce, 0x64,  //@@++ 
  0xff, 0xff,  //@@@@ 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 


  /*Unicode: U+007b ({) , Width: 3 */
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 
  0x0d, 0xa0,  //.@% 
  0x3f, 0x30,  //.@. 
  0x4f, 0x10,  //+@. 
  0x4f, 0x10,  //+@. 
  0xee, 0x00,  //@@. 
  0x6f, 0x10,  //+@. 
  0x4f, 0x10,  //+@. 
  0x2f, 0xa0,  //.@% 
  0x01, 0x10,  //... 
  0x00, 0x00,  //... 


  /*Unicode: U+007c (|) , Width: 3 */
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 
  0x4f, 0x10,  //+@. 
  0x4f, 0x10,  //+@. 
  0x4f, 0x10,  //+@. 
  0x4f, 0x10,  //+@. 
  0x4f, 0x10,  //+@. 
  0x4f, 0x10,  //+@. 
  0x4f, 0x10,  //+@. 
  0x4f, 0x10,  //+@. 
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 


  /*Unicode: U+007d (}) , Width: 3 */
  0x00, 0x00,  //... 
  0x00, 0x00,  //... 
  0xdb, 0x00,  //@%. 
  0x6f, 0x10,  //+@. 
  0x4f, 0x10,  //+@. 
  0x4f, 0x10,  //+@. 
  0x1f, 0xb0,  //.@% 
  0x4f, 0x30,  //+@. 
  0x4f, 0x10,  //+@. 
  0xde, 0x00,  //@@. 
  0x20, 0x00,  //... 
  0x00, 0x00,  //... 


  /*Unicode: U+007e (~) , Width: 5 */
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 
  0x5e, 0x77, 0x60,  //+@+++ 
  0xa8, 0xbf, 0x40,  //%%%@+ 
  0x00, 0x01, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00,  //..... 


  /*Unicode: U+007f () , Width: 4 */
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 
  0x00, 0x00,  //.... 



#elif USE_MABOLT_12 == 8
  /*Unicode: U+0020 ( ) , Width: 4 */
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 


  /*Unicode: U+0021 (!) , Width: 3 */
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 
  0x42, 0xff, 0x16,  //+@. 
  0x3a, 0xff, 0x0c,  //.@. 
  0x26, 0xf8, 0x00,  //.@. 
  0x14, 0xe4, 0x00,  //.@. 
  0x00, 0x1a, 0x00,  //... 
  0x28, 0xea, 0x06,  //.@. 
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 


  /*Unicode: U+0022 (") , Width: 4 */
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x42, 0xff, 0xff, 0x12,  //+@@. 
  0x42, 0xff, 0xff, 0x12,  //+@@. 
  0x08, 0x26, 0x26, 0x02,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 


  /*Unicode: U+0023 (#) , Width: 7 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x06, 0xf8, 0x58, 0xd4, 0x84, 0x00,  //..@+@%. 
  0x28, 0xff, 0xff, 0xff, 0xff, 0xff, 0x3a,  //.@@@@@. 
  0x0a, 0x86, 0xee, 0x62, 0xff, 0x3e, 0x02,  //.%@+@.. 
  0x74, 0xfc, 0xff, 0xfc, 0xff, 0xe6, 0x00,  //+@@@@@. 
  0x18, 0xd2, 0xa2, 0xac, 0xc4, 0x22, 0x00,  //.@%%@.. 
  0x00, 0xe6, 0x72, 0xba, 0x9a, 0x00, 0x00,  //.@+%%.. 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 


  /*Unicode: U+0024 ($) , Width: 6 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x18, 0x94, 0xff, 0x68, 0x02,  //..%@+. 
  0x0e, 0xe6, 0xf8, 0xff, 0xfa, 0x70,  //.@@@@+ 
  0x3a, 0xff, 0xb8, 0xff, 0x38, 0x0c,  //.@%@.. 
  0x0c, 0xe0, 0xff, 0xff, 0x90, 0x0a,  //.@@@%. 
  0x00, 0x0c, 0x86, 0xff, 0xf4, 0x8e,  //..%@@% 
  0x18, 0xae, 0x70, 0xff, 0xa8, 0xae,  //.%+@%% 
  0x32, 0xda, 0xff, 0xff, 0xfc, 0x56,  //.@@@@+ 
  0x00, 0x02, 0x6a, 0xff, 0x3c, 0x00,  //..+@.. 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 


  /*Unicode: U+0025 (%) , Width: 6 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0xb0, 0xec, 0x3c, 0x0a, 0xd8, 0x8c,  //%@..@% 
  0xe4, 0xff, 0x54, 0xa2, 0xca, 0x04,  //@@+%@. 
  0x08, 0x1a, 0x5e, 0xf0, 0x22, 0x00,  //..+@.. 
  0x00, 0x26, 0xf2, 0x7e, 0xca, 0x84,  //..@+@% 
  0x06, 0xce, 0x9c, 0x74, 0x7a, 0xf4,  //.@%++@ 
  0x94, 0xd6, 0x0a, 0x2e, 0xe8, 0x9a,  //%@..@% 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 


  /*Unicode: U+0026 (&) , Width: 7 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x24, 0xcc, 0xf4, 0xb0, 0x06, 0x00,  //..@@%.. 
  0x00, 0x76, 0xf2, 0x5c, 0xff, 0x2c, 0x00,  //.+@+@.. 
  0x00, 0x2e, 0xfc, 0xf0, 0x84, 0x00, 0x00,  //..@@%.. 
  0x0c, 0xda, 0xaa, 0xea, 0xa2, 0xbe, 0x00,  //.@%@%%. 
  0x36, 0xff, 0x5e, 0x78, 0xff, 0xca, 0x00,  //.@++@@. 
  0x00, 0x90, 0xee, 0xee, 0x94, 0xe0, 0x34,  //.%@@%@. 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x06, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 


  /*Unicode: U+0027 (') , Width: 3 */
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 
  0x42, 0xff, 0x16,  //+@. 
  0x42, 0xff, 0x16,  //+@. 
  0x08, 0x26, 0x02,  //... 
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 


  /*Unicode: U+0028 (() , Width: 4 */
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x5a, 0xf6, 0x1e,  //.+@. 
  0x00, 0xc8, 0xa0, 0x00,  //.@%. 
  0x12, 0xfc, 0x4e, 0x00,  //.@+. 
  0x38, 0xff, 0x22, 0x00,  //.@.. 
  0x38, 0xff, 0x22, 0x00,  //.@.. 
  0x12, 0xfc, 0x4e, 0x00,  //.@+. 
  0x00, 0xc8, 0x9e, 0x00,  //.@%. 
  0x00, 0x5a, 0xf6, 0x1e,  //.+@. 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 


  /*Unicode: U+0029 ()) , Width: 4 */
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x44, 0xfc, 0x30, 0x00,  //+@.. 
  0x00, 0xcc, 0x9c, 0x00,  //.@%. 
  0x00, 0x7a, 0xe4, 0x00,  //.+@. 
  0x00, 0x4e, 0xff, 0x0a,  //.+@. 
  0x00, 0x4e, 0xff, 0x0c,  //.+@. 
  0x00, 0x7a, 0xe4, 0x00,  //.+@. 
  0x00, 0xca, 0x9c, 0x00,  //.@%. 
  0x44, 0xfc, 0x30, 0x00,  //+@.. 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 


  /*Unicode: U+002a (*) , Width: 4 */
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x26, 0xae, 0xba, 0x36,  //.%%. 
  0x3c, 0xf6, 0xfa, 0x50,  //.@@+ 
  0x26, 0xb0, 0xba, 0x36,  //.%%. 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 


  /*Unicode: U+002b (+) , Width: 4 */
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x42, 0xff, 0x12,  //.+@. 
  0xfa, 0xfc, 0xff, 0xfa,  //@@@@ 
  0x2a, 0x62, 0xff, 0x3a,  //.+@. 
  0x00, 0x42, 0xff, 0x12,  //.+@. 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 


  /*Unicode: U+002c (,) , Width: 3 */
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 
  0x00, 0x14, 0x00,  //... 
  0x30, 0xfa, 0x08,  //.@. 
  0x22, 0xb2, 0x00,  //.%. 
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 


  /*Unicode: U+002d (-) , Width: 3 */
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 
  0xff, 0xff, 0xff,  //@@@ 
  0x2a, 0x2a, 0x2a,  //... 
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 


  /*Unicode: U+002e (.) , Width: 3 */
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 
  0x00, 0x18, 0x00,  //... 
  0x28, 0xe8, 0x06,  //.@. 
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 


  /*Unicode: U+002f (/) , Width: 6 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x0a, 0x7e, 0x16,  //....+. 
  0x00, 0x00, 0x00, 0x6c, 0xd6, 0x00,  //...+@. 
  0x00, 0x00, 0x00, 0xda, 0x66, 0x00,  //...@+. 
  0x00, 0x00, 0x4e, 0xea, 0x08, 0x00,  //..+@.. 
  0x00, 0x00, 0xc0, 0x82, 0x00, 0x00,  //..@%.. 
  0x00, 0x32, 0xf8, 0x16, 0x00, 0x00,  //..@... 
  0x00, 0xa4, 0x9e, 0x00, 0x00, 0x00,  //.%%... 
  0x1a, 0xf8, 0x2c, 0x00, 0x00, 0x00,  //.@.... 
  0x86, 0xba, 0x00, 0x00, 0x00, 0x00,  //%%.... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 


  /*Unicode: U+0030 (0) , Width: 7 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x38, 0xd0, 0xf4, 0xbc, 0x1c, 0x00,  //..@@%.. 
  0x06, 0xe8, 0xa6, 0x34, 0xc6, 0xbc, 0x00,  //.@%.@%. 
  0x36, 0xff, 0x28, 0x00, 0x54, 0xfc, 0x08,  //.@..+@. 
  0x38, 0xff, 0x28, 0x00, 0x56, 0xfc, 0x08,  //.@..+@. 
  0x08, 0xea, 0xa6, 0x34, 0xc6, 0xc0, 0x00,  //.@%.@@. 
  0x00, 0x3e, 0xd4, 0xf8, 0xc2, 0x20, 0x00,  //..@@@.. 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 


  /*Unicode: U+0031 (1) , Width: 4 */
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x70, 0xfa, 0xfa, 0x16,  //+@@. 
  0x12, 0x62, 0xff, 0x16,  //.+@. 
  0x00, 0x42, 0xff, 0x16,  //.+@. 
  0x00, 0x42, 0xff, 0x16,  //.+@. 
  0x00, 0x42, 0xff, 0x16,  //.+@. 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 


  /*Unicode: U+0032 (2) , Width: 5 */
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x5c, 0xde, 0xe8, 0x6a,  //.+@@+ 
  0x08, 0xd8, 0x78, 0x6c, 0xf2,  //.@++@ 
  0x00, 0x08, 0x00, 0xa2, 0xce,  //...%@ 
  0x00, 0x00, 0x8e, 0xf0, 0x30,  //..%@. 
  0x00, 0x7e, 0xfa, 0x64, 0x2a,  //.+@+. 
  0x00, 0xff, 0xff, 0xff, 0xff,  //.@@@@ 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 


  /*Unicode: U+0033 (3) , Width: 6 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0xfa, 0xfa, 0xfa, 0xfa, 0x00,  //.@@@@. 
  0x00, 0x2a, 0x84, 0xfc, 0x6c, 0x00,  //..%@+. 
  0x00, 0x24, 0xf6, 0xd8, 0x2c, 0x00,  //..@@.. 
  0x00, 0x20, 0x6c, 0xbc, 0xe6, 0x00,  //..+%@. 
  0x00, 0x60, 0x0c, 0x6a, 0xfa, 0x08,  //.+.+@. 
  0x22, 0xe2, 0xff, 0xfa, 0x7a, 0x00,  //.@@@+. 
  0x00, 0x00, 0x24, 0x10, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 


  /*Unicode: U+0034 (4) , Width: 5 */
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x5e, 0x66, 0x00,  //..++. 
  0x00, 0x3e, 0xfc, 0x54, 0x00,  //..@+. 
  0x0a, 0xdc, 0xb2, 0x00, 0x00,  //.@%.. 
  0x94, 0xf2, 0x64, 0xff, 0x16,  //%@+@. 
  0xfc, 0xff, 0xff, 0xff, 0xff,  //@@@@@ 
  0x32, 0x32, 0x68, 0xff, 0x42,  //..+@+ 
  0x00, 0x00, 0x42, 0xff, 0x12,  //..+@. 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 


  /*Unicode: U+0035 (5) , Width: 6 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x40, 0xfa, 0xfa, 0xfa, 0xb4, 0x00,  //+@@@%. 
  0x42, 0xff, 0x3e, 0x2a, 0x1e, 0x00,  //+@.... 
  0x40, 0xff, 0xf4, 0xdc, 0x4e, 0x00,  //+@@@+. 
  0x02, 0x60, 0x34, 0x9c, 0xf2, 0x04,  //.+.%@. 
  0x16, 0x74, 0x0c, 0x72, 0xf6, 0x06,  //.+.+@. 
  0x44, 0xec, 0xff, 0xf6, 0x64, 0x00,  //+@@@+. 
  0x00, 0x04, 0x24, 0x0c, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 


  /*Unicode: U+0036 (6) , Width: 6 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x50, 0xe4, 0xf0, 0x7c, 0x00,  //.+@@+. 
  0x0a, 0xf2, 0x74, 0x40, 0x3a, 0x00,  //.@++.. 
  0x38, 0xff, 0xd6, 0xec, 0x68, 0x00,  //.@@@+. 
  0x3a, 0xff, 0x64, 0x88, 0xf6, 0x06,  //.@+%@. 
  0x0c, 0xf6, 0x66, 0x88, 0xf6, 0x06,  //.@+%@. 
  0x00, 0x60, 0xea, 0xec, 0x62, 0x00,  //.+@@+. 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 


  /*Unicode: U+0037 (7) , Width: 5 */
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0xff, 0xff, 0xff, 0xff, 0x7e,  //@@@@+ 
  0xff, 0x68, 0x70, 0xff, 0x42,  //@++@+ 
  0x00, 0x00, 0xc2, 0xc6, 0x00,  //..@@. 
  0x00, 0x3e, 0xff, 0x48, 0x00,  //..@+. 
  0x00, 0xb8, 0xca, 0x00, 0x00,  //.%@.. 
  0x34, 0xff, 0x4e, 0x00, 0x00,  //.@+.. 
  0x14, 0x2a, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 


  /*Unicode: U+0038 (8) , Width: 6 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x06, 0xa0, 0xf2, 0xea, 0x80, 0x00,  //.%@@%. 
  0x32, 0xff, 0x64, 0x88, 0xfa, 0x08,  //.@+%@. 
  0x00, 0xc6, 0xff, 0xff, 0xaa, 0x00,  //.@@@%. 
  0x2c, 0xff, 0x64, 0x88, 0xf8, 0x04,  //.@+%@. 
  0x2c, 0xff, 0x64, 0x88, 0xf4, 0x04,  //.@+%@. 
  0x00, 0x82, 0xf2, 0xe6, 0x5a, 0x00,  //.%@@+. 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 


  /*Unicode: U+0039 (9) , Width: 6 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x82, 0xee, 0xd8, 0x38, 0x00,  //.%@@.. 
  0x28, 0xff, 0x66, 0x90, 0xd0, 0x00,  //.@+%@. 
  0x36, 0xff, 0x3a, 0x68, 0xff, 0x08,  //.@.+@. 
  0x02, 0xbc, 0xff, 0xf4, 0xff, 0x0a,  //.%@@@. 
  0x00, 0x28, 0x2e, 0x7e, 0xd6, 0x00,  //...+@. 
  0x00, 0xc6, 0xff, 0xf2, 0x48, 0x00,  //.@@@+. 
  0x00, 0x00, 0x22, 0x0a, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 


  /*Unicode: U+003a (:) , Width: 3 */
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 
  0x28, 0xe6, 0x06,  //.@. 
  0x00, 0x1a, 0x00,  //... 
  0x00, 0x1a, 0x00,  //... 
  0x28, 0xea, 0x06,  //.@. 
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 


  /*Unicode: U+003b (;) , Width: 3 */
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 
  0x28, 0xe6, 0x06,  //.@. 
  0x00, 0x1a, 0x00,  //... 
  0x00, 0x14, 0x00,  //... 
  0x30, 0xfa, 0x08,  //.@. 
  0x22, 0xb0, 0x00,  //.%. 
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 


  /*Unicode: U+003c (<) , Width: 5 */
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x1a,  //..... 
  0x00, 0x06, 0x64, 0xd8, 0x7e,  //..+@+ 
  0x76, 0xe6, 0xe6, 0x78, 0x0e,  //+@@+. 
  0xff, 0xe4, 0x32, 0x00, 0x00,  //@@... 
  0x3e, 0xb6, 0xfc, 0xb2, 0x2a,  //.%@%. 
  0x00, 0x00, 0x2c, 0xa4, 0x7a,  //...%+ 
  0x00, 0x00, 0x00, 0x00, 0x02,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 


  /*Unicode: U+003d (=) , Width: 4 */
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0xff, 0xff, 0xff, 0xff,  //@@@@ 
  0x2a, 0x2a, 0x2a, 0x2a,  //.... 
  0xfa, 0xfa, 0xfa, 0xfa,  //@@@@ 
  0x2a, 0x2a, 0x2a, 0x2a,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 


  /*Unicode: U+003e (>) , Width: 5 */
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x1c, 0x00, 0x00, 0x00, 0x00,  //..... 
  0xf8, 0x9e, 0x2a, 0x00, 0x00,  //@%... 
  0x3e, 0xb2, 0xfc, 0xb0, 0x2a,  //.%@%. 
  0x00, 0x06, 0x90, 0xff, 0x7e,  //..%@+ 
  0x76, 0xe6, 0xe8, 0x7a, 0x10,  //+@@+. 
  0xdc, 0x68, 0x06, 0x00, 0x00,  //@+... 
  0x02, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 


  /*Unicode: U+003f (?) , Width: 5 */
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x0c, 0xbe, 0xf6, 0xa8, 0x02,  //.%@%. 
  0x66, 0xe0, 0x4e, 0xff, 0x32,  //+@+@. 
  0x00, 0x00, 0x80, 0xe4, 0x0c,  //..%@. 
  0x00, 0x32, 0xff, 0x2a, 0x00,  //..@.. 
  0x00, 0x1e, 0x8e, 0x00, 0x00,  //..%.. 
  0x00, 0x28, 0xe8, 0x06, 0x00,  //..@.. 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 


  /*Unicode: U+0040 (@) , Width: 9 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x68, 0xd6, 0xf4, 0xd2, 0x58, 0x00, 0x00,  //..+@@@+.. 
  0x00, 0x82, 0xff, 0xff, 0xde, 0xff, 0xff, 0x5e, 0x00,  //.%@@@@@+. 
  0x12, 0xf8, 0xff, 0x72, 0x9c, 0xff, 0x96, 0xe0, 0x00,  //.@@+%@%@. 
  0x3c, 0xff, 0xff, 0x1a, 0x4a, 0xff, 0x5e, 0xff, 0x0c,  //.@@.+@+@. 
  0x26, 0xff, 0xff, 0x8a, 0xac, 0xff, 0x74, 0xee, 0x02,  //.@@%%@+@. 
  0x00, 0xc4, 0xff, 0xff, 0xb0, 0xaa, 0xd8, 0x58, 0x00,  //.@@@%%@+. 
  0x00, 0x18, 0xbc, 0xff, 0xff, 0x96, 0x00, 0x00, 0x00,  //..%@@%... 
  0x00, 0x00, 0x00, 0x16, 0x18, 0x00, 0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //......... 


  /*Unicode: U+0041 (A) , Width: 7 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x56, 0xde, 0xfa, 0xd0, 0x36, 0x00,  //.+@@@.. 
  0x14, 0xf8, 0x86, 0x34, 0xac, 0xde, 0x00,  //.@%.%@. 
  0x3e, 0xff, 0x18, 0x00, 0x46, 0xff, 0x0e,  //.@..+@. 
  0x42, 0xff, 0xfa, 0xfa, 0xfc, 0xff, 0x12,  //+@@@@@. 
  0x42, 0xff, 0x3e, 0x2a, 0x62, 0xff, 0x12,  //+@..+@. 
  0x42, 0xff, 0x16, 0x00, 0x42, 0xff, 0x12,  //+@..+@. 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 


  /*Unicode: U+0042 (B) , Width: 7 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x42, 0xff, 0xff, 0xf4, 0x98, 0x00, 0x00,  //+@@@%.. 
  0x42, 0xff, 0x3e, 0x82, 0xff, 0x0a, 0x00,  //+@.%@.. 
  0x42, 0xff, 0xfa, 0xff, 0xf2, 0x24, 0x00,  //+@@@@.. 
  0x42, 0xff, 0x3e, 0x30, 0x90, 0xe6, 0x00,  //+@..%@. 
  0x42, 0xff, 0x3e, 0x2e, 0x92, 0xf6, 0x04,  //+@..%@. 
  0x42, 0xff, 0xff, 0xff, 0xe6, 0x64, 0x00,  //+@@@@+. 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 


  /*Unicode: U+0043 (C) , Width: 7 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x16, 0xa8, 0xf0, 0xf0, 0xa8, 0x1a,  //..%@@%. 
  0x00, 0xce, 0xca, 0x40, 0x40, 0xb0, 0x2a,  //.@@++%. 
  0x32, 0xff, 0x2c, 0x00, 0x00, 0x00, 0x00,  //.@..... 
  0x34, 0xff, 0x2c, 0x00, 0x00, 0x00, 0x00,  //.@..... 
  0x02, 0xd2, 0xc6, 0x3c, 0x44, 0xb4, 0x26,  //.@@.+%. 
  0x00, 0x1a, 0xac, 0xf2, 0xf0, 0xa0, 0x10,  //..%@@%. 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 


  /*Unicode: U+0044 (D) , Width: 7 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x42, 0xff, 0xff, 0xee, 0xa8, 0x16, 0x00,  //+@@@%.. 
  0x42, 0xff, 0x3e, 0x44, 0xd6, 0xba, 0x00,  //+@.+@%. 
  0x42, 0xff, 0x16, 0x00, 0x5a, 0xfc, 0x08,  //+@..+@. 
  0x42, 0xff, 0x16, 0x00, 0x56, 0xfc, 0x06,  //+@..+@. 
  0x42, 0xff, 0x3e, 0x46, 0xd4, 0xb6, 0x00,  //+@.+@%. 
  0x42, 0xff, 0xff, 0xec, 0xa6, 0x14, 0x00,  //+@@@%.. 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 


  /*Unicode: U+0045 (E) , Width: 5 */
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x06, 0xa6, 0xf2, 0xee, 0x6e,  //.%@@+ 
  0x36, 0xff, 0x62, 0x3a, 0x28,  //.@+.. 
  0x00, 0xd2, 0xff, 0xfa, 0x48,  //.@@@+ 
  0x2a, 0xff, 0x6c, 0x2c, 0x0c,  //.@+.. 
  0x30, 0xff, 0x64, 0x3a, 0x62,  //.@+.+ 
  0x00, 0x8c, 0xf0, 0xf0, 0xa2,  //.%@@% 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 


  /*Unicode: U+0046 (F) , Width: 6 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x6c, 0xe8, 0xf8, 0xce, 0x04,  //.+@@@. 
  0x20, 0xfc, 0x82, 0x34, 0x5e, 0x00,  //.@%.+. 
  0x40, 0xff, 0x18, 0x00, 0x00, 0x00,  //+@.... 
  0x42, 0xff, 0xfa, 0xfa, 0x2a, 0x00,  //+@@@.. 
  0x42, 0xff, 0x3e, 0x2a, 0x06, 0x00,  //+@.... 
  0x42, 0xff, 0x16, 0x00, 0x00, 0x00,  //+@.... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 


  /*Unicode: U+0047 (G) , Width: 8 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //........ 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //........ 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //........ 
  0x00, 0x10, 0x98, 0xea, 0xf8, 0xca, 0x46, 0x00,  //..%@@@+. 
  0x00, 0xc6, 0xd0, 0x48, 0x34, 0x82, 0x2e, 0x00,  //.@@+.%.. 
  0x30, 0xff, 0x2e, 0x00, 0x00, 0x00, 0x00, 0x00,  //.@...... 
  0x34, 0xff, 0x2c, 0x00, 0x00, 0x42, 0xff, 0x12,  //.@...+@. 
  0x02, 0xd2, 0xcc, 0x48, 0x36, 0xa6, 0xff, 0x12,  //.@@+.%@. 
  0x00, 0x16, 0xa6, 0xf2, 0xee, 0xc8, 0xff, 0x12,  //..%@@@@. 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //........ 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //........ 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //........ 


  /*Unicode: U+0048 (H) , Width: 7 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x42, 0xff, 0x16, 0x00, 0x42, 0xff, 0x12,  //+@..+@. 
  0x42, 0xff, 0x16, 0x00, 0x42, 0xff, 0x12,  //+@..+@. 
  0x42, 0xff, 0xfa, 0xfa, 0xfc, 0xff, 0x12,  //+@@@@@. 
  0x42, 0xff, 0x3e, 0x2a, 0x62, 0xff, 0x12,  //+@..+@. 
  0x42, 0xff, 0x16, 0x00, 0x42, 0xff, 0x12,  //+@..+@. 
  0x42, 0xff, 0x16, 0x00, 0x42, 0xff, 0x12,  //+@..+@. 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 


  /*Unicode: U+0049 (I) , Width: 4 */
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0xff, 0xff, 0xff, 0xff,  //@@@@ 
  0x62, 0xff, 0x3a, 0x2a,  //+@.. 
  0x42, 0xff, 0x12, 0x00,  //+@.. 
  0x42, 0xff, 0x12, 0x00,  //+@.. 
  0x62, 0xff, 0x3a, 0x2a,  //+@.. 
  0xff, 0xff, 0xff, 0xff,  //@@@@ 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 


  /*Unicode: U+004a (J) , Width: 5 */
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x4a, 0xff, 0xff, 0xff, 0x16,  //+@@@. 
  0x0c, 0x2a, 0x62, 0xff, 0x16,  //..+@. 
  0x00, 0x00, 0x42, 0xff, 0x16,  //..+@. 
  0x00, 0x00, 0x42, 0xff, 0x16,  //..+@. 
  0x00, 0x00, 0x42, 0xff, 0x16,  //..+@. 
  0x66, 0x10, 0x6e, 0xfa, 0x08,  //+.+@. 
  0xcc, 0xff, 0xfc, 0x7e, 0x00,  //@@@+. 
  0x00, 0x1e, 0x14, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 


  /*Unicode: U+004b (K) , Width: 7 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x42, 0xff, 0x16, 0x1e, 0xe0, 0xb6, 0x04,  //+@..@%. 
  0x42, 0xff, 0x32, 0xdc, 0xc0, 0x08, 0x00,  //+@.@@.. 
  0x42, 0xff, 0xe4, 0xe4, 0x0c, 0x00, 0x00,  //+@@@... 
  0x42, 0xff, 0xe0, 0xff, 0x56, 0x00, 0x00,  //+@@@+.. 
  0x42, 0xff, 0x20, 0x94, 0xf0, 0x24, 0x00,  //+@.%@.. 
  0x42, 0xff, 0x16, 0x04, 0xc8, 0xce, 0x06,  //+@..@@. 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 


  /*Unicode: U+004c (L) , Width: 5 */
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x42, 0xff, 0x16, 0x00, 0x00,  //+@... 
  0x42, 0xff, 0x16, 0x00, 0x00,  //+@... 
  0x42, 0xff, 0x16, 0x00, 0x00,  //+@... 
  0x42, 0xff, 0x16, 0x00, 0x00,  //+@... 
  0x42, 0xff, 0x54, 0x42, 0x34,  //+@++. 
  0x42, 0xff, 0xff, 0xff, 0xc6,  //+@@@@ 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 


  /*Unicode: U+004d (M) , Width: 9 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //......... 
  0x42, 0xff, 0xd2, 0xe6, 0x5c, 0xde, 0xee, 0x60, 0x00,  //+@@@+@@+. 
  0x42, 0xff, 0x76, 0x92, 0xff, 0x70, 0x92, 0xf0, 0x02,  //+@+%@+%@. 
  0x42, 0xff, 0x18, 0x46, 0xff, 0x14, 0x44, 0xff, 0x12,  //+@.+@.+@. 
  0x42, 0xff, 0x16, 0x42, 0xff, 0x12, 0x42, 0xff, 0x12,  //+@.+@.+@. 
  0x42, 0xff, 0x16, 0x42, 0xff, 0x12, 0x42, 0xff, 0x12,  //+@.+@.+@. 
  0x42, 0xff, 0x16, 0x42, 0xff, 0x12, 0x42, 0xff, 0x12,  //+@.+@.+@. 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //......... 


  /*Unicode: U+004e (N) , Width: 7 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x42, 0xff, 0xc2, 0xf8, 0xd2, 0x38, 0x00,  //+@@@@.. 
  0x42, 0xff, 0x9e, 0x36, 0xb0, 0xe0, 0x00,  //+@%.%@. 
  0x42, 0xff, 0x20, 0x00, 0x4a, 0xff, 0x10,  //+@..+@. 
  0x42, 0xff, 0x16, 0x00, 0x42, 0xff, 0x12,  //+@..+@. 
  0x42, 0xff, 0x16, 0x00, 0x42, 0xff, 0x12,  //+@..+@. 
  0x42, 0xff, 0x16, 0x00, 0x42, 0xff, 0x12,  //+@..+@. 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 


  /*Unicode: U+004f (O) , Width: 8 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //........ 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //........ 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //........ 
  0x00, 0x18, 0xac, 0xf4, 0xec, 0x94, 0x08, 0x00,  //..%@@%.. 
  0x02, 0xd0, 0xc8, 0x3c, 0x4a, 0xe0, 0xa2, 0x00,  //.@@.+@%. 
  0x32, 0xff, 0x2e, 0x00, 0x00, 0x5a, 0xfa, 0x06,  //.@...+@. 
  0x32, 0xff, 0x2e, 0x00, 0x00, 0x5a, 0xfa, 0x06,  //.@...+@. 
  0x02, 0xd0, 0xc8, 0x3c, 0x4a, 0xe0, 0xa2, 0x00,  //.@@.+@%. 
  0x00, 0x18, 0xac, 0xf4, 0xee, 0x94, 0x08, 0x00,  //..%@@%.. 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //........ 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //........ 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //........ 


  /*Unicode: U+0050 (P) , Width: 7 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x42, 0xff, 0xff, 0xf8, 0xd4, 0x54, 0x00,  //+@@@@+. 
  0x42, 0xff, 0x3e, 0x32, 0x9c, 0xf4, 0x04,  //+@..%@. 
  0x42, 0xff, 0x16, 0x00, 0x76, 0xfa, 0x08,  //+@..+@. 
  0x42, 0xff, 0xfa, 0xfc, 0xf6, 0x7a, 0x00,  //+@@@@+. 
  0x42, 0xff, 0x3e, 0x24, 0x06, 0x00, 0x00,  //+@..... 
  0x42, 0xff, 0x16, 0x00, 0x00, 0x00, 0x00,  //+@..... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 


  /*Unicode: U+0051 (Q) , Width: 9 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //......... 
  0x00, 0x0a, 0x8c, 0xe4, 0xf8, 0xda, 0x72, 0x00, 0x00,  //..%@@@+.. 
  0x00, 0xbc, 0xe0, 0x56, 0x30, 0x68, 0xf0, 0x8e, 0x00,  //.%@+.+@%. 
  0x2e, 0xff, 0x3a, 0x00, 0x00, 0x00, 0x66, 0xf6, 0x04,  //.@....+@. 
  0x32, 0xff, 0x34, 0x00, 0x00, 0x00, 0x62, 0xfa, 0x06,  //.@....+@. 
  0x00, 0xc8, 0xd6, 0x80, 0xff, 0x6e, 0xec, 0x9a, 0x00,  //.@@%@+@%. 
  0x00, 0x10, 0x9c, 0xf2, 0xff, 0xe8, 0x82, 0x04, 0x00,  //..%@@@%.. 
  0x00, 0x00, 0x00, 0x42, 0xff, 0x12, 0x00, 0x00, 0x00,  //...+@.... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //......... 


  /*Unicode: U+0052 (R) , Width: 7 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x42, 0xff, 0xff, 0xfa, 0xdc, 0x62, 0x00,  //+@@@@+. 
  0x42, 0xff, 0x3e, 0x2e, 0x92, 0xf8, 0x06,  //+@..%@. 
  0x42, 0xff, 0x16, 0x00, 0x74, 0xfa, 0x06,  //+@..+@. 
  0x42, 0xff, 0xfa, 0xfc, 0xff, 0x82, 0x00,  //+@@@@%. 
  0x42, 0xff, 0x3e, 0x82, 0xff, 0x5a, 0x00,  //+@.%@+. 
  0x42, 0xff, 0x16, 0x00, 0x9a, 0xf2, 0x24,  //+@..%@. 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 


  /*Unicode: U+0053 (S) , Width: 6 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x64, 0xe4, 0xf4, 0xb4, 0x1c,  //.+@@%. 
  0x00, 0xf4, 0x80, 0x3a, 0x86, 0x08,  //.@%.%. 
  0x00, 0xc8, 0xe0, 0x8e, 0x36, 0x00,  //.@@%.. 
  0x00, 0x08, 0x5e, 0xa8, 0xfa, 0x46,  //..+%@+ 
  0x0c, 0xba, 0x68, 0x34, 0xdc, 0x70,  //.%+.@+ 
  0x02, 0x7c, 0xe2, 0xf4, 0xb4, 0x10,  //.+@@%. 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 


  /*Unicode: U+0054 (T) , Width: 7 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x1a, 0x98, 0xe2, 0xf8, 0xd8, 0x80, 0x0a,  //.%@@@%. 
  0x24, 0xbe, 0x8e, 0xff, 0x7e, 0xbc, 0x0c,  //.%%@+%. 
  0x00, 0x00, 0x42, 0xff, 0x16, 0x00, 0x00,  //..+@... 
  0x00, 0x00, 0x42, 0xff, 0x16, 0x00, 0x00,  //..+@... 
  0x00, 0x00, 0x42, 0xff, 0x16, 0x00, 0x00,  //..+@... 
  0x00, 0x00, 0x42, 0xff, 0x16, 0x00, 0x00,  //..+@... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 


  /*Unicode: U+0055 (U) , Width: 7 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x42, 0xff, 0x16, 0x00, 0x42, 0xff, 0x12,  //+@..+@. 
  0x42, 0xff, 0x16, 0x00, 0x42, 0xff, 0x12,  //+@..+@. 
  0x42, 0xff, 0x16, 0x00, 0x42, 0xff, 0x12,  //+@..+@. 
  0x40, 0xff, 0x1c, 0x00, 0x4e, 0xff, 0x12,  //+@..+@. 
  0x14, 0xf8, 0x8a, 0x38, 0xc4, 0xff, 0x12,  //.@%.@@. 
  0x00, 0x54, 0xe0, 0xf2, 0xc2, 0xff, 0x12,  //.+@@@@. 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 


  /*Unicode: U+0056 (V) , Width: 7 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0xd0, 0xb4, 0x00, 0x00, 0x80, 0xf2, 0x0c,  //@%..%@. 
  0x64, 0xfc, 0x20, 0x04, 0xe6, 0x94, 0x00,  //+@..@%. 
  0x08, 0xee, 0x8a, 0x5a, 0xff, 0x28, 0x00,  //.@%+@.. 
  0x00, 0x8c, 0xec, 0xca, 0xbc, 0x00, 0x00,  //.%@@%.. 
  0x00, 0x22, 0xfc, 0xff, 0x50, 0x00, 0x00,  //..@@+.. 
  0x00, 0x00, 0xb4, 0xe0, 0x02, 0x00, 0x00,  //..%@... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 


  /*Unicode: U+0057 (W) , Width: 9 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //......... 
  0x42, 0xff, 0x16, 0x42, 0xff, 0x12, 0x42, 0xff, 0x12,  //+@.+@.+@. 
  0x42, 0xff, 0x16, 0x42, 0xff, 0x12, 0x42, 0xff, 0x12,  //+@.+@.+@. 
  0x42, 0xff, 0x16, 0x42, 0xff, 0x12, 0x42, 0xff, 0x12,  //+@.+@.+@. 
  0x42, 0xff, 0x18, 0x44, 0xff, 0x14, 0x44, 0xff, 0x10,  //+@.+@.+@. 
  0x24, 0xff, 0x8c, 0xaa, 0xff, 0x8c, 0xa8, 0xf0, 0x02,  //.@%%@%%@. 
  0x00, 0x86, 0xf4, 0xd6, 0x6c, 0xe6, 0xec, 0x5e, 0x00,  //.%@@+@@+. 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //......... 


  /*Unicode: U+0058 (X) , Width: 7 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x6c, 0xfc, 0x40, 0x16, 0xec, 0xa8, 0x00,  //+@+.@%. 
  0x00, 0xbe, 0xde, 0xb6, 0xe6, 0x12, 0x00,  //.%@%@.. 
  0x00, 0x20, 0xf2, 0xff, 0x50, 0x00, 0x00,  //..@@+.. 
  0x00, 0x34, 0xfa, 0xff, 0x74, 0x00, 0x00,  //..@@+.. 
  0x08, 0xd6, 0xc6, 0x94, 0xf6, 0x2a, 0x00,  //.@@%@.. 
  0x8e, 0xf4, 0x26, 0x08, 0xd8, 0xcc, 0x04,  //%@..@@. 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 


  /*Unicode: U+0059 (Y) , Width: 7 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x42, 0xff, 0x16, 0x00, 0x42, 0xff, 0x12,  //+@..+@. 
  0x42, 0xff, 0x16, 0x00, 0x42, 0xff, 0x12,  //+@..+@. 
  0x40, 0xff, 0x1c, 0x00, 0x46, 0xff, 0x12,  //+@..+@. 
  0x1a, 0xfc, 0x78, 0x10, 0xa4, 0xff, 0x12,  //.@+.%@. 
  0x00, 0x80, 0xfc, 0xff, 0xea, 0xff, 0x0c,  //.%@@@@. 
  0x14, 0x84, 0x44, 0x30, 0x86, 0xd4, 0x00,  //.%+.%@. 
  0x02, 0xa2, 0xfc, 0xff, 0xe2, 0x34, 0x00,  //.%@@@.. 
  0x00, 0x00, 0x10, 0x24, 0x02, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 


  /*Unicode: U+005a (Z) , Width: 5 */
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0xff, 0xff, 0xff, 0xff, 0xff,  //@@@@@ 
  0x2a, 0x2a, 0x8e, 0xf0, 0x52,  //..%@+ 
  0xc2, 0xfa, 0xff, 0xfc, 0x8c,  //@@@@% 
  0x34, 0xf4, 0xae, 0x2a, 0x16,  //.@%.. 
  0xa0, 0xf6, 0x40, 0x2a, 0x2a,  //%@+.. 
  0xff, 0xff, 0xff, 0xff, 0xff,  //@@@@@ 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 


  /*Unicode: U+005b ([) , Width: 4 */
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x42, 0xff, 0xff, 0x3e,  //+@@. 
  0x42, 0xff, 0x3e, 0x0a,  //+@.. 
  0x42, 0xff, 0x16, 0x00,  //+@.. 
  0x42, 0xff, 0x16, 0x00,  //+@.. 
  0x42, 0xff, 0x16, 0x00,  //+@.. 
  0x42, 0xff, 0x16, 0x00,  //+@.. 
  0x42, 0xff, 0x16, 0x00,  //+@.. 
  0x42, 0xff, 0xfa, 0x3e,  //+@@. 
  0x0a, 0x2a, 0x2a, 0x0a,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 


  /*Unicode: U+005c (\) , Width: 5 */
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x82, 0xd4, 0x00, 0x00, 0x00,  //%@... 
  0x14, 0xf4, 0x4e, 0x00, 0x00,  //.@+.. 
  0x00, 0x92, 0xc6, 0x00, 0x00,  //.%@.. 
  0x00, 0x1e, 0xfa, 0x3e, 0x00,  //..@.. 
  0x00, 0x00, 0xa2, 0xb6, 0x00,  //..%%. 
  0x00, 0x00, 0x2c, 0xfc, 0x2e,  //...@. 
  0x00, 0x00, 0x00, 0xb2, 0xa6,  //...%% 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 


  /*Unicode: U+005d (]) , Width: 4 */
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x6a, 0xff, 0xff, 0x16,  //+@@. 
  0x10, 0x62, 0xff, 0x16,  //.+@. 
  0x00, 0x42, 0xff, 0x16,  //.+@. 
  0x00, 0x42, 0xff, 0x16,  //.+@. 
  0x00, 0x42, 0xff, 0x16,  //.+@. 
  0x00, 0x42, 0xff, 0x16,  //.+@. 
  0x00, 0x42, 0xff, 0x16,  //.+@. 
  0x68, 0xfc, 0xff, 0x16,  //+@@. 
  0x10, 0x2a, 0x2a, 0x02,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 


  /*Unicode: U+005e (^) , Width: 4 */
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x2c, 0xdc, 0xd8, 0x70,  //.@@+ 
  0x1e, 0x18, 0x08, 0x2a,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 


  /*Unicode: U+005f (_) , Width: 6 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x62, 0xff, 0xff, 0xff, 0xff, 0xde,  //+@@@@@ 
  0x10, 0x2a, 0x2a, 0x2a, 0x2a, 0x24,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 


  /*Unicode: U+0060 (`) , Width: 3 */
  0x12, 0x72, 0x0c,  //.+. 
  0x1a, 0xca, 0xa0,  //.@% 
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 


  /*Unicode: U+0061 (a) , Width: 7 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x46, 0xd8, 0xf6, 0xcc, 0xff, 0x12,  //.+@@@@. 
  0x14, 0xf4, 0x9e, 0x36, 0xba, 0xff, 0x12,  //.@%.%@. 
  0x3c, 0xff, 0x22, 0x00, 0x4e, 0xff, 0x12,  //.@..+@. 
  0x12, 0xf4, 0x9a, 0x36, 0xb6, 0xff, 0x12,  //.@%.%@. 
  0x00, 0x4a, 0xda, 0xf4, 0xce, 0xff, 0x12,  //.+@@@@. 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 


  /*Unicode: U+0062 (b) , Width: 7 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x42, 0xff, 0x16, 0x00, 0x00, 0x00, 0x00,  //+@..... 
  0x42, 0xff, 0x16, 0x00, 0x00, 0x00, 0x00,  //+@..... 
  0x42, 0xff, 0xb4, 0xf6, 0xd2, 0x32, 0x00,  //+@%@@.. 
  0x42, 0xff, 0x9a, 0x38, 0xbe, 0xde, 0x00,  //+@%.%@. 
  0x42, 0xff, 0x22, 0x00, 0x4e, 0xff, 0x0c,  //+@..+@. 
  0x42, 0xff, 0x96, 0x36, 0xba, 0xd4, 0x00,  //+@%.%@. 
  0x42, 0xff, 0xac, 0xf6, 0xce, 0x2a, 0x00,  //+@%@@.. 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 


  /*Unicode: U+0063 (c) , Width: 6 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x46, 0xd8, 0xf6, 0xb2, 0x14,  //.+@@%. 
  0x12, 0xf4, 0x96, 0x36, 0x80, 0x06,  //.@%.%. 
  0x3c, 0xff, 0x20, 0x00, 0x00, 0x00,  //.@.... 
  0x14, 0xf6, 0x94, 0x36, 0x96, 0x10,  //.@%.%. 
  0x00, 0x4c, 0xda, 0xf6, 0xae, 0x14,  //.+@@%. 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 


  /*Unicode: U+0064 (d) , Width: 7 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x42, 0xff, 0x12,  //....+@. 
  0x00, 0x00, 0x00, 0x00, 0x42, 0xff, 0x12,  //....+@. 
  0x00, 0x52, 0xe0, 0xf2, 0xba, 0xff, 0x12,  //.+@@%@. 
  0x16, 0xf8, 0x9c, 0x38, 0xbc, 0xff, 0x12,  //.@%.%@. 
  0x3c, 0xff, 0x22, 0x00, 0x4e, 0xff, 0x12,  //.@..+@. 
  0x10, 0xf2, 0x9a, 0x36, 0xb8, 0xff, 0x12,  //.@%.%@. 
  0x00, 0x48, 0xde, 0xf2, 0xb4, 0xff, 0x12,  //.+@@%@. 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 


  /*Unicode: U+0065 (e) , Width: 6 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x46, 0xd8, 0xf8, 0xbe, 0x1e,  //.+@@%. 
  0x14, 0xf4, 0x8e, 0x42, 0xea, 0xa2,  //.@%+@% 
  0x3c, 0xff, 0xaa, 0xea, 0xa2, 0x34,  //.@%@%. 
  0x12, 0xf6, 0xd4, 0x46, 0x92, 0x26,  //.@@+%. 
  0x00, 0x4e, 0xdc, 0xf8, 0xb4, 0x1a,  //.+@@%. 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 


  /*Unicode: U+0066 (f) , Width: 4 */
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x04, 0xaa, 0xf4, 0xac,  //.%@% 
  0x3c, 0xff, 0x50, 0x2c,  //.@+. 
  0x42, 0xff, 0xfa, 0x40,  //+@@+ 
  0x42, 0xff, 0x3e, 0x0a,  //+@.. 
  0x42, 0xff, 0x16, 0x00,  //+@.. 
  0x42, 0xff, 0x16, 0x00,  //+@.. 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 


  /*Unicode: U+0067 (g) , Width: 6 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x76, 0xf4, 0xce, 0xff, 0x12,  //.+@@@. 
  0x1a, 0xfc, 0x78, 0x9e, 0xff, 0x12,  //.@+%@. 
  0x3e, 0xff, 0x1c, 0x4a, 0xff, 0x12,  //.@.+@. 
  0x1a, 0xfc, 0x76, 0x9c, 0xff, 0x12,  //.@+%@. 
  0x00, 0x76, 0xf4, 0xd2, 0xff, 0x0c,  //.+@@@. 
  0x08, 0xcc, 0x62, 0x8e, 0xda, 0x00,  //.@+%@. 
  0x00, 0x6c, 0xec, 0xe2, 0x40, 0x00,  //.+@@+. 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 


  /*Unicode: U+0068 (h) , Width: 6 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x42, 0xff, 0x16, 0x00, 0x00, 0x00,  //+@.... 
  0x42, 0xff, 0x16, 0x00, 0x00, 0x00,  //+@.... 
  0x42, 0xff, 0xbc, 0xf4, 0x76, 0x00,  //+@%@+. 
  0x42, 0xff, 0x76, 0x8a, 0xf8, 0x06,  //+@+%@. 
  0x42, 0xff, 0x18, 0x44, 0xff, 0x12,  //+@.+@. 
  0x42, 0xff, 0x16, 0x42, 0xff, 0x12,  //+@.+@. 
  0x42, 0xff, 0x16, 0x42, 0xff, 0x12,  //+@.+@. 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 


  /*Unicode: U+0069 (i) , Width: 3 */
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 
  0x28, 0xe8, 0x06,  //.@. 
  0x00, 0x18, 0x00,  //... 
  0x42, 0xff, 0x16,  //+@. 
  0x42, 0xff, 0x16,  //+@. 
  0x42, 0xff, 0x16,  //+@. 
  0x42, 0xff, 0x16,  //+@. 
  0x42, 0xff, 0x16,  //+@. 
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 


  /*Unicode: U+006a (j) , Width: 3 */
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 
  0x28, 0xea, 0x06,  //.@. 
  0x00, 0x1a, 0x00,  //... 
  0x42, 0xff, 0x16,  //+@. 
  0x42, 0xff, 0x16,  //+@. 
  0x42, 0xff, 0x16,  //+@. 
  0x42, 0xff, 0x16,  //+@. 
  0x42, 0xff, 0x16,  //+@. 
  0x88, 0xff, 0x0a,  //%@. 
  0xf4, 0x86, 0x00,  //@%. 
  0x00, 0x00, 0x00,  //... 


  /*Unicode: U+006b (k) , Width: 6 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x42, 0xff, 0x16, 0x00, 0x00, 0x00,  //+@.... 
  0x42, 0xff, 0x16, 0x00, 0x00, 0x00,  //+@.... 
  0x42, 0xff, 0x24, 0xcc, 0xc8, 0x0a,  //+@.@@. 
  0x42, 0xff, 0xcc, 0xd6, 0x12, 0x00,  //+@@@.. 
  0x42, 0xff, 0xff, 0xc0, 0x00, 0x00,  //+@@@.. 
  0x42, 0xff, 0x70, 0xfa, 0x66, 0x00,  //+@+@+. 
  0x42, 0xff, 0x16, 0x8c, 0xf0, 0x1a,  //+@.%@. 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 


  /*Unicode: U+006c (l) , Width: 4 */
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x42, 0xff, 0x16, 0x00,  //+@.. 
  0x42, 0xff, 0x16, 0x00,  //+@.. 
  0x42, 0xff, 0x16, 0x00,  //+@.. 
  0x42, 0xff, 0x16, 0x00,  //+@.. 
  0x3a, 0xff, 0x5a, 0x28,  //.@+. 
  0x04, 0xb2, 0xf4, 0x6e,  //.%@+ 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 


  /*Unicode: U+006d (m) , Width: 9 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //......... 
  0x42, 0xff, 0xc2, 0xf0, 0x6c, 0xc4, 0xf4, 0x7a, 0x00,  //+@@@+@@+. 
  0x42, 0xff, 0x78, 0x86, 0xff, 0x72, 0x8a, 0xfa, 0x06,  //+@+%@+%@. 
  0x42, 0xff, 0x18, 0x44, 0xff, 0x14, 0x44, 0xff, 0x12,  //+@.+@.+@. 
  0x42, 0xff, 0x16, 0x42, 0xff, 0x12, 0x42, 0xff, 0x12,  //+@.+@.+@. 
  0x42, 0xff, 0x16, 0x42, 0xff, 0x12, 0x42, 0xff, 0x12,  //+@.+@.+@. 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //......... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //......... 


  /*Unicode: U+006e (n) , Width: 6 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x42, 0xff, 0xba, 0xf4, 0x76, 0x00,  //+@%@+. 
  0x42, 0xff, 0x74, 0x88, 0xf8, 0x06,  //+@+%@. 
  0x42, 0xff, 0x18, 0x42, 0xff, 0x12,  //+@.+@. 
  0x42, 0xff, 0x16, 0x42, 0xff, 0x12,  //+@.+@. 
  0x42, 0xff, 0x16, 0x42, 0xff, 0x12,  //+@.+@. 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 


  /*Unicode: U+006f (o) , Width: 7 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x44, 0xd6, 0xf8, 0xc2, 0x24, 0x00,  //.+@@@.. 
  0x12, 0xf2, 0x96, 0x36, 0xb8, 0xd4, 0x00,  //.@%.%@. 
  0x3c, 0xff, 0x20, 0x00, 0x4e, 0xff, 0x0c,  //.@..+@. 
  0x12, 0xf2, 0x96, 0x36, 0xb8, 0xd4, 0x00,  //.@%.%@. 
  0x00, 0x46, 0xd8, 0xf8, 0xc4, 0x26, 0x00,  //.+@@@.. 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 


  /*Unicode: U+0070 (p) , Width: 7 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x42, 0xff, 0xb6, 0xf6, 0xd0, 0x2c, 0x00,  //+@%@@.. 
  0x42, 0xff, 0x9a, 0x38, 0xbe, 0xd8, 0x00,  //+@%.%@. 
  0x42, 0xff, 0x22, 0x00, 0x4e, 0xff, 0x0c,  //+@..+@. 
  0x42, 0xff, 0x96, 0x36, 0xba, 0xd6, 0x00,  //+@%.%@. 
  0x42, 0xff, 0xac, 0xf6, 0xce, 0x2c, 0x00,  //+@%@@.. 
  0x42, 0xff, 0x16, 0x00, 0x00, 0x00, 0x00,  //+@..... 
  0x42, 0xff, 0x16, 0x00, 0x00, 0x00, 0x00,  //+@..... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 


  /*Unicode: U+0071 (q) , Width: 7 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 
  0x00, 0x4a, 0xde, 0xf0, 0xb6, 0xff, 0x12,  //.+@@%@. 
  0x12, 0xf4, 0x9c, 0x38, 0xbc, 0xff, 0x12,  //.@%.%@. 
  0x3c, 0xff, 0x22, 0x00, 0x4e, 0xff, 0x12,  //.@..+@. 
  0x12, 0xf4, 0x9a, 0x36, 0xb8, 0xff, 0x12,  //.@%.%@. 
  0x00, 0x4a, 0xda, 0xf4, 0xca, 0xff, 0x12,  //.+@@@@. 
  0x00, 0x00, 0x00, 0x00, 0x42, 0xff, 0x12,  //....+@. 
  0x00, 0x00, 0x00, 0x00, 0x42, 0xff, 0x12,  //....+@. 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //....... 


  /*Unicode: U+0072 (r) , Width: 4 */
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x42, 0xff, 0xb4, 0x86,  //+@%% 
  0x42, 0xff, 0x96, 0x1a,  //+@%. 
  0x42, 0xff, 0x20, 0x00,  //+@.. 
  0x42, 0xff, 0x16, 0x00,  //+@.. 
  0x42, 0xff, 0x16, 0x00,  //+@.. 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 


  /*Unicode: U+0073 (s) , Width: 5 */
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x80, 0xf2, 0xd8, 0x2c,  //.%@@. 
  0x00, 0xf4, 0x62, 0x5c, 0x0c,  //.@++. 
  0x00, 0x5e, 0xda, 0xc0, 0x20,  //.+@@. 
  0x06, 0x7e, 0x36, 0xc2, 0x74,  //.+.@+ 
  0x10, 0xaa, 0xf4, 0xd2, 0x22,  //.%@@. 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 


  /*Unicode: U+0074 (t) , Width: 4 */
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x42, 0xff, 0x16, 0x00,  //+@.. 
  0x42, 0xff, 0xff, 0x42,  //+@@+ 
  0x42, 0xff, 0x3e, 0x0a,  //+@.. 
  0x42, 0xff, 0x16, 0x00,  //+@.. 
  0x3a, 0xff, 0x5a, 0x2a,  //.@+. 
  0x04, 0xb2, 0xf4, 0x6e,  //.%@+ 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 


  /*Unicode: U+0075 (u) , Width: 6 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x42, 0xff, 0x16, 0x42, 0xff, 0x12,  //+@.+@. 
  0x42, 0xff, 0x16, 0x42, 0xff, 0x12,  //+@.+@. 
  0x42, 0xff, 0x16, 0x44, 0xff, 0x12,  //+@.+@. 
  0x32, 0xff, 0x58, 0x8e, 0xff, 0x12,  //.@+%@. 
  0x00, 0xa4, 0xf6, 0xc4, 0xff, 0x12,  //.%@@@. 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 


  /*Unicode: U+0076 (v) , Width: 6 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0xc6, 0xa0, 0x00, 0x58, 0xf8, 0x12,  //@%.+@. 
  0x64, 0xf4, 0x0c, 0xba, 0xaa, 0x00,  //+@.%%. 
  0x0c, 0xf4, 0x82, 0xfc, 0x48, 0x00,  //.@%@+. 
  0x00, 0xa2, 0xfc, 0xe2, 0x00, 0x00,  //.%@@.. 
  0x00, 0x40, 0xff, 0x84, 0x00, 0x00,  //.+@%.. 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 


  /*Unicode: U+0077 (w) , Width: 8 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //........ 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //........ 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //........ 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //........ 
  0xb8, 0xaa, 0x00, 0xbe, 0xda, 0x00, 0x8e, 0xd4,  //%%.%@.%@ 
  0x64, 0xf2, 0x1a, 0xfa, 0xff, 0x2a, 0xde, 0x80,  //+@.@@.@% 
  0x12, 0xfa, 0xac, 0xf2, 0xde, 0xac, 0xff, 0x2c,  //.@%@@%@. 
  0x00, 0xba, 0xff, 0xa6, 0x88, 0xff, 0xd8, 0x00,  //.%@%%@@. 
  0x00, 0x64, 0xff, 0x50, 0x34, 0xff, 0x84, 0x00,  //.+@+.@%. 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //........ 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //........ 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //........ 


  /*Unicode: U+0078 (x) , Width: 6 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x76, 0xf6, 0x28, 0xcc, 0xba, 0x00,  //+@.@%. 
  0x02, 0xcc, 0xea, 0xf0, 0x1c, 0x00,  //.@@@.. 
  0x00, 0x5a, 0xff, 0x96, 0x00, 0x00,  //.+@%.. 
  0x08, 0xd8, 0xe6, 0xf6, 0x28, 0x00,  //.@@@.. 
  0x8c, 0xea, 0x18, 0xca, 0xc8, 0x02,  //%@.@@. 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 


  /*Unicode: U+0079 (y) , Width: 6 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 
  0x42, 0xff, 0x16, 0x42, 0xff, 0x12,  //+@.+@. 
  0x42, 0xff, 0x16, 0x42, 0xff, 0x12,  //+@.+@. 
  0x38, 0xff, 0x40, 0x6e, 0xff, 0x12,  //.@++@. 
  0x08, 0xd6, 0xff, 0xf4, 0xff, 0x12,  //.@@@@. 
  0x02, 0x4e, 0x28, 0x46, 0xff, 0x0c,  //.+.+@. 
  0x48, 0xf8, 0x4c, 0xa6, 0xd6, 0x00,  //+@+%@. 
  0x00, 0x88, 0xf0, 0xda, 0x36, 0x00,  //.%@@.. 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  //...... 


  /*Unicode: U+007a (z) , Width: 4 */
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0xff, 0xff, 0xff, 0xff,  //@@@@ 
  0x2a, 0x60, 0xfa, 0x9a,  //.+@% 
  0xe6, 0xfc, 0xff, 0xa8,  //@@@% 
  0xc0, 0xee, 0x6a, 0x48,  //@@++ 
  0xff, 0xff, 0xff, 0xff,  //@@@@ 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 


  /*Unicode: U+007b ({) , Width: 3 */
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 
  0x0c, 0xd2, 0xaa,  //.@% 
  0x3e, 0xff, 0x3a,  //.@. 
  0x42, 0xff, 0x16,  //+@. 
  0x46, 0xff, 0x14,  //+@. 
  0xe0, 0xec, 0x00,  //@@. 
  0x62, 0xff, 0x16,  //+@. 
  0x42, 0xff, 0x1c,  //+@. 
  0x24, 0xf8, 0xaa,  //.@% 
  0x00, 0x12, 0x1c,  //... 
  0x00, 0x00, 0x00,  //... 


  /*Unicode: U+007c (|) , Width: 3 */
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 
  0x42, 0xff, 0x16,  //+@. 
  0x42, 0xff, 0x16,  //+@. 
  0x42, 0xff, 0x16,  //+@. 
  0x42, 0xff, 0x16,  //+@. 
  0x42, 0xff, 0x16,  //+@. 
  0x42, 0xff, 0x16,  //+@. 
  0x42, 0xff, 0x16,  //+@. 
  0x42, 0xff, 0x16,  //+@. 
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 


  /*Unicode: U+007d (}) , Width: 3 */
  0x00, 0x00, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 
  0xd8, 0xb6, 0x00,  //@%. 
  0x66, 0xff, 0x12,  //+@. 
  0x42, 0xff, 0x16,  //+@. 
  0x42, 0xff, 0x1c,  //+@. 
  0x1c, 0xfc, 0xb4,  //.@% 
  0x42, 0xff, 0x36,  //+@. 
  0x48, 0xff, 0x16,  //+@. 
  0xda, 0xe8, 0x06,  //@@. 
  0x22, 0x0a, 0x00,  //... 
  0x00, 0x00, 0x00,  //... 


  /*Unicode: U+007e (~) , Width: 5 */
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x52, 0xea, 0x72, 0x7a, 0x62,  //+@+++ 
  0xa6, 0x82, 0xb6, 0xfc, 0x46,  //%%%@+ 
  0x02, 0x0c, 0x00, 0x18, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 
  0x00, 0x00, 0x00, 0x00, 0x00,  //..... 


  /*Unicode: U+007f () , Width: 4 */
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 
  0x00, 0x00, 0x00, 0x00,  //.... 



#endif
};


/*Store the glyph descriptions*/
static const lv_font_glyph_dsc_t mabolt_12_glyph_dsc[] = 
{
#if USE_MABOLT_12 == 1
  {.w_px = 4,	.glyph_index = 0},	/*Unicode: U+0020 ( )*/
  {.w_px = 3,	.glyph_index = 12},	/*Unicode: U+0021 (!)*/
  {.w_px = 4,	.glyph_index = 24},	/*Unicode: U+0022 (")*/
  {.w_px = 7,	.glyph_index = 36},	/*Unicode: U+0023 (#)*/
  {.w_px = 6,	.glyph_index = 48},	/*Unicode: U+0024 ($)*/
  {.w_px = 6,	.glyph_index = 60},	/*Unicode: U+0025 (%)*/
  {.w_px = 7,	.glyph_index = 72},	/*Unicode: U+0026 (&)*/
  {.w_px = 3,	.glyph_index = 84},	/*Unicode: U+0027 (')*/
  {.w_px = 4,	.glyph_index = 96},	/*Unicode: U+0028 (()*/
  {.w_px = 4,	.glyph_index = 108},	/*Unicode: U+0029 ())*/
  {.w_px = 4,	.glyph_index = 120},	/*Unicode: U+002a (*)*/
  {.w_px = 4,	.glyph_index = 132},	/*Unicode: U+002b (+)*/
  {.w_px = 3,	.glyph_index = 144},	/*Unicode: U+002c (,)*/
  {.w_px = 3,	.glyph_index = 156},	/*Unicode: U+002d (-)*/
  {.w_px = 3,	.glyph_index = 168},	/*Unicode: U+002e (.)*/
  {.w_px = 6,	.glyph_index = 180},	/*Unicode: U+002f (/)*/
  {.w_px = 7,	.glyph_index = 192},	/*Unicode: U+0030 (0)*/
  {.w_px = 4,	.glyph_index = 204},	/*Unicode: U+0031 (1)*/
  {.w_px = 5,	.glyph_index = 216},	/*Unicode: U+0032 (2)*/
  {.w_px = 6,	.glyph_index = 228},	/*Unicode: U+0033 (3)*/
  {.w_px = 5,	.glyph_index = 240},	/*Unicode: U+0034 (4)*/
  {.w_px = 6,	.glyph_index = 252},	/*Unicode: U+0035 (5)*/
  {.w_px = 6,	.glyph_index = 264},	/*Unicode: U+0036 (6)*/
  {.w_px = 5,	.glyph_index = 276},	/*Unicode: U+0037 (7)*/
  {.w_px = 6,	.glyph_index = 288},	/*Unicode: U+0038 (8)*/
  {.w_px = 6,	.glyph_index = 300},	/*Unicode: U+0039 (9)*/
  {.w_px = 3,	.glyph_index = 312},	/*Unicode: U+003a (:)*/
  {.w_px = 3,	.glyph_index = 324},	/*Unicode: U+003b (;)*/
  {.w_px = 5,	.glyph_index = 336},	/*Unicode: U+003c (<)*/
  {.w_px = 4,	.glyph_index = 348},	/*Unicode: U+003d (=)*/
  {.w_px = 5,	.glyph_index = 360},	/*Unicode: U+003e (>)*/
  {.w_px = 5,	.glyph_index = 372},	/*Unicode: U+003f (?)*/
  {.w_px = 9,	.glyph_index = 384},	/*Unicode: U+0040 (@)*/
  {.w_px = 7,	.glyph_index = 408},	/*Unicode: U+0041 (A)*/
  {.w_px = 7,	.glyph_index = 420},	/*Unicode: U+0042 (B)*/
  {.w_px = 7,	.glyph_index = 432},	/*Unicode: U+0043 (C)*/
  {.w_px = 7,	.glyph_index = 444},	/*Unicode: U+0044 (D)*/
  {.w_px = 5,	.glyph_index = 456},	/*Unicode: U+0045 (E)*/
  {.w_px = 6,	.glyph_index = 468},	/*Unicode: U+0046 (F)*/
  {.w_px = 8,	.glyph_index = 480},	/*Unicode: U+0047 (G)*/
  {.w_px = 7,	.glyph_index = 492},	/*Unicode: U+0048 (H)*/
  {.w_px = 4,	.glyph_index = 504},	/*Unicode: U+0049 (I)*/
  {.w_px = 5,	.glyph_index = 516},	/*Unicode: U+004a (J)*/
  {.w_px = 7,	.glyph_index = 528},	/*Unicode: U+004b (K)*/
  {.w_px = 5,	.glyph_index = 540},	/*Unicode: U+004c (L)*/
  {.w_px = 9,	.glyph_index = 552},	/*Unicode: U+004d (M)*/
  {.w_px = 7,	.glyph_index = 576},	/*Unicode: U+004e (N)*/
  {.w_px = 8,	.glyph_index = 588},	/*Unicode: U+004f (O)*/
  {.w_px = 7,	.glyph_index = 600},	/*Unicode: U+0050 (P)*/
  {.w_px = 9,	.glyph_index = 612},	/*Unicode: U+0051 (Q)*/
  {.w_px = 7,	.glyph_index = 636},	/*Unicode: U+0052 (R)*/
  {.w_px = 6,	.glyph_index = 648},	/*Unicode: U+0053 (S)*/
  {.w_px = 7,	.glyph_index = 660},	/*Unicode: U+0054 (T)*/
  {.w_px = 7,	.glyph_index = 672},	/*Unicode: U+0055 (U)*/
  {.w_px = 7,	.glyph_index = 684},	/*Unicode: U+0056 (V)*/
  {.w_px = 9,	.glyph_index = 696},	/*Unicode: U+0057 (W)*/
  {.w_px = 7,	.glyph_index = 720},	/*Unicode: U+0058 (X)*/
  {.w_px = 7,	.glyph_index = 732},	/*Unicode: U+0059 (Y)*/
  {.w_px = 5,	.glyph_index = 744},	/*Unicode: U+005a (Z)*/
  {.w_px = 4,	.glyph_index = 756},	/*Unicode: U+005b ([)*/
  {.w_px = 5,	.glyph_index = 768},	/*Unicode: U+005c (\)*/
  {.w_px = 4,	.glyph_index = 780},	/*Unicode: U+005d (])*/
  {.w_px = 4,	.glyph_index = 792},	/*Unicode: U+005e (^)*/
  {.w_px = 6,	.glyph_index = 804},	/*Unicode: U+005f (_)*/
  {.w_px = 3,	.glyph_index = 816},	/*Unicode: U+0060 (`)*/
  {.w_px = 7,	.glyph_index = 828},	/*Unicode: U+0061 (a)*/
  {.w_px = 7,	.glyph_index = 840},	/*Unicode: U+0062 (b)*/
  {.w_px = 6,	.glyph_index = 852},	/*Unicode: U+0063 (c)*/
  {.w_px = 7,	.glyph_index = 864},	/*Unicode: U+0064 (d)*/
  {.w_px = 6,	.glyph_index = 876},	/*Unicode: U+0065 (e)*/
  {.w_px = 4,	.glyph_index = 888},	/*Unicode: U+0066 (f)*/
  {.w_px = 6,	.glyph_index = 900},	/*Unicode: U+0067 (g)*/
  {.w_px = 6,	.glyph_index = 912},	/*Unicode: U+0068 (h)*/
  {.w_px = 3,	.glyph_index = 924},	/*Unicode: U+0069 (i)*/
  {.w_px = 3,	.glyph_index = 936},	/*Unicode: U+006a (j)*/
  {.w_px = 6,	.glyph_index = 948},	/*Unicode: U+006b (k)*/
  {.w_px = 4,	.glyph_index = 960},	/*Unicode: U+006c (l)*/
  {.w_px = 9,	.glyph_index = 972},	/*Unicode: U+006d (m)*/
  {.w_px = 6,	.glyph_index = 996},	/*Unicode: U+006e (n)*/
  {.w_px = 7,	.glyph_index = 1008},	/*Unicode: U+006f (o)*/
  {.w_px = 7,	.glyph_index = 1020},	/*Unicode: U+0070 (p)*/
  {.w_px = 7,	.glyph_index = 1032},	/*Unicode: U+0071 (q)*/
  {.w_px = 4,	.glyph_index = 1044},	/*Unicode: U+0072 (r)*/
  {.w_px = 5,	.glyph_index = 1056},	/*Unicode: U+0073 (s)*/
  {.w_px = 4,	.glyph_index = 1068},	/*Unicode: U+0074 (t)*/
  {.w_px = 6,	.glyph_index = 1080},	/*Unicode: U+0075 (u)*/
  {.w_px = 6,	.glyph_index = 1092},	/*Unicode: U+0076 (v)*/
  {.w_px = 8,	.glyph_index = 1104},	/*Unicode: U+0077 (w)*/
  {.w_px = 6,	.glyph_index = 1116},	/*Unicode: U+0078 (x)*/
  {.w_px = 6,	.glyph_index = 1128},	/*Unicode: U+0079 (y)*/
  {.w_px = 4,	.glyph_index = 1140},	/*Unicode: U+007a (z)*/
  {.w_px = 3,	.glyph_index = 1152},	/*Unicode: U+007b ({)*/
  {.w_px = 3,	.glyph_index = 1164},	/*Unicode: U+007c (|)*/
  {.w_px = 3,	.glyph_index = 1176},	/*Unicode: U+007d (})*/
  {.w_px = 5,	.glyph_index = 1188},	/*Unicode: U+007e (~)*/
  {.w_px = 4,	.glyph_index = 1200},	/*Unicode: U+007f ()*/

#elif USE_MABOLT_12 == 2
  {.w_px = 4,	.glyph_index = 0},	/*Unicode: U+0020 ( )*/
  {.w_px = 3,	.glyph_index = 12},	/*Unicode: U+0021 (!)*/
  {.w_px = 4,	.glyph_index = 24},	/*Unicode: U+0022 (")*/
  {.w_px = 7,	.glyph_index = 36},	/*Unicode: U+0023 (#)*/
  {.w_px = 6,	.glyph_index = 60},	/*Unicode: U+0024 ($)*/
  {.w_px = 6,	.glyph_index = 84},	/*Unicode: U+0025 (%)*/
  {.w_px = 7,	.glyph_index = 108},	/*Unicode: U+0026 (&)*/
  {.w_px = 3,	.glyph_index = 132},	/*Unicode: U+0027 (')*/
  {.w_px = 4,	.glyph_index = 144},	/*Unicode: U+0028 (()*/
  {.w_px = 4,	.glyph_index = 156},	/*Unicode: U+0029 ())*/
  {.w_px = 4,	.glyph_index = 168},	/*Unicode: U+002a (*)*/
  {.w_px = 4,	.glyph_index = 180},	/*Unicode: U+002b (+)*/
  {.w_px = 3,	.glyph_index = 192},	/*Unicode: U+002c (,)*/
  {.w_px = 3,	.glyph_index = 204},	/*Unicode: U+002d (-)*/
  {.w_px = 3,	.glyph_index = 216},	/*Unicode: U+002e (.)*/
  {.w_px = 6,	.glyph_index = 228},	/*Unicode: U+002f (/)*/
  {.w_px = 7,	.glyph_index = 252},	/*Unicode: U+0030 (0)*/
  {.w_px = 4,	.glyph_index = 276},	/*Unicode: U+0031 (1)*/
  {.w_px = 5,	.glyph_index = 288},	/*Unicode: U+0032 (2)*/
  {.w_px = 6,	.glyph_index = 312},	/*Unicode: U+0033 (3)*/
  {.w_px = 5,	.glyph_index = 336},	/*Unicode: U+0034 (4)*/
  {.w_px = 6,	.glyph_index = 360},	/*Unicode: U+0035 (5)*/
  {.w_px = 6,	.glyph_index = 384},	/*Unicode: U+0036 (6)*/
  {.w_px = 5,	.glyph_index = 408},	/*Unicode: U+0037 (7)*/
  {.w_px = 6,	.glyph_index = 432},	/*Unicode: U+0038 (8)*/
  {.w_px = 6,	.glyph_index = 456},	/*Unicode: U+0039 (9)*/
  {.w_px = 3,	.glyph_index = 480},	/*Unicode: U+003a (:)*/
  {.w_px = 3,	.glyph_index = 492},	/*Unicode: U+003b (;)*/
  {.w_px = 5,	.glyph_index = 504},	/*Unicode: U+003c (<)*/
  {.w_px = 4,	.glyph_index = 528},	/*Unicode: U+003d (=)*/
  {.w_px = 5,	.glyph_index = 540},	/*Unicode: U+003e (>)*/
  {.w_px = 5,	.glyph_index = 564},	/*Unicode: U+003f (?)*/
  {.w_px = 9,	.glyph_index = 588},	/*Unicode: U+0040 (@)*/
  {.w_px = 7,	.glyph_index = 624},	/*Unicode: U+0041 (A)*/
  {.w_px = 7,	.glyph_index = 648},	/*Unicode: U+0042 (B)*/
  {.w_px = 7,	.glyph_index = 672},	/*Unicode: U+0043 (C)*/
  {.w_px = 7,	.glyph_index = 696},	/*Unicode: U+0044 (D)*/
  {.w_px = 5,	.glyph_index = 720},	/*Unicode: U+0045 (E)*/
  {.w_px = 6,	.glyph_index = 744},	/*Unicode: U+0046 (F)*/
  {.w_px = 8,	.glyph_index = 768},	/*Unicode: U+0047 (G)*/
  {.w_px = 7,	.glyph_index = 792},	/*Unicode: U+0048 (H)*/
  {.w_px = 4,	.glyph_index = 816},	/*Unicode: U+0049 (I)*/
  {.w_px = 5,	.glyph_index = 828},	/*Unicode: U+004a (J)*/
  {.w_px = 7,	.glyph_index = 852},	/*Unicode: U+004b (K)*/
  {.w_px = 5,	.glyph_index = 876},	/*Unicode: U+004c (L)*/
  {.w_px = 9,	.glyph_index = 900},	/*Unicode: U+004d (M)*/
  {.w_px = 7,	.glyph_index = 936},	/*Unicode: U+004e (N)*/
  {.w_px = 8,	.glyph_index = 960},	/*Unicode: U+004f (O)*/
  {.w_px = 7,	.glyph_index = 984},	/*Unicode: U+0050 (P)*/
  {.w_px = 9,	.glyph_index = 1008},	/*Unicode: U+0051 (Q)*/
  {.w_px = 7,	.glyph_index = 1044},	/*Unicode: U+0052 (R)*/
  {.w_px = 6,	.glyph_index = 1068},	/*Unicode: U+0053 (S)*/
  {.w_px = 7,	.glyph_index = 1092},	/*Unicode: U+0054 (T)*/
  {.w_px = 7,	.glyph_index = 1116},	/*Unicode: U+0055 (U)*/
  {.w_px = 7,	.glyph_index = 1140},	/*Unicode: U+0056 (V)*/
  {.w_px = 9,	.glyph_index = 1164},	/*Unicode: U+0057 (W)*/
  {.w_px = 7,	.glyph_index = 1200},	/*Unicode: U+0058 (X)*/
  {.w_px = 7,	.glyph_index = 1224},	/*Unicode: U+0059 (Y)*/
  {.w_px = 5,	.glyph_index = 1248},	/*Unicode: U+005a (Z)*/
  {.w_px = 4,	.glyph_index = 1272},	/*Unicode: U+005b ([)*/
  {.w_px = 5,	.glyph_index = 1284},	/*Unicode: U+005c (\)*/
  {.w_px = 4,	.glyph_index = 1308},	/*Unicode: U+005d (])*/
  {.w_px = 4,	.glyph_index = 1320},	/*Unicode: U+005e (^)*/
  {.w_px = 6,	.glyph_index = 1332},	/*Unicode: U+005f (_)*/
  {.w_px = 3,	.glyph_index = 1356},	/*Unicode: U+0060 (`)*/
  {.w_px = 7,	.glyph_index = 1368},	/*Unicode: U+0061 (a)*/
  {.w_px = 7,	.glyph_index = 1392},	/*Unicode: U+0062 (b)*/
  {.w_px = 6,	.glyph_index = 1416},	/*Unicode: U+0063 (c)*/
  {.w_px = 7,	.glyph_index = 1440},	/*Unicode: U+0064 (d)*/
  {.w_px = 6,	.glyph_index = 1464},	/*Unicode: U+0065 (e)*/
  {.w_px = 4,	.glyph_index = 1488},	/*Unicode: U+0066 (f)*/
  {.w_px = 6,	.glyph_index = 1500},	/*Unicode: U+0067 (g)*/
  {.w_px = 6,	.glyph_index = 1524},	/*Unicode: U+0068 (h)*/
  {.w_px = 3,	.glyph_index = 1548},	/*Unicode: U+0069 (i)*/
  {.w_px = 3,	.glyph_index = 1560},	/*Unicode: U+006a (j)*/
  {.w_px = 6,	.glyph_index = 1572},	/*Unicode: U+006b (k)*/
  {.w_px = 4,	.glyph_index = 1596},	/*Unicode: U+006c (l)*/
  {.w_px = 9,	.glyph_index = 1608},	/*Unicode: U+006d (m)*/
  {.w_px = 6,	.glyph_index = 1644},	/*Unicode: U+006e (n)*/
  {.w_px = 7,	.glyph_index = 1668},	/*Unicode: U+006f (o)*/
  {.w_px = 7,	.glyph_index = 1692},	/*Unicode: U+0070 (p)*/
  {.w_px = 7,	.glyph_index = 1716},	/*Unicode: U+0071 (q)*/
  {.w_px = 4,	.glyph_index = 1740},	/*Unicode: U+0072 (r)*/
  {.w_px = 5,	.glyph_index = 1752},	/*Unicode: U+0073 (s)*/
  {.w_px = 4,	.glyph_index = 1776},	/*Unicode: U+0074 (t)*/
  {.w_px = 6,	.glyph_index = 1788},	/*Unicode: U+0075 (u)*/
  {.w_px = 6,	.glyph_index = 1812},	/*Unicode: U+0076 (v)*/
  {.w_px = 8,	.glyph_index = 1836},	/*Unicode: U+0077 (w)*/
  {.w_px = 6,	.glyph_index = 1860},	/*Unicode: U+0078 (x)*/
  {.w_px = 6,	.glyph_index = 1884},	/*Unicode: U+0079 (y)*/
  {.w_px = 4,	.glyph_index = 1908},	/*Unicode: U+007a (z)*/
  {.w_px = 3,	.glyph_index = 1920},	/*Unicode: U+007b ({)*/
  {.w_px = 3,	.glyph_index = 1932},	/*Unicode: U+007c (|)*/
  {.w_px = 3,	.glyph_index = 1944},	/*Unicode: U+007d (})*/
  {.w_px = 5,	.glyph_index = 1956},	/*Unicode: U+007e (~)*/
  {.w_px = 4,	.glyph_index = 1980},	/*Unicode: U+007f ()*/

#elif USE_MABOLT_12 == 4
  {.w_px = 4,	.glyph_index = 0},	/*Unicode: U+0020 ( )*/
  {.w_px = 3,	.glyph_index = 24},	/*Unicode: U+0021 (!)*/
  {.w_px = 4,	.glyph_index = 48},	/*Unicode: U+0022 (")*/
  {.w_px = 7,	.glyph_index = 72},	/*Unicode: U+0023 (#)*/
  {.w_px = 6,	.glyph_index = 120},	/*Unicode: U+0024 ($)*/
  {.w_px = 6,	.glyph_index = 156},	/*Unicode: U+0025 (%)*/
  {.w_px = 7,	.glyph_index = 192},	/*Unicode: U+0026 (&)*/
  {.w_px = 3,	.glyph_index = 240},	/*Unicode: U+0027 (')*/
  {.w_px = 4,	.glyph_index = 264},	/*Unicode: U+0028 (()*/
  {.w_px = 4,	.glyph_index = 288},	/*Unicode: U+0029 ())*/
  {.w_px = 4,	.glyph_index = 312},	/*Unicode: U+002a (*)*/
  {.w_px = 4,	.glyph_index = 336},	/*Unicode: U+002b (+)*/
  {.w_px = 3,	.glyph_index = 360},	/*Unicode: U+002c (,)*/
  {.w_px = 3,	.glyph_index = 384},	/*Unicode: U+002d (-)*/
  {.w_px = 3,	.glyph_index = 408},	/*Unicode: U+002e (.)*/
  {.w_px = 6,	.glyph_index = 432},	/*Unicode: U+002f (/)*/
  {.w_px = 7,	.glyph_index = 468},	/*Unicode: U+0030 (0)*/
  {.w_px = 4,	.glyph_index = 516},	/*Unicode: U+0031 (1)*/
  {.w_px = 5,	.glyph_index = 540},	/*Unicode: U+0032 (2)*/
  {.w_px = 6,	.glyph_index = 576},	/*Unicode: U+0033 (3)*/
  {.w_px = 5,	.glyph_index = 612},	/*Unicode: U+0034 (4)*/
  {.w_px = 6,	.glyph_index = 648},	/*Unicode: U+0035 (5)*/
  {.w_px = 6,	.glyph_index = 684},	/*Unicode: U+0036 (6)*/
  {.w_px = 5,	.glyph_index = 720},	/*Unicode: U+0037 (7)*/
  {.w_px = 6,	.glyph_index = 756},	/*Unicode: U+0038 (8)*/
  {.w_px = 6,	.glyph_index = 792},	/*Unicode: U+0039 (9)*/
  {.w_px = 3,	.glyph_index = 828},	/*Unicode: U+003a (:)*/
  {.w_px = 3,	.glyph_index = 852},	/*Unicode: U+003b (;)*/
  {.w_px = 5,	.glyph_index = 876},	/*Unicode: U+003c (<)*/
  {.w_px = 4,	.glyph_index = 912},	/*Unicode: U+003d (=)*/
  {.w_px = 5,	.glyph_index = 936},	/*Unicode: U+003e (>)*/
  {.w_px = 5,	.glyph_index = 972},	/*Unicode: U+003f (?)*/
  {.w_px = 9,	.glyph_index = 1008},	/*Unicode: U+0040 (@)*/
  {.w_px = 7,	.glyph_index = 1068},	/*Unicode: U+0041 (A)*/
  {.w_px = 7,	.glyph_index = 1116},	/*Unicode: U+0042 (B)*/
  {.w_px = 7,	.glyph_index = 1164},	/*Unicode: U+0043 (C)*/
  {.w_px = 7,	.glyph_index = 1212},	/*Unicode: U+0044 (D)*/
  {.w_px = 5,	.glyph_index = 1260},	/*Unicode: U+0045 (E)*/
  {.w_px = 6,	.glyph_index = 1296},	/*Unicode: U+0046 (F)*/
  {.w_px = 8,	.glyph_index = 1332},	/*Unicode: U+0047 (G)*/
  {.w_px = 7,	.glyph_index = 1380},	/*Unicode: U+0048 (H)*/
  {.w_px = 4,	.glyph_index = 1428},	/*Unicode: U+0049 (I)*/
  {.w_px = 5,	.glyph_index = 1452},	/*Unicode: U+004a (J)*/
  {.w_px = 7,	.glyph_index = 1488},	/*Unicode: U+004b (K)*/
  {.w_px = 5,	.glyph_index = 1536},	/*Unicode: U+004c (L)*/
  {.w_px = 9,	.glyph_index = 1572},	/*Unicode: U+004d (M)*/
  {.w_px = 7,	.glyph_index = 1632},	/*Unicode: U+004e (N)*/
  {.w_px = 8,	.glyph_index = 1680},	/*Unicode: U+004f (O)*/
  {.w_px = 7,	.glyph_index = 1728},	/*Unicode: U+0050 (P)*/
  {.w_px = 9,	.glyph_index = 1776},	/*Unicode: U+0051 (Q)*/
  {.w_px = 7,	.glyph_index = 1836},	/*Unicode: U+0052 (R)*/
  {.w_px = 6,	.glyph_index = 1884},	/*Unicode: U+0053 (S)*/
  {.w_px = 7,	.glyph_index = 1920},	/*Unicode: U+0054 (T)*/
  {.w_px = 7,	.glyph_index = 1968},	/*Unicode: U+0055 (U)*/
  {.w_px = 7,	.glyph_index = 2016},	/*Unicode: U+0056 (V)*/
  {.w_px = 9,	.glyph_index = 2064},	/*Unicode: U+0057 (W)*/
  {.w_px = 7,	.glyph_index = 2124},	/*Unicode: U+0058 (X)*/
  {.w_px = 7,	.glyph_index = 2172},	/*Unicode: U+0059 (Y)*/
  {.w_px = 5,	.glyph_index = 2220},	/*Unicode: U+005a (Z)*/
  {.w_px = 4,	.glyph_index = 2256},	/*Unicode: U+005b ([)*/
  {.w_px = 5,	.glyph_index = 2280},	/*Unicode: U+005c (\)*/
  {.w_px = 4,	.glyph_index = 2316},	/*Unicode: U+005d (])*/
  {.w_px = 4,	.glyph_index = 2340},	/*Unicode: U+005e (^)*/
  {.w_px = 6,	.glyph_index = 2364},	/*Unicode: U+005f (_)*/
  {.w_px = 3,	.glyph_index = 2400},	/*Unicode: U+0060 (`)*/
  {.w_px = 7,	.glyph_index = 2424},	/*Unicode: U+0061 (a)*/
  {.w_px = 7,	.glyph_index = 2472},	/*Unicode: U+0062 (b)*/
  {.w_px = 6,	.glyph_index = 2520},	/*Unicode: U+0063 (c)*/
  {.w_px = 7,	.glyph_index = 2556},	/*Unicode: U+0064 (d)*/
  {.w_px = 6,	.glyph_index = 2604},	/*Unicode: U+0065 (e)*/
  {.w_px = 4,	.glyph_index = 2640},	/*Unicode: U+0066 (f)*/
  {.w_px = 6,	.glyph_index = 2664},	/*Unicode: U+0067 (g)*/
  {.w_px = 6,	.glyph_index = 2700},	/*Unicode: U+0068 (h)*/
  {.w_px = 3,	.glyph_index = 2736},	/*Unicode: U+0069 (i)*/
  {.w_px = 3,	.glyph_index = 2760},	/*Unicode: U+006a (j)*/
  {.w_px = 6,	.glyph_index = 2784},	/*Unicode: U+006b (k)*/
  {.w_px = 4,	.glyph_index = 2820},	/*Unicode: U+006c (l)*/
  {.w_px = 9,	.glyph_index = 2844},	/*Unicode: U+006d (m)*/
  {.w_px = 6,	.glyph_index = 2904},	/*Unicode: U+006e (n)*/
  {.w_px = 7,	.glyph_index = 2940},	/*Unicode: U+006f (o)*/
  {.w_px = 7,	.glyph_index = 2988},	/*Unicode: U+0070 (p)*/
  {.w_px = 7,	.glyph_index = 3036},	/*Unicode: U+0071 (q)*/
  {.w_px = 4,	.glyph_index = 3084},	/*Unicode: U+0072 (r)*/
  {.w_px = 5,	.glyph_index = 3108},	/*Unicode: U+0073 (s)*/
  {.w_px = 4,	.glyph_index = 3144},	/*Unicode: U+0074 (t)*/
  {.w_px = 6,	.glyph_index = 3168},	/*Unicode: U+0075 (u)*/
  {.w_px = 6,	.glyph_index = 3204},	/*Unicode: U+0076 (v)*/
  {.w_px = 8,	.glyph_index = 3240},	/*Unicode: U+0077 (w)*/
  {.w_px = 6,	.glyph_index = 3288},	/*Unicode: U+0078 (x)*/
  {.w_px = 6,	.glyph_index = 3324},	/*Unicode: U+0079 (y)*/
  {.w_px = 4,	.glyph_index = 3360},	/*Unicode: U+007a (z)*/
  {.w_px = 3,	.glyph_index = 3384},	/*Unicode: U+007b ({)*/
  {.w_px = 3,	.glyph_index = 3408},	/*Unicode: U+007c (|)*/
  {.w_px = 3,	.glyph_index = 3432},	/*Unicode: U+007d (})*/
  {.w_px = 5,	.glyph_index = 3456},	/*Unicode: U+007e (~)*/
  {.w_px = 4,	.glyph_index = 3492},	/*Unicode: U+007f ()*/

#elif USE_MABOLT_12 == 8
  {.w_px = 4,	.glyph_index = 0},	/*Unicode: U+0020 ( )*/
  {.w_px = 3,	.glyph_index = 48},	/*Unicode: U+0021 (!)*/
  {.w_px = 4,	.glyph_index = 84},	/*Unicode: U+0022 (")*/
  {.w_px = 7,	.glyph_index = 132},	/*Unicode: U+0023 (#)*/
  {.w_px = 6,	.glyph_index = 216},	/*Unicode: U+0024 ($)*/
  {.w_px = 6,	.glyph_index = 288},	/*Unicode: U+0025 (%)*/
  {.w_px = 7,	.glyph_index = 360},	/*Unicode: U+0026 (&)*/
  {.w_px = 3,	.glyph_index = 444},	/*Unicode: U+0027 (')*/
  {.w_px = 4,	.glyph_index = 480},	/*Unicode: U+0028 (()*/
  {.w_px = 4,	.glyph_index = 528},	/*Unicode: U+0029 ())*/
  {.w_px = 4,	.glyph_index = 576},	/*Unicode: U+002a (*)*/
  {.w_px = 4,	.glyph_index = 624},	/*Unicode: U+002b (+)*/
  {.w_px = 3,	.glyph_index = 672},	/*Unicode: U+002c (,)*/
  {.w_px = 3,	.glyph_index = 708},	/*Unicode: U+002d (-)*/
  {.w_px = 3,	.glyph_index = 744},	/*Unicode: U+002e (.)*/
  {.w_px = 6,	.glyph_index = 780},	/*Unicode: U+002f (/)*/
  {.w_px = 7,	.glyph_index = 852},	/*Unicode: U+0030 (0)*/
  {.w_px = 4,	.glyph_index = 936},	/*Unicode: U+0031 (1)*/
  {.w_px = 5,	.glyph_index = 984},	/*Unicode: U+0032 (2)*/
  {.w_px = 6,	.glyph_index = 1044},	/*Unicode: U+0033 (3)*/
  {.w_px = 5,	.glyph_index = 1116},	/*Unicode: U+0034 (4)*/
  {.w_px = 6,	.glyph_index = 1176},	/*Unicode: U+0035 (5)*/
  {.w_px = 6,	.glyph_index = 1248},	/*Unicode: U+0036 (6)*/
  {.w_px = 5,	.glyph_index = 1320},	/*Unicode: U+0037 (7)*/
  {.w_px = 6,	.glyph_index = 1380},	/*Unicode: U+0038 (8)*/
  {.w_px = 6,	.glyph_index = 1452},	/*Unicode: U+0039 (9)*/
  {.w_px = 3,	.glyph_index = 1524},	/*Unicode: U+003a (:)*/
  {.w_px = 3,	.glyph_index = 1560},	/*Unicode: U+003b (;)*/
  {.w_px = 5,	.glyph_index = 1596},	/*Unicode: U+003c (<)*/
  {.w_px = 4,	.glyph_index = 1656},	/*Unicode: U+003d (=)*/
  {.w_px = 5,	.glyph_index = 1704},	/*Unicode: U+003e (>)*/
  {.w_px = 5,	.glyph_index = 1764},	/*Unicode: U+003f (?)*/
  {.w_px = 9,	.glyph_index = 1824},	/*Unicode: U+0040 (@)*/
  {.w_px = 7,	.glyph_index = 1932},	/*Unicode: U+0041 (A)*/
  {.w_px = 7,	.glyph_index = 2016},	/*Unicode: U+0042 (B)*/
  {.w_px = 7,	.glyph_index = 2100},	/*Unicode: U+0043 (C)*/
  {.w_px = 7,	.glyph_index = 2184},	/*Unicode: U+0044 (D)*/
  {.w_px = 5,	.glyph_index = 2268},	/*Unicode: U+0045 (E)*/
  {.w_px = 6,	.glyph_index = 2328},	/*Unicode: U+0046 (F)*/
  {.w_px = 8,	.glyph_index = 2400},	/*Unicode: U+0047 (G)*/
  {.w_px = 7,	.glyph_index = 2496},	/*Unicode: U+0048 (H)*/
  {.w_px = 4,	.glyph_index = 2580},	/*Unicode: U+0049 (I)*/
  {.w_px = 5,	.glyph_index = 2628},	/*Unicode: U+004a (J)*/
  {.w_px = 7,	.glyph_index = 2688},	/*Unicode: U+004b (K)*/
  {.w_px = 5,	.glyph_index = 2772},	/*Unicode: U+004c (L)*/
  {.w_px = 9,	.glyph_index = 2832},	/*Unicode: U+004d (M)*/
  {.w_px = 7,	.glyph_index = 2940},	/*Unicode: U+004e (N)*/
  {.w_px = 8,	.glyph_index = 3024},	/*Unicode: U+004f (O)*/
  {.w_px = 7,	.glyph_index = 3120},	/*Unicode: U+0050 (P)*/
  {.w_px = 9,	.glyph_index = 3204},	/*Unicode: U+0051 (Q)*/
  {.w_px = 7,	.glyph_index = 3312},	/*Unicode: U+0052 (R)*/
  {.w_px = 6,	.glyph_index = 3396},	/*Unicode: U+0053 (S)*/
  {.w_px = 7,	.glyph_index = 3468},	/*Unicode: U+0054 (T)*/
  {.w_px = 7,	.glyph_index = 3552},	/*Unicode: U+0055 (U)*/
  {.w_px = 7,	.glyph_index = 3636},	/*Unicode: U+0056 (V)*/
  {.w_px = 9,	.glyph_index = 3720},	/*Unicode: U+0057 (W)*/
  {.w_px = 7,	.glyph_index = 3828},	/*Unicode: U+0058 (X)*/
  {.w_px = 7,	.glyph_index = 3912},	/*Unicode: U+0059 (Y)*/
  {.w_px = 5,	.glyph_index = 3996},	/*Unicode: U+005a (Z)*/
  {.w_px = 4,	.glyph_index = 4056},	/*Unicode: U+005b ([)*/
  {.w_px = 5,	.glyph_index = 4104},	/*Unicode: U+005c (\)*/
  {.w_px = 4,	.glyph_index = 4164},	/*Unicode: U+005d (])*/
  {.w_px = 4,	.glyph_index = 4212},	/*Unicode: U+005e (^)*/
  {.w_px = 6,	.glyph_index = 4260},	/*Unicode: U+005f (_)*/
  {.w_px = 3,	.glyph_index = 4332},	/*Unicode: U+0060 (`)*/
  {.w_px = 7,	.glyph_index = 4368},	/*Unicode: U+0061 (a)*/
  {.w_px = 7,	.glyph_index = 4452},	/*Unicode: U+0062 (b)*/
  {.w_px = 6,	.glyph_index = 4536},	/*Unicode: U+0063 (c)*/
  {.w_px = 7,	.glyph_index = 4608},	/*Unicode: U+0064 (d)*/
  {.w_px = 6,	.glyph_index = 4692},	/*Unicode: U+0065 (e)*/
  {.w_px = 4,	.glyph_index = 4764},	/*Unicode: U+0066 (f)*/
  {.w_px = 6,	.glyph_index = 4812},	/*Unicode: U+0067 (g)*/
  {.w_px = 6,	.glyph_index = 4884},	/*Unicode: U+0068 (h)*/
  {.w_px = 3,	.glyph_index = 4956},	/*Unicode: U+0069 (i)*/
  {.w_px = 3,	.glyph_index = 4992},	/*Unicode: U+006a (j)*/
  {.w_px = 6,	.glyph_index = 5028},	/*Unicode: U+006b (k)*/
  {.w_px = 4,	.glyph_index = 5100},	/*Unicode: U+006c (l)*/
  {.w_px = 9,	.glyph_index = 5148},	/*Unicode: U+006d (m)*/
  {.w_px = 6,	.glyph_index = 5256},	/*Unicode: U+006e (n)*/
  {.w_px = 7,	.glyph_index = 5328},	/*Unicode: U+006f (o)*/
  {.w_px = 7,	.glyph_index = 5412},	/*Unicode: U+0070 (p)*/
  {.w_px = 7,	.glyph_index = 5496},	/*Unicode: U+0071 (q)*/
  {.w_px = 4,	.glyph_index = 5580},	/*Unicode: U+0072 (r)*/
  {.w_px = 5,	.glyph_index = 5628},	/*Unicode: U+0073 (s)*/
  {.w_px = 4,	.glyph_index = 5688},	/*Unicode: U+0074 (t)*/
  {.w_px = 6,	.glyph_index = 5736},	/*Unicode: U+0075 (u)*/
  {.w_px = 6,	.glyph_index = 5808},	/*Unicode: U+0076 (v)*/
  {.w_px = 8,	.glyph_index = 5880},	/*Unicode: U+0077 (w)*/
  {.w_px = 6,	.glyph_index = 5976},	/*Unicode: U+0078 (x)*/
  {.w_px = 6,	.glyph_index = 6048},	/*Unicode: U+0079 (y)*/
  {.w_px = 4,	.glyph_index = 6120},	/*Unicode: U+007a (z)*/
  {.w_px = 3,	.glyph_index = 6168},	/*Unicode: U+007b ({)*/
  {.w_px = 3,	.glyph_index = 6204},	/*Unicode: U+007c (|)*/
  {.w_px = 3,	.glyph_index = 6240},	/*Unicode: U+007d (})*/
  {.w_px = 5,	.glyph_index = 6276},	/*Unicode: U+007e (~)*/
  {.w_px = 4,	.glyph_index = 6336},	/*Unicode: U+007f ()*/

#endif
};

lv_font_t mabolt_12 = 
{
    .unicode_first = 32,	/*First Unicode letter in this font*/
    .unicode_last = 127,	/*Last Unicode letter in this font*/
    .h_px = 12,				/*Font height in pixels*/
    .glyph_bitmap = mabolt_12_glyph_bitmap,	/*Bitmap of glyphs*/
    .glyph_dsc = mabolt_12_glyph_dsc,		/*Description of glyphs*/
    .glyph_cnt = 96,			/*Number of glyphs in the font*/
    .unicode_list = NULL,	/*Every character in the font from 'unicode_first' to 'unicode_last'*/
    .get_bitmap = lv_font_get_bitmap_continuous,	/*Function pointer to get glyph's bitmap*/
    .get_width = lv_font_get_width_continuous,	/*Function pointer to get glyph's width*/
#if USE_MABOLT_12 == 1
    .bpp = 1,				/*Bit per pixel*/
 #elif USE_MABOLT_12 == 2
    .bpp = 2,				/*Bit per pixel*/
 #elif USE_MABOLT_12 == 4
    .bpp = 4,				/*Bit per pixel*/
 #elif USE_MABOLT_12 == 8
    .bpp = 8,				/*Bit per pixel*/
#endif
    .monospace = 0,				/*Fix width (0: if not used)*/
    .next_page = NULL,		/*Pointer to a font extension*/
};

#endif /*USE_MABOLT_12*/

